package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.upb.javaast.methodast.IdentifierNode;
import java.util.regex.Pattern;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.upb.javaast.methodast.MethodCallNode;
import de.upb.javaast.methodast.PrimaryExpressionNode;

public class AssignmentToContainerEngine
extends GFRNEngine
{
   private  AssignmentToContainerEngine()
   {
   }

   private static AssignmentToContainerEngine theAssignmentToContainerEngine;

   public static AssignmentToContainerEngine get()
   {
      if (theAssignmentToContainerEngine == null)
      {
         theAssignmentToContainerEngine = new AssignmentToContainerEngine ();
      }
      return theAssignmentToContainerEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation assignmentToContainer = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         assignmentToContainer = this.annotateUsingFieldRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( assignmentToContainer != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (assignmentToContainer) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            assignmentToContainer = this.annotateUsingMethodRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( assignmentToContainer != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (assignmentToContainer) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               assignmentToContainer = this.annotateUsingParamRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            return (assignmentToContainer) ;
         }
      }
   }


   private GFRNAnnotation annotateUsingFieldRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterMethodCallToId2 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode3 = null ;
      ASTRootNode root = null ;
      AssignmentToContainerAnnotation assignmentToContainer = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAttribAnnotationsAssignmentToContainer = null ;
      Iterator fujaba__IterUMLClass1MethodsUMLMethod2 = null ;
      Iterator fujaba__IterUMLMethod2ParamParam = null ;
      IdentifierNode addTo = null ;
      IdentifierNode id1 = null ;
      de.upb.javaast.methodast.IdentifierNode id2 = null ;
      MethodCallNode methodCall = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode3 = null ;
      UMLAttr attrib = null ;
      UMLClass uMLClass1 = null ;
      UMLMethod uMLMethod2 = null ;
      UMLParam param = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attrib = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass1: UMLClass
            uMLClass1 = attrib.getParent () ;
            JavaSDM.ensure ( uMLClass1 != null ) ;
             
            // bind uMLMethod2: UMLMethod
            fujaba__IterUMLClass1MethodsUMLMethod2 = uMLClass1.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass1MethodsUMLMethod2.hasNext () )
            {
               try
               {
                  uMLMethod2 = (UMLMethod) fujaba__IterUMLClass1MethodsUMLMethod2.next () ;
                   
                  // bind root: ASTRootNode
                  root = uMLMethod2.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // bind param: UMLParam
                  fujaba__IterUMLMethod2ParamParam = uMLMethod2.iteratorOfParam () ;
                  while ( fujaba__IterUMLMethod2ParamParam.hasNext () )
                  {
                     try
                     {
                        param = (UMLParam) fujaba__IterUMLMethod2ParamParam.next () ;
                         
                        // Path search between ASTRootNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode3 : PrimaryExpressionNode
                        fujaba__IterRootToPrimaryExpressionNode3 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterRootToPrimaryExpressionNode3.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode3 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode3.next () ;
                               
                              // bind id1: IdentifierNode
                              id1 = primaryExpressionNode3.getIdentifier () ;
                              JavaSDM.ensure ( id1 != null ) ;
                               
                              // check To-One-Link 'umlDeclaration' between id1 and attrib
                              JavaSDM.ensure ( (id1.getUmlDeclaration () != null) && id1.getUmlDeclaration ().equals (attrib) ) ;
                               
                              // bind methodCall: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode3.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCall = (MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode3.equals (methodCall)) ) ;
                               
                              // bind addTo: IdentifierNode
                              addTo = methodCall.getIdentifier () ;
                              JavaSDM.ensure ( addTo != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( ((addTo.getName () != null) && Pattern.matches ("add|put", addTo.getName ())) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(id1.equals (addTo)) ) ;
                               
                              // Path search between MethodCallNode and IdentifierNode
                              // Bind id2 : IdentifierNode
                              fujaba__IterMethodCallToId2 = new ASTPathVisitor (methodCall, IdentifierNode.class ) ;
                              while ( fujaba__IterMethodCallToId2.hasNext () )
                              {
                                 try
                                 {
                                    id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterMethodCallToId2.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(id1.equals (id2)) && !(addTo.equals (id2)) ) ;
                                     
                                    // check To-One-Link 'umlDeclaration' between id2 and param
                                    JavaSDM.ensure ( (id2.getUmlDeclaration () != null) && id2.getUmlDeclaration ().equals (param) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object attrib is really bound
                                          JavaSDM.ensure ( attrib != null ) ;
                                           
                                          // check object param is really bound
                                          JavaSDM.ensure ( param != null ) ;
                                           
                                          // check object uMLMethod2 is really bound
                                          JavaSDM.ensure ( uMLMethod2 != null ) ;
                                           
                                          // bind assignmentToContainer: AssignmentToContainerAnnotation
                                          fujaba__IterAttribAnnotationsAssignmentToContainer = attrib.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsAssignmentToContainer.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAttribAnnotationsAssignmentToContainer.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                                                assignmentToContainer = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between assignmentToContainer and attrib
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("field", attrib) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and param
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("param", param) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and uMLMethod2
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("method", uMLMethod2) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object attrib is really bound
                                             JavaSDM.ensure ( attrib != null ) ;
                                              
                                             // check object param is really bound
                                             JavaSDM.ensure ( param != null ) ;
                                              
                                             // check object uMLMethod2 is really bound
                                             JavaSDM.ensure ( uMLMethod2 != null ) ;
                                              
                                             // check object id2 is really bound
                                             JavaSDM.ensure ( id2 != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // check object id1 is really bound
                                             JavaSDM.ensure ( id1 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                              
                                             // check object methodCall is really bound
                                             JavaSDM.ensure ( methodCall != null ) ;
                                              
                                             // check object addTo is really bound
                                             JavaSDM.ensure ( addTo != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (addTo)) && !(id1.equals (addTo)) ) ;
                                              
                                             // create object
                                             assignmentToContainer = new AssignmentToContainerAnnotation ( ) ;
                                              
                                             // assign statement
                                             assignmentToContainer.setClassification (0);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("field", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("method", uMLMethod2);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("attrib", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id2", id2);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("root", root);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id1", id1);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("methodCall", methodCall);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("addTo", addTo);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (assignmentToContainer) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignmentToContainer is really bound
            JavaSDM.ensure ( assignmentToContainer != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assignmentToContainer) ;
   }


   private GFRNAnnotation annotateUsingMethodRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterMethodCallToId2 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode6 = null ;
      ASTRootNode root = null ;
      AssignmentToContainerAnnotation assignmentToContainer = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterParamAnnotationsAssignmentToContainer = null ;
      Iterator fujaba__IterUMLClass4AttrsAttrib = null ;
      Iterator fujaba__IterUMLMethod5ParamParam = null ;
      IdentifierNode addTo = null ;
      IdentifierNode id1 = null ;
      de.upb.javaast.methodast.IdentifierNode id2 = null ;
      MethodCallNode methodCall = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode6 = null ;
      UMLAttr attrib = null ;
      UMLClass uMLClass4 = null ;
      UMLMethod uMLMethod5 = null ;
      UMLParam param = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod5 = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = uMLMethod5.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLClass4: UMLClass
            uMLClass4 = uMLMethod5.getParent () ;
            JavaSDM.ensure ( uMLClass4 != null ) ;
             
            // bind param: UMLParam
            fujaba__IterUMLMethod5ParamParam = uMLMethod5.iteratorOfParam () ;
            while ( fujaba__IterUMLMethod5ParamParam.hasNext () )
            {
               try
               {
                  param = (UMLParam) fujaba__IterUMLMethod5ParamParam.next () ;
                   
                  // bind attrib: UMLAttr
                  fujaba__IterUMLClass4AttrsAttrib = uMLClass4.iteratorOfAttrs () ;
                  while ( fujaba__IterUMLClass4AttrsAttrib.hasNext () )
                  {
                     try
                     {
                        attrib = (UMLAttr) fujaba__IterUMLClass4AttrsAttrib.next () ;
                         
                        // Path search between ASTRootNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode6 : PrimaryExpressionNode
                        fujaba__IterRootToPrimaryExpressionNode6 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterRootToPrimaryExpressionNode6.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode6 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode6.next () ;
                               
                              // bind id1: IdentifierNode
                              id1 = primaryExpressionNode6.getIdentifier () ;
                              JavaSDM.ensure ( id1 != null ) ;
                               
                              // check To-One-Link 'umlDeclaration' between id1 and attrib
                              JavaSDM.ensure ( (id1.getUmlDeclaration () != null) && id1.getUmlDeclaration ().equals (attrib) ) ;
                               
                              // bind methodCall: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode6.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCall = (MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode6.equals (methodCall)) ) ;
                               
                              // bind addTo: IdentifierNode
                              addTo = methodCall.getIdentifier () ;
                              JavaSDM.ensure ( addTo != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( ((addTo.getName () != null) && Pattern.matches ("add|put", addTo.getName ())) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(id1.equals (addTo)) ) ;
                               
                              // Path search between MethodCallNode and IdentifierNode
                              // Bind id2 : IdentifierNode
                              fujaba__IterMethodCallToId2 = new ASTPathVisitor (methodCall, IdentifierNode.class ) ;
                              while ( fujaba__IterMethodCallToId2.hasNext () )
                              {
                                 try
                                 {
                                    id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterMethodCallToId2.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(id1.equals (id2)) && !(addTo.equals (id2)) ) ;
                                     
                                    // check To-One-Link 'umlDeclaration' between id2 and param
                                    JavaSDM.ensure ( (id2.getUmlDeclaration () != null) && id2.getUmlDeclaration ().equals (param) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object attrib is really bound
                                          JavaSDM.ensure ( attrib != null ) ;
                                           
                                          // check object param is really bound
                                          JavaSDM.ensure ( param != null ) ;
                                           
                                          // check object uMLMethod5 is really bound
                                          JavaSDM.ensure ( uMLMethod5 != null ) ;
                                           
                                          // bind assignmentToContainer: AssignmentToContainerAnnotation
                                          fujaba__IterParamAnnotationsAssignmentToContainer = param.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterParamAnnotationsAssignmentToContainer.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterParamAnnotationsAssignmentToContainer.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                                                assignmentToContainer = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between assignmentToContainer and param
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("param", param) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and attrib
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("field", attrib) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and uMLMethod5
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("method", uMLMethod5) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object attrib is really bound
                                             JavaSDM.ensure ( attrib != null ) ;
                                              
                                             // check object param is really bound
                                             JavaSDM.ensure ( param != null ) ;
                                              
                                             // check object uMLMethod5 is really bound
                                             JavaSDM.ensure ( uMLMethod5 != null ) ;
                                              
                                             // check object id2 is really bound
                                             JavaSDM.ensure ( id2 != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // check object id1 is really bound
                                             JavaSDM.ensure ( id1 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                              
                                             // check object methodCall is really bound
                                             JavaSDM.ensure ( methodCall != null ) ;
                                              
                                             // check object addTo is really bound
                                             JavaSDM.ensure ( addTo != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (addTo)) && !(id1.equals (addTo)) ) ;
                                              
                                             // create object
                                             assignmentToContainer = new AssignmentToContainerAnnotation ( ) ;
                                              
                                             // assign statement
                                             assignmentToContainer.setClassification (0);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("field", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("method", uMLMethod5);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("attrib", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id2", id2);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("root", root);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id1", id1);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("methodCall", methodCall);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("addTo", addTo);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (assignmentToContainer) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignmentToContainer is really bound
            JavaSDM.ensure ( assignmentToContainer != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assignmentToContainer) ;
   }


   private GFRNAnnotation annotateUsingParamRole(ASGElement asgElement)
   {
      ASTPathVisitor fujaba__IterMethodCallToId2 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode9 = null ;
      ASTRootNode root = null ;
      AssignmentToContainerAnnotation assignmentToContainer = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAttribAnnotationsAssignmentToContainer = null ;
      Iterator fujaba__IterUMLClass7AttrsAttrib = null ;
      IdentifierNode addTo = null ;
      IdentifierNode id1 = null ;
      de.upb.javaast.methodast.IdentifierNode id2 = null ;
      MethodCallNode methodCall = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode9 = null ;
      UMLAttr attrib = null ;
      UMLClass uMLClass7 = null ;
      UMLMethod uMLMethod8 = null ;
      UMLParam param = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            param = (UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod8: UMLMethod
            uMLMethod8 = param.getRevParam () ;
            JavaSDM.ensure ( uMLMethod8 != null ) ;
             
            // bind root: ASTRootNode
            root = uMLMethod8.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLClass7: UMLClass
            uMLClass7 = uMLMethod8.getParent () ;
            JavaSDM.ensure ( uMLClass7 != null ) ;
             
            // bind attrib: UMLAttr
            fujaba__IterUMLClass7AttrsAttrib = uMLClass7.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass7AttrsAttrib.hasNext () )
            {
               try
               {
                  attrib = (UMLAttr) fujaba__IterUMLClass7AttrsAttrib.next () ;
                   
                  // Path search between ASTRootNode and PrimaryExpressionNode
                  // Bind primaryExpressionNode9 : PrimaryExpressionNode
                  fujaba__IterRootToPrimaryExpressionNode9 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                  while ( fujaba__IterRootToPrimaryExpressionNode9.hasNext () )
                  {
                     try
                     {
                        primaryExpressionNode9 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode9.next () ;
                         
                        // bind id1: IdentifierNode
                        id1 = primaryExpressionNode9.getIdentifier () ;
                        JavaSDM.ensure ( id1 != null ) ;
                         
                        // check To-One-Link 'umlDeclaration' between id1 and attrib
                        JavaSDM.ensure ( (id1.getUmlDeclaration () != null) && id1.getUmlDeclaration ().equals (attrib) ) ;
                         
                        // bind methodCall: MethodCallNode
                        fujaba__TmpObject = primaryExpressionNode9.getNextPrimaryExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                        methodCall = (MethodCallNode) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(primaryExpressionNode9.equals (methodCall)) ) ;
                         
                        // bind addTo: IdentifierNode
                        addTo = methodCall.getIdentifier () ;
                        JavaSDM.ensure ( addTo != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( ((addTo.getName () != null) && Pattern.matches ("add|put", addTo.getName ())) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(id1.equals (addTo)) ) ;
                         
                        // Path search between MethodCallNode and IdentifierNode
                        // Bind id2 : IdentifierNode
                        fujaba__IterMethodCallToId2 = new ASTPathVisitor (methodCall, IdentifierNode.class ) ;
                        while ( fujaba__IterMethodCallToId2.hasNext () )
                        {
                           try
                           {
                              id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterMethodCallToId2.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(id1.equals (id2)) && !(addTo.equals (id2)) ) ;
                               
                              // check To-One-Link 'umlDeclaration' between id2 and param
                              JavaSDM.ensure ( (id2.getUmlDeclaration () != null) && id2.getUmlDeclaration ().equals (param) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // check object param is really bound
                                    JavaSDM.ensure ( param != null ) ;
                                     
                                    // check object uMLMethod8 is really bound
                                    JavaSDM.ensure ( uMLMethod8 != null ) ;
                                     
                                    // bind assignmentToContainer: AssignmentToContainerAnnotation
                                    fujaba__IterAttribAnnotationsAssignmentToContainer = attrib.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsAssignmentToContainer.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAttribAnnotationsAssignmentToContainer.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                                          assignmentToContainer = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between assignmentToContainer and attrib
                                          JavaSDM.ensure ( assignmentToContainer.hasInElements ("field", attrib) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignmentToContainer and param
                                          JavaSDM.ensure ( assignmentToContainer.hasInElements ("param", param) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignmentToContainer and uMLMethod8
                                          JavaSDM.ensure ( assignmentToContainer.hasInElements ("method", uMLMethod8) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object param is really bound
                                       JavaSDM.ensure ( param != null ) ;
                                        
                                       // check object uMLMethod8 is really bound
                                       JavaSDM.ensure ( uMLMethod8 != null ) ;
                                        
                                       // check object id2 is really bound
                                       JavaSDM.ensure ( id2 != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object id1 is really bound
                                       JavaSDM.ensure ( id1 != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(id2.equals (id1)) ) ;
                                        
                                       // check object methodCall is really bound
                                       JavaSDM.ensure ( methodCall != null ) ;
                                        
                                       // check object addTo is really bound
                                       JavaSDM.ensure ( addTo != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(id2.equals (addTo)) && !(id1.equals (addTo)) ) ;
                                        
                                       // create object
                                       assignmentToContainer = new AssignmentToContainerAnnotation ( ) ;
                                        
                                       // assign statement
                                       assignmentToContainer.setClassification (0);
                                        
                                       // create link
                                       assignmentToContainer.addToElements ("field", attrib);
                                        
                                       // create link
                                       assignmentToContainer.addToElements ("param", param);
                                        
                                       // create link
                                       assignmentToContainer.addToElements ("method", uMLMethod8);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("param", param);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("id2", id2);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("id1", id1);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("methodCall", methodCall);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("addTo", addTo);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (assignmentToContainer) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignmentToContainer is really bound
            JavaSDM.ensure ( assignmentToContainer != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("param", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assignmentToContainer) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
