package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLParam;

public class DoubleContainerAccessEngine
extends GFRNEngine
{
   private  DoubleContainerAccessEngine()
   {
   }

   private static DoubleContainerAccessEngine theDoubleContainerAccessEngine;

   public static DoubleContainerAccessEngine get()
   {
      if (theDoubleContainerAccessEngine == null)
      {
         theDoubleContainerAccessEngine = new DoubleContainerAccessEngine ();
      }
      return theDoubleContainerAccessEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation doubleContainerAccess = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         doubleContainerAccess = this.annotateUsingMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( doubleContainerAccess != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (doubleContainerAccess) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            doubleContainerAccess = this.annotateUsingFieldRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (doubleContainerAccess) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               doubleContainerAccess = this.annotateUsingTrigger_ContainerAccessRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( doubleContainerAccess != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (doubleContainerAccess) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  doubleContainerAccess = this.annotateUsingTrigger_ContainerAccessRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               try
               {
                  fujaba__Success = false ;
                   
                  // constraint
                  JavaSDM.ensure ( doubleContainerAccess != null ) ;
                   
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( fujaba__Success )
               {
                  return (doubleContainerAccess) ;
               }
               else
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // collabStatBegin 1 is empty !
                     doubleContainerAccess = this.annotateUsingParamRole(asgElement);
                      
                     // collabStatEnd
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  try
                  {
                     fujaba__Success = false ;
                      
                     // constraint
                     JavaSDM.ensure ( doubleContainerAccess != null ) ;
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  if ( fujaba__Success )
                  {
                     return (doubleContainerAccess) ;
                  }
                  else
                  {
                     try
                     {
                        fujaba__Success = false ;
                         
                        // collabStatBegin 1 is empty !
                        doubleContainerAccess = this.annotateUsingParamRole(asgElement);
                         
                        // collabStatEnd
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     return (doubleContainerAccess) ;
                  }
               }
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingFieldRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess10 = null ;
      ContainerAccessAnnotation containerAccess9 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess = null ;
      Iterator fujaba__IterContainerAccess10ElementsUMLMethod7 = null ;
      Iterator fujaba__IterContainerAccess10ElementsUMLParam11 = null ;
      Iterator fujaba__IterContainerAccess9ElementsUMLParam12 = null ;
      Iterator fujaba__IterUMLAttr8AnnotationsContainerAccess10 = null ;
      Iterator fujaba__IterUMLAttr8AnnotationsContainerAccess9 = null ;
      Iterator fujaba__IterUMLMethod7AnnotationsDoubleContainerAccess = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr8 = null ;
      UMLMethod uMLMethod7 = null ;
      UMLParam uMLParam11 = null ;
      UMLParam uMLParam12 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr8 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess10: ContainerAccessAnnotation
            fujaba__IterUMLAttr8AnnotationsContainerAccess10 = uMLAttr8.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLAttr8AnnotationsContainerAccess10.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLAttr8AnnotationsContainerAccess10.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess10 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess10 and uMLAttr8
                  JavaSDM.ensure ( containerAccess10.hasInElements ("field", uMLAttr8) ) ;
                   
                  // bind containerAccess9: ContainerAccessAnnotation
                  fujaba__IterUMLAttr8AnnotationsContainerAccess9 = uMLAttr8.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr8AnnotationsContainerAccess9.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr8AnnotationsContainerAccess9.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess9 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess9 and uMLAttr8
                        JavaSDM.ensure ( containerAccess9.hasInElements ("field", uMLAttr8) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(containerAccess10.equals (containerAccess9)) ) ;
                         
                        // bind uMLMethod7: UMLMethod
                        fujaba__IterContainerAccess10ElementsUMLMethod7 = containerAccess10.iteratorOfElements ("method") ;
                        while ( fujaba__IterContainerAccess10ElementsUMLMethod7.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess10ElementsUMLMethod7.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod7 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check To-Many-Link 'elements' between containerAccess9 and uMLMethod7
                              JavaSDM.ensure ( containerAccess9.hasInElements ("method", uMLMethod7) ) ;
                               
                              // bind uMLParam11: UMLParam
                              fujaba__IterContainerAccess10ElementsUMLParam11 = containerAccess10.iteratorOfElements ("param") ;
                              while ( fujaba__IterContainerAccess10ElementsUMLParam11.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterContainerAccess10ElementsUMLParam11.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                    uMLParam11 = (UMLParam) fujaba__TmpObject ;
                                     
                                    // bind uMLParam12: UMLParam
                                    fujaba__IterContainerAccess9ElementsUMLParam12 = containerAccess9.iteratorOfElements ("param") ;
                                    while ( fujaba__IterContainerAccess9ElementsUMLParam12.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess9ElementsUMLParam12.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam12 = (UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam11.equals (uMLParam12)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLParam11 is really bound
                                                JavaSDM.ensure ( uMLParam11 != null ) ;
                                                 
                                                // check object uMLAttr8 is really bound
                                                JavaSDM.ensure ( uMLAttr8 != null ) ;
                                                 
                                                // check object uMLMethod7 is really bound
                                                JavaSDM.ensure ( uMLMethod7 != null ) ;
                                                 
                                                // check object uMLParam12 is really bound
                                                JavaSDM.ensure ( uMLParam12 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam11.equals (uMLParam12)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLMethod7AnnotationsDoubleContainerAccess = uMLMethod7.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLMethod7AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLMethod7AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLMethod7
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod7) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam11
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam11) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLAttr8
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr8) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam12
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam12) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLParam11 is really bound
                                                   JavaSDM.ensure ( uMLParam11 != null ) ;
                                                    
                                                   // check object uMLAttr8 is really bound
                                                   JavaSDM.ensure ( uMLAttr8 != null ) ;
                                                    
                                                   // check object uMLMethod7 is really bound
                                                   JavaSDM.ensure ( uMLMethod7 != null ) ;
                                                    
                                                   // check object uMLParam12 is really bound
                                                   JavaSDM.ensure ( uMLParam12 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam11.equals (uMLParam12)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   doubleContainerAccess.setClassification (0);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam11);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr8);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod7);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam12);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess9 is really bound
                                                   JavaSDM.ensure ( containerAccess9 != null ) ;
                                                    
                                                   // check object containerAccess10 is really bound
                                                   JavaSDM.ensure ( containerAccess10 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess9.equals (containerAccess10)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess9);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess10);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (doubleContainerAccess) ;
   }


   private GFRNAnnotation annotateUsingMethodRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess3 = null ;
      ContainerAccessAnnotation containerAccess4 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess = null ;
      Iterator fujaba__IterContainerAccess3ElementsUMLParam6 = null ;
      Iterator fujaba__IterContainerAccess4ElementsUMLAttr2 = null ;
      Iterator fujaba__IterContainerAccess4ElementsUMLParam5 = null ;
      Iterator fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess = null ;
      Iterator fujaba__IterUMLMethod1AnnotationsContainerAccess3 = null ;
      Iterator fujaba__IterUMLMethod1AnnotationsContainerAccess4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr2 = null ;
      UMLMethod uMLMethod1 = null ;
      UMLParam uMLParam5 = null ;
      UMLParam uMLParam6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod1 = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess4: ContainerAccessAnnotation
            fujaba__IterUMLMethod1AnnotationsContainerAccess4 = uMLMethod1.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLMethod1AnnotationsContainerAccess4.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLMethod1AnnotationsContainerAccess4.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess4 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess4 and uMLMethod1
                  JavaSDM.ensure ( containerAccess4.hasInElements ("method", uMLMethod1) ) ;
                   
                  // bind containerAccess3: ContainerAccessAnnotation
                  fujaba__IterUMLMethod1AnnotationsContainerAccess3 = uMLMethod1.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod1AnnotationsContainerAccess3.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod1AnnotationsContainerAccess3.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess3 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess3 and uMLMethod1
                        JavaSDM.ensure ( containerAccess3.hasInElements ("method", uMLMethod1) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(containerAccess4.equals (containerAccess3)) ) ;
                         
                        // bind uMLAttr2: UMLAttr
                        fujaba__IterContainerAccess4ElementsUMLAttr2 = containerAccess4.iteratorOfElements ("field") ;
                        while ( fujaba__IterContainerAccess4ElementsUMLAttr2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess4ElementsUMLAttr2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              uMLAttr2 = (UMLAttr) fujaba__TmpObject ;
                               
                              // check To-Many-Link 'elements' between containerAccess3 and uMLAttr2
                              JavaSDM.ensure ( containerAccess3.hasInElements ("field", uMLAttr2) ) ;
                               
                              // bind uMLParam5: UMLParam
                              fujaba__IterContainerAccess4ElementsUMLParam5 = containerAccess4.iteratorOfElements ("param") ;
                              while ( fujaba__IterContainerAccess4ElementsUMLParam5.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterContainerAccess4ElementsUMLParam5.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                    uMLParam5 = (UMLParam) fujaba__TmpObject ;
                                     
                                    // bind uMLParam6: UMLParam
                                    fujaba__IterContainerAccess3ElementsUMLParam6 = containerAccess3.iteratorOfElements ("param") ;
                                    while ( fujaba__IterContainerAccess3ElementsUMLParam6.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess3ElementsUMLParam6.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam6 = (UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam5.equals (uMLParam6)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLParam5 is really bound
                                                JavaSDM.ensure ( uMLParam5 != null ) ;
                                                 
                                                // check object uMLAttr2 is really bound
                                                JavaSDM.ensure ( uMLAttr2 != null ) ;
                                                 
                                                // check object uMLMethod1 is really bound
                                                JavaSDM.ensure ( uMLMethod1 != null ) ;
                                                 
                                                // check object uMLParam6 is really bound
                                                JavaSDM.ensure ( uMLParam6 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam5.equals (uMLParam6)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess = uMLAttr2.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLAttr2AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLAttr2
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr2) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam5
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam5) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLMethod1
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam6
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam6) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLParam5 is really bound
                                                   JavaSDM.ensure ( uMLParam5 != null ) ;
                                                    
                                                   // check object uMLAttr2 is really bound
                                                   JavaSDM.ensure ( uMLAttr2 != null ) ;
                                                    
                                                   // check object uMLMethod1 is really bound
                                                   JavaSDM.ensure ( uMLMethod1 != null ) ;
                                                    
                                                   // check object uMLParam6 is really bound
                                                   JavaSDM.ensure ( uMLParam6 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam5.equals (uMLParam6)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   doubleContainerAccess.setClassification (0);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam5);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr2);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod1);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam6);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess3 is really bound
                                                   JavaSDM.ensure ( containerAccess3 != null ) ;
                                                    
                                                   // check object containerAccess4 is really bound
                                                   JavaSDM.ensure ( containerAccess4 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess3.equals (containerAccess4)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess3);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess4);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (doubleContainerAccess) ;
   }


   private GFRNAnnotation annotateUsingParamRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess27 = null ;
      ContainerAccessAnnotation containerAccess28 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess = null ;
      Iterator fujaba__IterContainerAccess27ElementsUMLParam30 = null ;
      Iterator fujaba__IterContainerAccess28ElementsUMLAttr26 = null ;
      Iterator fujaba__IterContainerAccess28ElementsUMLMethod25 = null ;
      Iterator fujaba__IterUMLAttr26AnnotationsContainerAccess27 = null ;
      Iterator fujaba__IterUMLMethod25AnnotationsDoubleContainerAccess = null ;
      Iterator fujaba__IterUMLParam29AnnotationsContainerAccess28 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr26 = null ;
      UMLMethod uMLMethod25 = null ;
      UMLParam uMLParam29 = null ;
      UMLParam uMLParam30 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam29 = (UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess28: ContainerAccessAnnotation
            fujaba__IterUMLParam29AnnotationsContainerAccess28 = uMLParam29.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLParam29AnnotationsContainerAccess28.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLParam29AnnotationsContainerAccess28.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess28 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess28 and uMLParam29
                  JavaSDM.ensure ( containerAccess28.hasInElements ("param", uMLParam29) ) ;
                   
                  // bind uMLAttr26: UMLAttr
                  fujaba__IterContainerAccess28ElementsUMLAttr26 = containerAccess28.iteratorOfElements ("field") ;
                  while ( fujaba__IterContainerAccess28ElementsUMLAttr26.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess28ElementsUMLAttr26.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr26 = (UMLAttr) fujaba__TmpObject ;
                         
                        // bind uMLMethod25: UMLMethod
                        fujaba__IterContainerAccess28ElementsUMLMethod25 = containerAccess28.iteratorOfElements ("method") ;
                        while ( fujaba__IterContainerAccess28ElementsUMLMethod25.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess28ElementsUMLMethod25.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod25 = (UMLMethod) fujaba__TmpObject ;
                               
                              // bind containerAccess27: ContainerAccessAnnotation
                              fujaba__IterUMLAttr26AnnotationsContainerAccess27 = uMLAttr26.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLAttr26AnnotationsContainerAccess27.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr26AnnotationsContainerAccess27.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                    containerAccess27 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between containerAccess27 and uMLAttr26
                                    JavaSDM.ensure ( containerAccess27.hasInElements ("field", uMLAttr26) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(containerAccess28.equals (containerAccess27)) ) ;
                                     
                                    // check To-Many-Link 'elements' between containerAccess27 and uMLMethod25
                                    JavaSDM.ensure ( containerAccess27.hasInElements ("method", uMLMethod25) ) ;
                                     
                                    // bind uMLParam30: UMLParam
                                    fujaba__IterContainerAccess27ElementsUMLParam30 = containerAccess27.iteratorOfElements ("param") ;
                                    while ( fujaba__IterContainerAccess27ElementsUMLParam30.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess27ElementsUMLParam30.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam30 = (UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam29.equals (uMLParam30)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLParam29 is really bound
                                                JavaSDM.ensure ( uMLParam29 != null ) ;
                                                 
                                                // check object uMLAttr26 is really bound
                                                JavaSDM.ensure ( uMLAttr26 != null ) ;
                                                 
                                                // check object uMLMethod25 is really bound
                                                JavaSDM.ensure ( uMLMethod25 != null ) ;
                                                 
                                                // check object uMLParam30 is really bound
                                                JavaSDM.ensure ( uMLParam30 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam29.equals (uMLParam30)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLMethod25AnnotationsDoubleContainerAccess = uMLMethod25.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLMethod25AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLMethod25AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLMethod25
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod25) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam29
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam29) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLAttr26
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr26) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam30
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam30) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLParam29 is really bound
                                                   JavaSDM.ensure ( uMLParam29 != null ) ;
                                                    
                                                   // check object uMLAttr26 is really bound
                                                   JavaSDM.ensure ( uMLAttr26 != null ) ;
                                                    
                                                   // check object uMLMethod25 is really bound
                                                   JavaSDM.ensure ( uMLMethod25 != null ) ;
                                                    
                                                   // check object uMLParam30 is really bound
                                                   JavaSDM.ensure ( uMLParam30 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam29.equals (uMLParam30)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   doubleContainerAccess.setClassification (0);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam29);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr26);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod25);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam30);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess27 is really bound
                                                   JavaSDM.ensure ( containerAccess27 != null ) ;
                                                    
                                                   // check object containerAccess28 is really bound
                                                   JavaSDM.ensure ( containerAccess28 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess27.equals (containerAccess28)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess27);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess28);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("param", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (doubleContainerAccess) ;
   }


   private GFRNAnnotation annotateUsingTrigger_ContainerAccessRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess15 = null ;
      ContainerAccessAnnotation containerAccess16 = null ;
      DoubleContainerAccessAnnotation doubleContainerAccess = null ;
      Iterator fujaba__IterContainerAccess15ElementsUMLAttr14 = null ;
      Iterator fujaba__IterContainerAccess15ElementsUMLMethod13 = null ;
      Iterator fujaba__IterContainerAccess15ElementsUMLParam18 = null ;
      Iterator fujaba__IterContainerAccess16ElementsUMLParam17 = null ;
      Iterator fujaba__IterUMLAttr14AnnotationsContainerAccess16 = null ;
      Iterator fujaba__IterUMLMethod13AnnotationsDoubleContainerAccess = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr14 = null ;
      UMLMethod uMLMethod13 = null ;
      UMLParam uMLParam17 = null ;
      UMLParam uMLParam18 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_ContainerAccess", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess15 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr14: UMLAttr
            fujaba__IterContainerAccess15ElementsUMLAttr14 = containerAccess15.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess15ElementsUMLAttr14.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess15ElementsUMLAttr14.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr14 = (UMLAttr) fujaba__TmpObject ;
                   
                  // bind uMLParam18: UMLParam
                  fujaba__IterContainerAccess15ElementsUMLParam18 = containerAccess15.iteratorOfElements ("param") ;
                  while ( fujaba__IterContainerAccess15ElementsUMLParam18.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess15ElementsUMLParam18.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                        uMLParam18 = (UMLParam) fujaba__TmpObject ;
                         
                        // bind uMLMethod13: UMLMethod
                        fujaba__IterContainerAccess15ElementsUMLMethod13 = containerAccess15.iteratorOfElements ("method") ;
                        while ( fujaba__IterContainerAccess15ElementsUMLMethod13.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess15ElementsUMLMethod13.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod13 = (UMLMethod) fujaba__TmpObject ;
                               
                              // bind containerAccess16: ContainerAccessAnnotation
                              fujaba__IterUMLAttr14AnnotationsContainerAccess16 = uMLAttr14.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLAttr14AnnotationsContainerAccess16.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr14AnnotationsContainerAccess16.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                                    containerAccess16 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between containerAccess16 and uMLAttr14
                                    JavaSDM.ensure ( containerAccess16.hasInElements ("field", uMLAttr14) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(containerAccess15.equals (containerAccess16)) ) ;
                                     
                                    // check To-Many-Link 'elements' between containerAccess16 and uMLMethod13
                                    JavaSDM.ensure ( containerAccess16.hasInElements ("method", uMLMethod13) ) ;
                                     
                                    // bind uMLParam17: UMLParam
                                    fujaba__IterContainerAccess16ElementsUMLParam17 = containerAccess16.iteratorOfElements ("param") ;
                                    while ( fujaba__IterContainerAccess16ElementsUMLParam17.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterContainerAccess16ElementsUMLParam17.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                                          uMLParam17 = (UMLParam) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLParam18.equals (uMLParam17)) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object uMLParam17 is really bound
                                                JavaSDM.ensure ( uMLParam17 != null ) ;
                                                 
                                                // check object uMLAttr14 is really bound
                                                JavaSDM.ensure ( uMLAttr14 != null ) ;
                                                 
                                                // check object uMLMethod13 is really bound
                                                JavaSDM.ensure ( uMLMethod13 != null ) ;
                                                 
                                                // check object uMLParam18 is really bound
                                                JavaSDM.ensure ( uMLParam18 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLParam17.equals (uMLParam18)) ) ;
                                                 
                                                // bind doubleContainerAccess: DoubleContainerAccessAnnotation
                                                fujaba__IterUMLMethod13AnnotationsDoubleContainerAccess = uMLMethod13.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterUMLMethod13AnnotationsDoubleContainerAccess.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLMethod13AnnotationsDoubleContainerAccess.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DoubleContainerAccessAnnotation ) ;
                                                      doubleContainerAccess = (DoubleContainerAccessAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between doubleContainerAccess and uMLMethod13
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("method", uMLMethod13) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam17
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam17) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLAttr14
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("field", uMLAttr14) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between doubleContainerAccess and uMLParam18
                                                      JavaSDM.ensure ( doubleContainerAccess.hasInElements ("param", uMLParam18) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object uMLParam17 is really bound
                                                   JavaSDM.ensure ( uMLParam17 != null ) ;
                                                    
                                                   // check object uMLAttr14 is really bound
                                                   JavaSDM.ensure ( uMLAttr14 != null ) ;
                                                    
                                                   // check object uMLMethod13 is really bound
                                                   JavaSDM.ensure ( uMLMethod13 != null ) ;
                                                    
                                                   // check object uMLParam18 is really bound
                                                   JavaSDM.ensure ( uMLParam18 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(uMLParam17.equals (uMLParam18)) ) ;
                                                    
                                                   // create object
                                                   doubleContainerAccess = new DoubleContainerAccessAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   doubleContainerAccess.setClassification (0);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam17);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("field", uMLAttr14);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("method", uMLMethod13);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToElements ("param", uMLParam18);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object containerAccess15 is really bound
                                                   JavaSDM.ensure ( containerAccess15 != null ) ;
                                                    
                                                   // check object containerAccess16 is really bound
                                                   JavaSDM.ensure ( containerAccess16 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(containerAccess15.equals (containerAccess16)) ) ;
                                                    
                                                   // check object doubleContainerAccess is really bound
                                                   JavaSDM.ensure ( doubleContainerAccess != null ) ;
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess15);
                                                    
                                                   // create link
                                                   doubleContainerAccess.addToAntecedentAnnos (containerAccess16);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (doubleContainerAccess) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object doubleContainerAccess is really bound
            JavaSDM.ensure ( doubleContainerAccess != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_ContainerAccess", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (doubleContainerAccess) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_ContainerAccess", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_ContainerAccess", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess37 = null ;
      ContainerAccessAnnotation containerAccess40 = null ;
      Iterator fujaba__IterContainerAccess37ElementsUMLAttr38 = null ;
      Iterator fujaba__IterContainerAccess37ElementsUMLAttr39 = null ;
      Iterator fujaba__IterContainerAccess40ElementsUMLAttr41 = null ;
      Iterator fujaba__IterContainerAccess40ElementsUMLAttr42 = null ;
      Iterator fujaba__IterUMLParam35AnnotationsContainerAccess37 = null ;
      Iterator fujaba__IterUMLParam36AnnotationsContainerAccess40 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr38 = null ;
      UMLAttr uMLAttr39 = null ;
      UMLAttr uMLAttr41 = null ;
      UMLAttr uMLAttr42 = null ;
      UMLMethod uMLMethod31 = null ;
      UMLParam uMLParam35 = null ;
      UMLParam uMLParam36 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("ContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam35 = (UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess37: ContainerAccessAnnotation
            fujaba__IterUMLParam35AnnotationsContainerAccess37 = uMLParam35.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLParam35AnnotationsContainerAccess37.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLParam35AnnotationsContainerAccess37.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess37 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess37 and uMLParam35
                  JavaSDM.ensure ( containerAccess37.hasInElements ("param", uMLParam35) ) ;
                   
                  // bind uMLAttr38: UMLAttr
                  fujaba__IterContainerAccess37ElementsUMLAttr38 = containerAccess37.iteratorOfElements ("field") ;
                  while ( fujaba__IterContainerAccess37ElementsUMLAttr38.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess37ElementsUMLAttr38.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr38 = (UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLAttr38);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr38 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr38);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod31 = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLMethod31);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam36 = (UMLParam) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLParam36);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess37 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr39: UMLAttr
            fujaba__IterContainerAccess37ElementsUMLAttr39 = containerAccess37.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess37ElementsUMLAttr39.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess37ElementsUMLAttr39.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr39 = (UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr39);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("ContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam35 = (UMLParam) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLParam35);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr39 = (UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr39);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod31 = (UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLMethod31);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            uMLParam36 = (UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess40: ContainerAccessAnnotation
            fujaba__IterUMLParam36AnnotationsContainerAccess40 = uMLParam36.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLParam36AnnotationsContainerAccess40.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLParam36AnnotationsContainerAccess40.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess40 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess40 and uMLParam36
                  JavaSDM.ensure ( containerAccess40.hasInElements ("param", uMLParam36) ) ;
                   
                  // bind uMLAttr41: UMLAttr
                  fujaba__IterContainerAccess40ElementsUMLAttr41 = containerAccess40.iteratorOfElements ("field") ;
                  while ( fujaba__IterContainerAccess40ElementsUMLAttr41.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess40ElementsUMLAttr41.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr41 = (UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (uMLAttr41);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess40 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr42: UMLAttr
            fujaba__IterContainerAccess40ElementsUMLAttr42 = containerAccess40.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess40ElementsUMLAttr42.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess40ElementsUMLAttr42.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr42 = (UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr42);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
