package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class IteratorEngine
extends GFRNEngine
{
   private  IteratorEngine()
   {
   }

   private static IteratorEngine theIteratorEngine;

   public static IteratorEngine get()
   {
      if (theIteratorEngine == null)
      {
         theIteratorEngine = new IteratorEngine ();
      }
      return theIteratorEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation iterator = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         iterator = this.annotateUsingAggregateRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( iterator != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (iterator) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            iterator = this.annotateUsingTrigger_CreateMethodRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (iterator) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               iterator = this.annotateUsingIteratorRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( iterator != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (iterator) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  iterator = this.annotateUsingTrigger_MultiReferenceRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               return (iterator) ;
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingAggregateRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod2 = null ;
      Iterator fujaba__IterAggregateClassAnnotationsIterator = null ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr1 = null ;
      Iterator fujaba__IterAggregateClassMethodsCreateIterator = null ;
      Iterator fujaba__IterCreateIteratorAnnotationsCreateMethod2 = null ;
      Iterator fujaba__IterCreateMethod2ElementsIteratorClass = null ;
      Iterator fujaba__IterMultiReference4ElementsReferencedClass = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod3 = null ;
      Iterator fujaba__IterUMLAttr1AnnotationsMultiReference4 = null ;
      IteratorAnnotation iterator = null ;
      MultiReferenceAnnotation multiReference4 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr1 = null ;
      UMLClass aggregateClass = null ;
      UMLClass iteratorClass = null ;
      UMLClass referencedClass = null ;
      UMLMethod createIterator = null ;
      UMLMethod uMLMethod3 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("aggregate", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            aggregateClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr1: UMLAttr
            fujaba__IterAggregateClassAttrsUMLAttr1 = aggregateClass.iteratorOfAttrs () ;
            while ( fujaba__IterAggregateClassAttrsUMLAttr1.hasNext () )
            {
               try
               {
                  uMLAttr1 = (UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr1.next () ;
                   
                  // bind createIterator: UMLMethod
                  fujaba__IterAggregateClassMethodsCreateIterator = aggregateClass.iteratorOfMethods () ;
                  while ( fujaba__IterAggregateClassMethodsCreateIterator.hasNext () )
                  {
                     try
                     {
                        createIterator = (UMLMethod) fujaba__IterAggregateClassMethodsCreateIterator.next () ;
                         
                        // bind multiReference4: MultiReferenceAnnotation
                        fujaba__IterUMLAttr1AnnotationsMultiReference4 = uMLAttr1.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr1AnnotationsMultiReference4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLAttr1AnnotationsMultiReference4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                              multiReference4 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between multiReference4 and uMLAttr1
                              JavaSDM.ensure ( multiReference4.hasInElements ("field", uMLAttr1) ) ;
                               
                              // bind createMethod2: CreateMethodAnnotation
                              fujaba__IterCreateIteratorAnnotationsCreateMethod2 = createIterator.iteratorOfAnnotations () ;
                              while ( fujaba__IterCreateIteratorAnnotationsCreateMethod2.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateIteratorAnnotationsCreateMethod2.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod2 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod2 and createIterator
                                    JavaSDM.ensure ( createMethod2.hasInElements ("method", createIterator) ) ;
                                     
                                    // bind referencedClass: UMLClass
                                    fujaba__IterMultiReference4ElementsReferencedClass = multiReference4.iteratorOfElements ("references") ;
                                    while ( fujaba__IterMultiReference4ElementsReferencedClass.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterMultiReference4ElementsReferencedClass.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          referencedClass = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) ) ;
                                           
                                          // bind iteratorClass: UMLClass
                                          fujaba__IterCreateMethod2ElementsIteratorClass = createMethod2.iteratorOfElements ("creates") ;
                                          while ( fujaba__IterCreateMethod2ElementsIteratorClass.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterCreateMethod2ElementsIteratorClass.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                iteratorClass = (UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) && !(referencedClass.equals (iteratorClass)) ) ;
                                                 
                                                // bind uMLMethod3: UMLMethod
                                                fujaba__IterReferencedClassRevResultTypeUMLMethod3 = referencedClass.iteratorOfRevResultType () ;
                                                while ( fujaba__IterReferencedClassRevResultTypeUMLMethod3.hasNext () )
                                                {
                                                   try
                                                   {
                                                      uMLMethod3 = (UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod3.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(createIterator.equals (uMLMethod3)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between uMLMethod3 and iteratorClass
                                                      JavaSDM.ensure ( (uMLMethod3.getParent () != null) && uMLMethod3.getParent ().equals (iteratorClass) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object aggregateClass is really bound
                                                            JavaSDM.ensure ( aggregateClass != null ) ;
                                                             
                                                            // check object iteratorClass is really bound
                                                            JavaSDM.ensure ( iteratorClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                             
                                                            // bind iterator: IteratorAnnotation
                                                            fujaba__IterAggregateClassAnnotationsIterator = aggregateClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAggregateClassAnnotationsIterator.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAggregateClassAnnotationsIterator.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof IteratorAnnotation ) ;
                                                                  iterator = (IteratorAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between iterator and aggregateClass
                                                                  JavaSDM.ensure ( iterator.hasInElements ("aggregate", aggregateClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between iterator and iteratorClass
                                                                  JavaSDM.ensure ( iterator.hasInElements ("iterator", iteratorClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object aggregateClass is really bound
                                                               JavaSDM.ensure ( aggregateClass != null ) ;
                                                                
                                                               // check object iteratorClass is really bound
                                                               JavaSDM.ensure ( iteratorClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                                
                                                               // check object createIterator is really bound
                                                               JavaSDM.ensure ( createIterator != null ) ;
                                                                
                                                               // check object referencedClass is really bound
                                                               JavaSDM.ensure ( referencedClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                                                
                                                               // create object
                                                               iterator = new IteratorAnnotation ( ) ;
                                                                
                                                               // assign statement
                                                               iterator.setClassification (1);
                                                                
                                                               // create link
                                                               iterator.addToElements ("aggregate", aggregateClass);
                                                                
                                                               // create link
                                                               iterator.addToElements ("iterator", iteratorClass);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("createIterator", createIterator);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("aggregateClass", aggregateClass);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("iteratorClass", iteratorClass);
                                                                
                                                               // create link
                                                               iterator.addToBoundObjects ("referencedClass", referencedClass);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object createMethod2 is really bound
                                                               JavaSDM.ensure ( createMethod2 != null ) ;
                                                                
                                                               // check object multiReference4 is really bound
                                                               JavaSDM.ensure ( multiReference4 != null ) ;
                                                                
                                                               // check object iterator is really bound
                                                               JavaSDM.ensure ( iterator != null ) ;
                                                                
                                                               // create link
                                                               iterator.addToAntecedentAnnos (createMethod2);
                                                                
                                                               // create link
                                                               iterator.addToAntecedentAnnos (multiReference4);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (iterator) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object iterator is really bound
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("aggregate", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (iterator) ;
   }


   private GFRNAnnotation annotateUsingIteratorRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod10 = null ;
      Iterator fujaba__IterAggregateClassAnnotationsIterator = null ;
      Iterator fujaba__IterCreateMethod10ElementsCreateIterator = null ;
      Iterator fujaba__IterIteratorClassAnnotationsCreateMethod10 = null ;
      Iterator fujaba__IterIteratorClassMethodsUMLMethod11 = null ;
      Iterator fujaba__IterMultiReference12ElementsUMLAttr9 = null ;
      Iterator fujaba__IterReferencedClassAnnotationsMultiReference12 = null ;
      IteratorAnnotation iterator = null ;
      MultiReferenceAnnotation multiReference12 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr9 = null ;
      UMLClass aggregateClass = null ;
      UMLClass iteratorClass = null ;
      UMLClass referencedClass = null ;
      UMLMethod createIterator = null ;
      UMLMethod uMLMethod11 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("iterator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            iteratorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod11: UMLMethod
            fujaba__IterIteratorClassMethodsUMLMethod11 = iteratorClass.iteratorOfMethods () ;
            while ( fujaba__IterIteratorClassMethodsUMLMethod11.hasNext () )
            {
               try
               {
                  uMLMethod11 = (UMLMethod) fujaba__IterIteratorClassMethodsUMLMethod11.next () ;
                   
                  // bind referencedClass: UMLClass
                  fujaba__TmpObject = uMLMethod11.getResultType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (UMLClass) fujaba__TmpObject ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(iteratorClass.equals (referencedClass)) ) ;
                   
                  // bind createMethod10: CreateMethodAnnotation
                  fujaba__IterIteratorClassAnnotationsCreateMethod10 = iteratorClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterIteratorClassAnnotationsCreateMethod10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterIteratorClassAnnotationsCreateMethod10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod10 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod10 and iteratorClass
                        JavaSDM.ensure ( createMethod10.hasInElements ("creates", iteratorClass) ) ;
                         
                        // bind multiReference12: MultiReferenceAnnotation
                        fujaba__IterReferencedClassAnnotationsMultiReference12 = referencedClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencedClassAnnotationsMultiReference12.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencedClassAnnotationsMultiReference12.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                              multiReference12 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between multiReference12 and referencedClass
                              JavaSDM.ensure ( multiReference12.hasInElements ("references", referencedClass) ) ;
                               
                              // bind createIterator: UMLMethod
                              fujaba__IterCreateMethod10ElementsCreateIterator = createMethod10.iteratorOfElements ("method") ;
                              while ( fujaba__IterCreateMethod10ElementsCreateIterator.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod10ElementsCreateIterator.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    createIterator = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod11.equals (createIterator)) ) ;
                                     
                                    // bind aggregateClass: UMLClass
                                    aggregateClass = createIterator.getParent () ;
                                    JavaSDM.ensure ( aggregateClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(iteratorClass.equals (aggregateClass)) && !(referencedClass.equals (aggregateClass)) ) ;
                                     
                                    // bind uMLAttr9: UMLAttr
                                    fujaba__IterMultiReference12ElementsUMLAttr9 = multiReference12.iteratorOfElements ("field") ;
                                    while ( fujaba__IterMultiReference12ElementsUMLAttr9.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterMultiReference12ElementsUMLAttr9.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                          uMLAttr9 = (UMLAttr) fujaba__TmpObject ;
                                           
                                          // check To-One-Link 'parent' between uMLAttr9 and aggregateClass
                                          JavaSDM.ensure ( (uMLAttr9.getParent () != null) && uMLAttr9.getParent ().equals (aggregateClass) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object aggregateClass is really bound
                                                JavaSDM.ensure ( aggregateClass != null ) ;
                                                 
                                                // check object iteratorClass is really bound
                                                JavaSDM.ensure ( iteratorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                 
                                                // bind iterator: IteratorAnnotation
                                                fujaba__IterAggregateClassAnnotationsIterator = aggregateClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterAggregateClassAnnotationsIterator.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAggregateClassAnnotationsIterator.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof IteratorAnnotation ) ;
                                                      iterator = (IteratorAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between iterator and aggregateClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("aggregate", aggregateClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between iterator and iteratorClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("iterator", iteratorClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object aggregateClass is really bound
                                                   JavaSDM.ensure ( aggregateClass != null ) ;
                                                    
                                                   // check object iteratorClass is really bound
                                                   JavaSDM.ensure ( iteratorClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                    
                                                   // check object createIterator is really bound
                                                   JavaSDM.ensure ( createIterator != null ) ;
                                                    
                                                   // check object referencedClass is really bound
                                                   JavaSDM.ensure ( referencedClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                                    
                                                   // create object
                                                   iterator = new IteratorAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   iterator.setClassification (1);
                                                    
                                                   // create link
                                                   iterator.addToElements ("aggregate", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToElements ("iterator", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("createIterator", createIterator);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("aggregateClass", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("iteratorClass", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("referencedClass", referencedClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object createMethod10 is really bound
                                                   JavaSDM.ensure ( createMethod10 != null ) ;
                                                    
                                                   // check object multiReference12 is really bound
                                                   JavaSDM.ensure ( multiReference12 != null ) ;
                                                    
                                                   // check object iterator is really bound
                                                   JavaSDM.ensure ( iterator != null ) ;
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (createMethod10);
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (multiReference12);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (iterator) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object iterator is really bound
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("iterator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (iterator) ;
   }


   private GFRNAnnotation annotateUsingTrigger_CreateMethodRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod6 = null ;
      Iterator fujaba__IterAggregateClassAnnotationsIterator = null ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr5 = null ;
      Iterator fujaba__IterCreateMethod6ElementsCreateIterator = null ;
      Iterator fujaba__IterCreateMethod6ElementsIteratorClass = null ;
      Iterator fujaba__IterIteratorClassMethodsUMLMethod7 = null ;
      Iterator fujaba__IterUMLAttr5AnnotationsMultiReference8 = null ;
      IteratorAnnotation iterator = null ;
      MultiReferenceAnnotation multiReference8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr5 = null ;
      UMLClass aggregateClass = null ;
      UMLClass iteratorClass = null ;
      UMLClass referencedClass = null ;
      UMLMethod createIterator = null ;
      UMLMethod uMLMethod7 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_CreateMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof CreateMethodAnnotation ) ;
             
            // explicit type cast
            createMethod6 = (CreateMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind createIterator: UMLMethod
            fujaba__IterCreateMethod6ElementsCreateIterator = createMethod6.iteratorOfElements ("method") ;
            while ( fujaba__IterCreateMethod6ElementsCreateIterator.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCreateMethod6ElementsCreateIterator.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  createIterator = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind aggregateClass: UMLClass
                  aggregateClass = createIterator.getParent () ;
                  JavaSDM.ensure ( aggregateClass != null ) ;
                   
                  // bind iteratorClass: UMLClass
                  fujaba__IterCreateMethod6ElementsIteratorClass = createMethod6.iteratorOfElements ("creates") ;
                  while ( fujaba__IterCreateMethod6ElementsIteratorClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCreateMethod6ElementsIteratorClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        iteratorClass = (UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                         
                        // bind uMLAttr5: UMLAttr
                        fujaba__IterAggregateClassAttrsUMLAttr5 = aggregateClass.iteratorOfAttrs () ;
                        while ( fujaba__IterAggregateClassAttrsUMLAttr5.hasNext () )
                        {
                           try
                           {
                              uMLAttr5 = (UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr5.next () ;
                               
                              // bind uMLMethod7: UMLMethod
                              fujaba__IterIteratorClassMethodsUMLMethod7 = iteratorClass.iteratorOfMethods () ;
                              while ( fujaba__IterIteratorClassMethodsUMLMethod7.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod7 = (UMLMethod) fujaba__IterIteratorClassMethodsUMLMethod7.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(createIterator.equals (uMLMethod7)) ) ;
                                     
                                    // bind referencedClass: UMLClass
                                    fujaba__TmpObject = uMLMethod7.getResultType () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    referencedClass = (UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                     
                                    // bind multiReference8: MultiReferenceAnnotation
                                    fujaba__IterUMLAttr5AnnotationsMultiReference8 = uMLAttr5.iteratorOfAnnotations () ;
                                    while ( fujaba__IterUMLAttr5AnnotationsMultiReference8.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLAttr5AnnotationsMultiReference8.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                          multiReference8 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between multiReference8 and uMLAttr5
                                          JavaSDM.ensure ( multiReference8.hasInElements ("field", uMLAttr5) ) ;
                                           
                                          // check To-Many-Link 'elements' between multiReference8 and referencedClass
                                          JavaSDM.ensure ( multiReference8.hasInElements ("references", referencedClass) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object aggregateClass is really bound
                                                JavaSDM.ensure ( aggregateClass != null ) ;
                                                 
                                                // check object iteratorClass is really bound
                                                JavaSDM.ensure ( iteratorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                 
                                                // bind iterator: IteratorAnnotation
                                                fujaba__IterAggregateClassAnnotationsIterator = aggregateClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterAggregateClassAnnotationsIterator.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAggregateClassAnnotationsIterator.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof IteratorAnnotation ) ;
                                                      iterator = (IteratorAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between iterator and aggregateClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("aggregate", aggregateClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between iterator and iteratorClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("iterator", iteratorClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object aggregateClass is really bound
                                                   JavaSDM.ensure ( aggregateClass != null ) ;
                                                    
                                                   // check object iteratorClass is really bound
                                                   JavaSDM.ensure ( iteratorClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                    
                                                   // check object createIterator is really bound
                                                   JavaSDM.ensure ( createIterator != null ) ;
                                                    
                                                   // check object referencedClass is really bound
                                                   JavaSDM.ensure ( referencedClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                                    
                                                   // create object
                                                   iterator = new IteratorAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   iterator.setClassification (1);
                                                    
                                                   // create link
                                                   iterator.addToElements ("aggregate", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToElements ("iterator", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("createIterator", createIterator);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("aggregateClass", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("iteratorClass", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("referencedClass", referencedClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object createMethod6 is really bound
                                                   JavaSDM.ensure ( createMethod6 != null ) ;
                                                    
                                                   // check object multiReference8 is really bound
                                                   JavaSDM.ensure ( multiReference8 != null ) ;
                                                    
                                                   // check object iterator is really bound
                                                   JavaSDM.ensure ( iterator != null ) ;
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (createMethod6);
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (multiReference8);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (iterator) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object iterator is really bound
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_CreateMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (iterator) ;
   }


   private GFRNAnnotation annotateUsingTrigger_MultiReferenceRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod14 = null ;
      Iterator fujaba__IterAggregateClassMethodsCreateIterator = null ;
      Iterator fujaba__IterIteratorClassAnnotationsCreateMethod14 = null ;
      Iterator fujaba__IterIteratorClassAnnotationsIterator = null ;
      Iterator fujaba__IterMultiReference16ElementsReferencedClass = null ;
      Iterator fujaba__IterMultiReference16ElementsUMLAttr13 = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod15 = null ;
      IteratorAnnotation iterator = null ;
      MultiReferenceAnnotation multiReference16 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr13 = null ;
      UMLClass aggregateClass = null ;
      UMLClass iteratorClass = null ;
      UMLClass referencedClass = null ;
      UMLMethod createIterator = null ;
      UMLMethod uMLMethod15 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiReference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference16 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            fujaba__IterMultiReference16ElementsReferencedClass = multiReference16.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference16ElementsReferencedClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference16ElementsReferencedClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLAttr13: UMLAttr
                  fujaba__IterMultiReference16ElementsUMLAttr13 = multiReference16.iteratorOfElements ("field") ;
                  while ( fujaba__IterMultiReference16ElementsUMLAttr13.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiReference16ElementsUMLAttr13.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        uMLAttr13 = (UMLAttr) fujaba__TmpObject ;
                         
                        // bind aggregateClass: UMLClass
                        aggregateClass = uMLAttr13.getParent () ;
                        JavaSDM.ensure ( aggregateClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(referencedClass.equals (aggregateClass)) ) ;
                         
                        // bind uMLMethod15: UMLMethod
                        fujaba__IterReferencedClassRevResultTypeUMLMethod15 = referencedClass.iteratorOfRevResultType () ;
                        while ( fujaba__IterReferencedClassRevResultTypeUMLMethod15.hasNext () )
                        {
                           try
                           {
                              uMLMethod15 = (UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod15.next () ;
                               
                              // bind iteratorClass: UMLClass
                              iteratorClass = uMLMethod15.getParent () ;
                              JavaSDM.ensure ( iteratorClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) && !(referencedClass.equals (iteratorClass)) ) ;
                               
                              // bind createIterator: UMLMethod
                              fujaba__IterAggregateClassMethodsCreateIterator = aggregateClass.iteratorOfMethods () ;
                              while ( fujaba__IterAggregateClassMethodsCreateIterator.hasNext () )
                              {
                                 try
                                 {
                                    createIterator = (UMLMethod) fujaba__IterAggregateClassMethodsCreateIterator.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod15.equals (createIterator)) ) ;
                                     
                                    // bind createMethod14: CreateMethodAnnotation
                                    fujaba__IterIteratorClassAnnotationsCreateMethod14 = iteratorClass.iteratorOfAnnotations () ;
                                    while ( fujaba__IterIteratorClassAnnotationsCreateMethod14.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterIteratorClassAnnotationsCreateMethod14.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                          createMethod14 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between createMethod14 and iteratorClass
                                          JavaSDM.ensure ( createMethod14.hasInElements ("creates", iteratorClass) ) ;
                                           
                                          // check To-Many-Link 'elements' between createMethod14 and createIterator
                                          JavaSDM.ensure ( createMethod14.hasInElements ("method", createIterator) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object aggregateClass is really bound
                                                JavaSDM.ensure ( aggregateClass != null ) ;
                                                 
                                                // check object iteratorClass is really bound
                                                JavaSDM.ensure ( iteratorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                 
                                                // bind iterator: IteratorAnnotation
                                                fujaba__IterIteratorClassAnnotationsIterator = iteratorClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterIteratorClassAnnotationsIterator.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterIteratorClassAnnotationsIterator.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof IteratorAnnotation ) ;
                                                      iterator = (IteratorAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between iterator and iteratorClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("iterator", iteratorClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between iterator and aggregateClass
                                                      JavaSDM.ensure ( iterator.hasInElements ("aggregate", aggregateClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object aggregateClass is really bound
                                                   JavaSDM.ensure ( aggregateClass != null ) ;
                                                    
                                                   // check object iteratorClass is really bound
                                                   JavaSDM.ensure ( iteratorClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) ) ;
                                                    
                                                   // check object createIterator is really bound
                                                   JavaSDM.ensure ( createIterator != null ) ;
                                                    
                                                   // check object referencedClass is really bound
                                                   JavaSDM.ensure ( referencedClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) && !(iteratorClass.equals (referencedClass)) ) ;
                                                    
                                                   // create object
                                                   iterator = new IteratorAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   iterator.setClassification (1);
                                                    
                                                   // create link
                                                   iterator.addToElements ("aggregate", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToElements ("iterator", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("createIterator", createIterator);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("aggregateClass", aggregateClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("iteratorClass", iteratorClass);
                                                    
                                                   // create link
                                                   iterator.addToBoundObjects ("referencedClass", referencedClass);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object createMethod14 is really bound
                                                   JavaSDM.ensure ( createMethod14 != null ) ;
                                                    
                                                   // check object multiReference16 is really bound
                                                   JavaSDM.ensure ( multiReference16 != null ) ;
                                                    
                                                   // check object iterator is really bound
                                                   JavaSDM.ensure ( iterator != null ) ;
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (createMethod14);
                                                    
                                                   // create link
                                                   iterator.addToAntecedentAnnos (multiReference16);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (iterator) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object iterator is really bound
            JavaSDM.ensure ( iterator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_MultiReference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (iterator) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("aggregate", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("iterator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof CreateMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_CreateMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_MultiReference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod14 = null ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr17 = null ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr21 = null ;
      Iterator fujaba__IterAggregateClassAttrsUMLAttr23 = null ;
      Iterator fujaba__IterCreateMethod14ElementsCreateIterator = null ;
      Iterator fujaba__IterIteratorClassMethodsUMLMethod22 = null ;
      Iterator fujaba__IterMultiReference18ElementsReferencedClass = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod19 = null ;
      Iterator fujaba__IterReferencedClassRevResultTypeUMLMethod20 = null ;
      Iterator fujaba__IterUMLAttr17AnnotationsMultiReference18 = null ;
      MultiReferenceAnnotation multiReference18 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLAttr uMLAttr17 = null ;
      UMLAttr uMLAttr21 = null ;
      UMLAttr uMLAttr23 = null ;
      UMLClass aggregateClass = null ;
      UMLClass iteratorClass = null ;
      UMLClass referencedClass = null ;
      UMLMethod createIterator = null ;
      UMLMethod uMLMethod19 = null ;
      UMLMethod uMLMethod20 = null ;
      UMLMethod uMLMethod22 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("CreateMethod") || annotation.equals ("CreateMethodSubType") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            aggregateClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr17: UMLAttr
            fujaba__IterAggregateClassAttrsUMLAttr17 = aggregateClass.iteratorOfAttrs () ;
            while ( fujaba__IterAggregateClassAttrsUMLAttr17.hasNext () )
            {
               try
               {
                  uMLAttr17 = (UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr17.next () ;
                   
                  // bind multiReference18: MultiReferenceAnnotation
                  fujaba__IterUMLAttr17AnnotationsMultiReference18 = uMLAttr17.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLAttr17AnnotationsMultiReference18.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLAttr17AnnotationsMultiReference18.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference18 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference18 and uMLAttr17
                        JavaSDM.ensure ( multiReference18.hasInElements ("field", uMLAttr17) ) ;
                         
                        // bind referencedClass: UMLClass
                        fujaba__IterMultiReference18ElementsReferencedClass = multiReference18.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference18ElementsReferencedClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference18ElementsReferencedClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              referencedClass = (UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(aggregateClass.equals (referencedClass)) ) ;
                               
                              // bind uMLMethod19: UMLMethod
                              fujaba__IterReferencedClassRevResultTypeUMLMethod19 = referencedClass.iteratorOfRevResultType () ;
                              while ( fujaba__IterReferencedClassRevResultTypeUMLMethod19.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod19 = (UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod19.next () ;
                                     
                                    // bind iteratorClass: UMLClass
                                    iteratorClass = uMLMethod19.getParent () ;
                                    JavaSDM.ensure ( iteratorClass != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(aggregateClass.equals (iteratorClass)) && !(referencedClass.equals (iteratorClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (iteratorClass);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            iteratorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (iteratorClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference18 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            fujaba__IterMultiReference18ElementsReferencedClass = multiReference18.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference18ElementsReferencedClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference18ElementsReferencedClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod20: UMLMethod
                  fujaba__IterReferencedClassRevResultTypeUMLMethod20 = referencedClass.iteratorOfRevResultType () ;
                  while ( fujaba__IterReferencedClassRevResultTypeUMLMethod20.hasNext () )
                  {
                     try
                     {
                        uMLMethod20 = (UMLMethod) fujaba__IterReferencedClassRevResultTypeUMLMethod20.next () ;
                         
                        // bind iteratorClass: UMLClass
                        iteratorClass = uMLMethod20.getParent () ;
                        JavaSDM.ensure ( iteratorClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(referencedClass.equals (iteratorClass)) ) ;
                         
                        {
                           //  for each flow
                           set.add (iteratorClass);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("MultiReference") || annotation.equals ("ArrayReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            aggregateClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr21: UMLAttr
            fujaba__IterAggregateClassAttrsUMLAttr21 = aggregateClass.iteratorOfAttrs () ;
            while ( fujaba__IterAggregateClassAttrsUMLAttr21.hasNext () )
            {
               try
               {
                  uMLAttr21 = (UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr21.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr21);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            iteratorClass = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod22: UMLMethod
            fujaba__IterIteratorClassMethodsUMLMethod22 = iteratorClass.iteratorOfMethods () ;
            while ( fujaba__IterIteratorClassMethodsUMLMethod22.hasNext () )
            {
               try
               {
                  uMLMethod22 = (UMLMethod) fujaba__IterIteratorClassMethodsUMLMethod22.next () ;
                   
                  // bind referencedClass: UMLClass
                  fujaba__TmpObject = uMLMethod22.getResultType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  referencedClass = (UMLClass) fujaba__TmpObject ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(iteratorClass.equals (referencedClass)) ) ;
                   
                  {
                     //  for each flow
                     set.add (referencedClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof CreateMethodAnnotation ) ;
             
            // explicit type cast
            createMethod14 = (CreateMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind createIterator: UMLMethod
            fujaba__IterCreateMethod14ElementsCreateIterator = createMethod14.iteratorOfElements ("method") ;
            while ( fujaba__IterCreateMethod14ElementsCreateIterator.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCreateMethod14ElementsCreateIterator.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  createIterator = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind aggregateClass: UMLClass
                  aggregateClass = createIterator.getParent () ;
                  JavaSDM.ensure ( aggregateClass != null ) ;
                   
                  // bind uMLAttr23: UMLAttr
                  fujaba__IterAggregateClassAttrsUMLAttr23 = aggregateClass.iteratorOfAttrs () ;
                  while ( fujaba__IterAggregateClassAttrsUMLAttr23.hasNext () )
                  {
                     try
                     {
                        uMLAttr23 = (UMLAttr) fujaba__IterAggregateClassAttrsUMLAttr23.next () ;
                         
                        {
                           //  for each flow
                           set.add (uMLAttr23);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
