package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLParam;

public class StateEngine
extends GFRNEngine
{
   private  StateEngine()
   {
   }

   private static StateEngine theStateEngine;

   public static StateEngine get()
   {
      if (theStateEngine == null)
      {
         theStateEngine = new StateEngine ();
      }
      return theStateEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation state = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         state = this.annotateUsingTrigger_OverridingMethodRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( state != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (state) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            state = this.annotateUsingContextRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( state != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (state) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               state = this.annotateUsingStateRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( state != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (state) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  state = this.annotateUsingTrigger_NeighborCallRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               try
               {
                  fujaba__Success = false ;
                   
                  // constraint
                  JavaSDM.ensure ( state != null ) ;
                   
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( fujaba__Success )
               {
                  return (state) ;
               }
               else
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // collabStatBegin 1 is empty !
                     state = this.annotateUsingTrigger_ReferenceRole(asgElement);
                      
                     // collabStatEnd
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  return (state) ;
               }
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingContextRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractStateAnnotationsState = null ;
      Iterator fujaba__IterContextAnnotationsReference7 = null ;
      Iterator fujaba__IterContextMethodsRequest = null ;
      Iterator fujaba__IterContextMethodsSetState = null ;
      Iterator fujaba__IterHandleAnnotationsOverridingMethod5 = null ;
      Iterator fujaba__IterNeighborCall6ElementsHandle = null ;
      Iterator fujaba__IterRequestAnnotationsNeighborCall6 = null ;
      Iterator fujaba__IterSetStateParamUMLParam8 = null ;
      NeighborCallAnnotation neighborCall6 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod5 = null ;
      ReferenceAnnotation reference7 = null ;
      StateAnnotation state = null ;
      UMLClass abstractState = null ;
      UMLClass context = null ;
      UMLMethod handle = null ;
      UMLMethod request = null ;
      UMLMethod setState = null ;
      UMLParam uMLParam8 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("context", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            context = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind request: UMLMethod
            fujaba__IterContextMethodsRequest = context.iteratorOfMethods () ;
            while ( fujaba__IterContextMethodsRequest.hasNext () )
            {
               try
               {
                  request = (UMLMethod) fujaba__IterContextMethodsRequest.next () ;
                   
                  // bind setState: UMLMethod
                  fujaba__IterContextMethodsSetState = context.iteratorOfMethods () ;
                  while ( fujaba__IterContextMethodsSetState.hasNext () )
                  {
                     try
                     {
                        setState = (UMLMethod) fujaba__IterContextMethodsSetState.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(request.equals (setState)) ) ;
                         
                        // bind reference7: ReferenceAnnotation
                        fujaba__IterContextAnnotationsReference7 = context.iteratorOfAnnotations () ;
                        while ( fujaba__IterContextAnnotationsReference7.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContextAnnotationsReference7.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference7 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference7 and context
                              JavaSDM.ensure ( reference7.hasInElements ("referencingClass", context) ) ;
                               
                              // bind neighborCall6: NeighborCallAnnotation
                              fujaba__IterRequestAnnotationsNeighborCall6 = request.iteratorOfAnnotations () ;
                              while ( fujaba__IterRequestAnnotationsNeighborCall6.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterRequestAnnotationsNeighborCall6.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall6 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall6 and request
                                    JavaSDM.ensure ( neighborCall6.hasInElements ("caller", request) ) ;
                                     
                                    // bind uMLParam8: UMLParam
                                    fujaba__IterSetStateParamUMLParam8 = setState.iteratorOfParam () ;
                                    while ( fujaba__IterSetStateParamUMLParam8.hasNext () )
                                    {
                                       try
                                       {
                                          uMLParam8 = (UMLParam) fujaba__IterSetStateParamUMLParam8.next () ;
                                           
                                          // bind abstractState: UMLClass
                                          fujaba__TmpObject = uMLParam8.getParamType () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          abstractState = (UMLClass) fujaba__TmpObject ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (abstractState.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                           
                                          // check To-Many-Link 'elements' between reference7 and abstractState
                                          JavaSDM.ensure ( reference7.hasInElements ("references", abstractState) ) ;
                                           
                                          // bind handle: UMLMethod
                                          fujaba__IterNeighborCall6ElementsHandle = neighborCall6.iteratorOfElements ("callee") ;
                                          while ( fujaba__IterNeighborCall6ElementsHandle.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterNeighborCall6ElementsHandle.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                handle = (UMLMethod) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(request.equals (handle)) && !(setState.equals (handle)) ) ;
                                                 
                                                // check To-One-Link 'parent' between handle and abstractState
                                                JavaSDM.ensure ( (handle.getParent () != null) && handle.getParent ().equals (abstractState) ) ;
                                                 
                                                // bind overridingMethod5: OverridingMethodAnnotation
                                                fujaba__IterHandleAnnotationsOverridingMethod5 = handle.iteratorOfAnnotations () ;
                                                while ( fujaba__IterHandleAnnotationsOverridingMethod5.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterHandleAnnotationsOverridingMethod5.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                      overridingMethod5 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between overridingMethod5 and handle
                                                      JavaSDM.ensure ( overridingMethod5.hasInElements ("overridden", handle) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object context is really bound
                                                            JavaSDM.ensure ( context != null ) ;
                                                             
                                                            // check object abstractState is really bound
                                                            JavaSDM.ensure ( abstractState != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                             
                                                            // bind state: StateAnnotation
                                                            fujaba__IterAbstractStateAnnotationsState = abstractState.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAbstractStateAnnotationsState.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAbstractStateAnnotationsState.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof StateAnnotation ) ;
                                                                  state = (StateAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between state and abstractState
                                                                  JavaSDM.ensure ( state.hasInElements ("state", abstractState) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between state and context
                                                                  JavaSDM.ensure ( state.hasInElements ("context", context) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object context is really bound
                                                               JavaSDM.ensure ( context != null ) ;
                                                                
                                                               // check object abstractState is really bound
                                                               JavaSDM.ensure ( abstractState != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                                
                                                               // check object request is really bound
                                                               JavaSDM.ensure ( request != null ) ;
                                                                
                                                               // check object handle is really bound
                                                               JavaSDM.ensure ( handle != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(request.equals (handle)) ) ;
                                                                
                                                               // check object setState is really bound
                                                               JavaSDM.ensure ( setState != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(request.equals (setState)) && !(handle.equals (setState)) ) ;
                                                                
                                                               // create object
                                                               state = new StateAnnotation ( ) ;
                                                                
                                                               // assign statement
                                                               state.setClassification (1);
                                                                
                                                               // create link
                                                               state.addToElements ("context", context);
                                                                
                                                               // create link
                                                               state.addToElements ("state", abstractState);
                                                                
                                                               // create link
                                                               state.addToBoundObjects ("request", request);
                                                                
                                                               // create link
                                                               state.addToBoundObjects ("context", context);
                                                                
                                                               // create link
                                                               state.addToBoundObjects ("abstractState", abstractState);
                                                                
                                                               // create link
                                                               state.addToBoundObjects ("handle", handle);
                                                                
                                                               // create link
                                                               state.addToBoundObjects ("setState", setState);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object overridingMethod5 is really bound
                                                               JavaSDM.ensure ( overridingMethod5 != null ) ;
                                                                
                                                               // check object neighborCall6 is really bound
                                                               JavaSDM.ensure ( neighborCall6 != null ) ;
                                                                
                                                               // check object reference7 is really bound
                                                               JavaSDM.ensure ( reference7 != null ) ;
                                                                
                                                               // check object state is really bound
                                                               JavaSDM.ensure ( state != null ) ;
                                                                
                                                               // create link
                                                               state.addToAntecedentAnnos (overridingMethod5);
                                                                
                                                               // create link
                                                               state.addToAntecedentAnnos (neighborCall6);
                                                                
                                                               // create link
                                                               state.addToAntecedentAnnos (reference7);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (state) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object state is really bound
            JavaSDM.ensure ( state != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("context", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (state) ;
   }


   private GFRNAnnotation annotateUsingStateRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractStateAnnotationsReference11 = null ;
      Iterator fujaba__IterAbstractStateMethodsHandle = null ;
      Iterator fujaba__IterAbstractStateRevParamTypeUMLParam12 = null ;
      Iterator fujaba__IterContextAnnotationsState = null ;
      Iterator fujaba__IterContextMethodsRequest = null ;
      Iterator fujaba__IterHandleAnnotationsNeighborCall10 = null ;
      Iterator fujaba__IterHandleAnnotationsOverridingMethod9 = null ;
      NeighborCallAnnotation neighborCall10 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod9 = null ;
      ReferenceAnnotation reference11 = null ;
      StateAnnotation state = null ;
      UMLClass abstractState = null ;
      UMLClass context = null ;
      UMLMethod handle = null ;
      UMLMethod request = null ;
      UMLMethod setState = null ;
      UMLParam uMLParam12 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("state", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractState = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (abstractState.isAbstract () == true) ) ;
             
            // bind handle: UMLMethod
            fujaba__IterAbstractStateMethodsHandle = abstractState.iteratorOfMethods () ;
            while ( fujaba__IterAbstractStateMethodsHandle.hasNext () )
            {
               try
               {
                  handle = (UMLMethod) fujaba__IterAbstractStateMethodsHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                   
                  // bind reference11: ReferenceAnnotation
                  fujaba__IterAbstractStateAnnotationsReference11 = abstractState.iteratorOfAnnotations () ;
                  while ( fujaba__IterAbstractStateAnnotationsReference11.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAbstractStateAnnotationsReference11.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference11 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference11 and abstractState
                        JavaSDM.ensure ( reference11.hasInElements ("references", abstractState) ) ;
                         
                        // bind uMLParam12: UMLParam
                        fujaba__IterAbstractStateRevParamTypeUMLParam12 = abstractState.iteratorOfRevParamType () ;
                        while ( fujaba__IterAbstractStateRevParamTypeUMLParam12.hasNext () )
                        {
                           try
                           {
                              uMLParam12 = (UMLParam) fujaba__IterAbstractStateRevParamTypeUMLParam12.next () ;
                               
                              // bind setState: UMLMethod
                              setState = uMLParam12.getRevParam () ;
                              JavaSDM.ensure ( setState != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(handle.equals (setState)) ) ;
                               
                              // bind context: UMLClass
                              context = setState.getParent () ;
                              JavaSDM.ensure ( context != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstractState.equals (context)) ) ;
                               
                              // check To-Many-Link 'elements' between reference11 and context
                              JavaSDM.ensure ( reference11.hasInElements ("referencingClass", context) ) ;
                               
                              // bind neighborCall10: NeighborCallAnnotation
                              fujaba__IterHandleAnnotationsNeighborCall10 = handle.iteratorOfAnnotations () ;
                              while ( fujaba__IterHandleAnnotationsNeighborCall10.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterHandleAnnotationsNeighborCall10.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall10 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall10 and handle
                                    JavaSDM.ensure ( neighborCall10.hasInElements ("callee", handle) ) ;
                                     
                                    // bind overridingMethod9: OverridingMethodAnnotation
                                    fujaba__IterHandleAnnotationsOverridingMethod9 = handle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterHandleAnnotationsOverridingMethod9.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterHandleAnnotationsOverridingMethod9.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                          overridingMethod9 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between overridingMethod9 and handle
                                          JavaSDM.ensure ( overridingMethod9.hasInElements ("overridden", handle) ) ;
                                           
                                          // bind request: UMLMethod
                                          fujaba__IterContextMethodsRequest = context.iteratorOfMethods () ;
                                          while ( fujaba__IterContextMethodsRequest.hasNext () )
                                          {
                                             try
                                             {
                                                request = (UMLMethod) fujaba__IterContextMethodsRequest.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(handle.equals (request)) && !(setState.equals (request)) ) ;
                                                 
                                                // check To-Many-Link 'elements' between neighborCall10 and request
                                                JavaSDM.ensure ( neighborCall10.hasInElements ("caller", request) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object context is really bound
                                                      JavaSDM.ensure ( context != null ) ;
                                                       
                                                      // check object abstractState is really bound
                                                      JavaSDM.ensure ( abstractState != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                       
                                                      // bind state: StateAnnotation
                                                      fujaba__IterContextAnnotationsState = context.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterContextAnnotationsState.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterContextAnnotationsState.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof StateAnnotation ) ;
                                                            state = (StateAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between state and context
                                                            JavaSDM.ensure ( state.hasInElements ("context", context) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between state and abstractState
                                                            JavaSDM.ensure ( state.hasInElements ("state", abstractState) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object context is really bound
                                                         JavaSDM.ensure ( context != null ) ;
                                                          
                                                         // check object abstractState is really bound
                                                         JavaSDM.ensure ( abstractState != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                          
                                                         // check object request is really bound
                                                         JavaSDM.ensure ( request != null ) ;
                                                          
                                                         // check object handle is really bound
                                                         JavaSDM.ensure ( handle != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(request.equals (handle)) ) ;
                                                          
                                                         // check object setState is really bound
                                                         JavaSDM.ensure ( setState != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(request.equals (setState)) && !(handle.equals (setState)) ) ;
                                                          
                                                         // create object
                                                         state = new StateAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         state.setClassification (1);
                                                          
                                                         // create link
                                                         state.addToElements ("context", context);
                                                          
                                                         // create link
                                                         state.addToElements ("state", abstractState);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("request", request);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("context", context);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("abstractState", abstractState);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("handle", handle);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("setState", setState);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object overridingMethod9 is really bound
                                                         JavaSDM.ensure ( overridingMethod9 != null ) ;
                                                          
                                                         // check object neighborCall10 is really bound
                                                         JavaSDM.ensure ( neighborCall10 != null ) ;
                                                          
                                                         // check object reference11 is really bound
                                                         JavaSDM.ensure ( reference11 != null ) ;
                                                          
                                                         // check object state is really bound
                                                         JavaSDM.ensure ( state != null ) ;
                                                          
                                                         // create link
                                                         state.addToAntecedentAnnos (overridingMethod9);
                                                          
                                                         // create link
                                                         state.addToAntecedentAnnos (neighborCall10);
                                                          
                                                         // create link
                                                         state.addToAntecedentAnnos (reference11);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (state) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object state is really bound
            JavaSDM.ensure ( state != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("state", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (state) ;
   }


   private GFRNAnnotation annotateUsingTrigger_NeighborCallRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractStateAnnotationsState = null ;
      Iterator fujaba__IterAbstractStateRevParamTypeUMLParam16 = null ;
      Iterator fujaba__IterContextAnnotationsReference15 = null ;
      Iterator fujaba__IterContextMethodsSetState = null ;
      Iterator fujaba__IterHandleAnnotationsOverridingMethod13 = null ;
      Iterator fujaba__IterNeighborCall14ElementsHandle = null ;
      Iterator fujaba__IterNeighborCall14ElementsRequest = null ;
      NeighborCallAnnotation neighborCall14 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod13 = null ;
      ReferenceAnnotation reference15 = null ;
      StateAnnotation state = null ;
      UMLClass abstractState = null ;
      UMLClass context = null ;
      UMLMethod handle = null ;
      UMLMethod request = null ;
      UMLMethod setState = null ;
      UMLParam uMLParam16 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_NeighborCall", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall14 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind request: UMLMethod
            fujaba__IterNeighborCall14ElementsRequest = neighborCall14.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall14ElementsRequest.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall14ElementsRequest.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  request = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind context: UMLClass
                  context = request.getParent () ;
                  JavaSDM.ensure ( context != null ) ;
                   
                  // bind handle: UMLMethod
                  fujaba__IterNeighborCall14ElementsHandle = neighborCall14.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall14ElementsHandle.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall14ElementsHandle.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        handle = (UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(request.equals (handle)) ) ;
                         
                        // bind abstractState: UMLClass
                        abstractState = handle.getParent () ;
                        JavaSDM.ensure ( abstractState != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractState.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                         
                        // bind setState: UMLMethod
                        fujaba__IterContextMethodsSetState = context.iteratorOfMethods () ;
                        while ( fujaba__IterContextMethodsSetState.hasNext () )
                        {
                           try
                           {
                              setState = (UMLMethod) fujaba__IterContextMethodsSetState.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(request.equals (setState)) && !(handle.equals (setState)) ) ;
                               
                              // bind reference15: ReferenceAnnotation
                              fujaba__IterContextAnnotationsReference15 = context.iteratorOfAnnotations () ;
                              while ( fujaba__IterContextAnnotationsReference15.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterContextAnnotationsReference15.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                    reference15 = (ReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between reference15 and context
                                    JavaSDM.ensure ( reference15.hasInElements ("referencingClass", context) ) ;
                                     
                                    // check To-Many-Link 'elements' between reference15 and abstractState
                                    JavaSDM.ensure ( reference15.hasInElements ("references", abstractState) ) ;
                                     
                                    // bind overridingMethod13: OverridingMethodAnnotation
                                    fujaba__IterHandleAnnotationsOverridingMethod13 = handle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterHandleAnnotationsOverridingMethod13.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterHandleAnnotationsOverridingMethod13.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                          overridingMethod13 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between overridingMethod13 and handle
                                          JavaSDM.ensure ( overridingMethod13.hasInElements ("overridden", handle) ) ;
                                           
                                          // bind uMLParam16: UMLParam
                                          fujaba__IterAbstractStateRevParamTypeUMLParam16 = abstractState.iteratorOfRevParamType () ;
                                          while ( fujaba__IterAbstractStateRevParamTypeUMLParam16.hasNext () )
                                          {
                                             try
                                             {
                                                uMLParam16 = (UMLParam) fujaba__IterAbstractStateRevParamTypeUMLParam16.next () ;
                                                 
                                                // check To-One-Link 'revParam' between uMLParam16 and setState
                                                JavaSDM.ensure ( (uMLParam16.getRevParam () != null) && uMLParam16.getRevParam ().equals (setState) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object context is really bound
                                                      JavaSDM.ensure ( context != null ) ;
                                                       
                                                      // check object abstractState is really bound
                                                      JavaSDM.ensure ( abstractState != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                       
                                                      // bind state: StateAnnotation
                                                      fujaba__IterAbstractStateAnnotationsState = abstractState.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterAbstractStateAnnotationsState.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractStateAnnotationsState.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof StateAnnotation ) ;
                                                            state = (StateAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between state and abstractState
                                                            JavaSDM.ensure ( state.hasInElements ("state", abstractState) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between state and context
                                                            JavaSDM.ensure ( state.hasInElements ("context", context) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object context is really bound
                                                         JavaSDM.ensure ( context != null ) ;
                                                          
                                                         // check object abstractState is really bound
                                                         JavaSDM.ensure ( abstractState != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                          
                                                         // check object request is really bound
                                                         JavaSDM.ensure ( request != null ) ;
                                                          
                                                         // check object handle is really bound
                                                         JavaSDM.ensure ( handle != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(request.equals (handle)) ) ;
                                                          
                                                         // check object setState is really bound
                                                         JavaSDM.ensure ( setState != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(request.equals (setState)) && !(handle.equals (setState)) ) ;
                                                          
                                                         // create object
                                                         state = new StateAnnotation ( ) ;
                                                          
                                                         // assign statement
                                                         state.setClassification (1);
                                                          
                                                         // create link
                                                         state.addToElements ("context", context);
                                                          
                                                         // create link
                                                         state.addToElements ("state", abstractState);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("request", request);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("context", context);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("abstractState", abstractState);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("handle", handle);
                                                          
                                                         // create link
                                                         state.addToBoundObjects ("setState", setState);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object overridingMethod13 is really bound
                                                         JavaSDM.ensure ( overridingMethod13 != null ) ;
                                                          
                                                         // check object neighborCall14 is really bound
                                                         JavaSDM.ensure ( neighborCall14 != null ) ;
                                                          
                                                         // check object reference15 is really bound
                                                         JavaSDM.ensure ( reference15 != null ) ;
                                                          
                                                         // check object state is really bound
                                                         JavaSDM.ensure ( state != null ) ;
                                                          
                                                         // create link
                                                         state.addToAntecedentAnnos (overridingMethod13);
                                                          
                                                         // create link
                                                         state.addToAntecedentAnnos (neighborCall14);
                                                          
                                                         // create link
                                                         state.addToAntecedentAnnos (reference15);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (state) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object state is really bound
            JavaSDM.ensure ( state != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_NeighborCall", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (state) ;
   }


   private GFRNAnnotation annotateUsingTrigger_OverridingMethodRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractStateAnnotationsReference3 = null ;
      Iterator fujaba__IterAbstractStateAnnotationsState = null ;
      Iterator fujaba__IterAbstractStateRevParamTypeUMLParam4 = null ;
      Iterator fujaba__IterHandleAnnotationsNeighborCall2 = null ;
      Iterator fujaba__IterNeighborCall2ElementsRequest = null ;
      Iterator fujaba__IterOverridingMethod1ElementsHandle = null ;
      NeighborCallAnnotation neighborCall2 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod1 = null ;
      ReferenceAnnotation reference3 = null ;
      StateAnnotation state = null ;
      UMLClass abstractState = null ;
      UMLClass context = null ;
      UMLMethod handle = null ;
      UMLMethod request = null ;
      UMLMethod setState = null ;
      UMLParam uMLParam4 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OverridingMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod1 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind handle: UMLMethod
            fujaba__IterOverridingMethod1ElementsHandle = overridingMethod1.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod1ElementsHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod1ElementsHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  handle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                   
                  // bind abstractState: UMLClass
                  abstractState = handle.getParent () ;
                  JavaSDM.ensure ( abstractState != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractState.isAbstract () == true) ) ;
                   
                  // bind neighborCall2: NeighborCallAnnotation
                  fujaba__IterHandleAnnotationsNeighborCall2 = handle.iteratorOfAnnotations () ;
                  while ( fujaba__IterHandleAnnotationsNeighborCall2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterHandleAnnotationsNeighborCall2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall2 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall2 and handle
                        JavaSDM.ensure ( neighborCall2.hasInElements ("callee", handle) ) ;
                         
                        // bind reference3: ReferenceAnnotation
                        fujaba__IterAbstractStateAnnotationsReference3 = abstractState.iteratorOfAnnotations () ;
                        while ( fujaba__IterAbstractStateAnnotationsReference3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAbstractStateAnnotationsReference3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference3 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference3 and abstractState
                              JavaSDM.ensure ( reference3.hasInElements ("references", abstractState) ) ;
                               
                              // bind uMLParam4: UMLParam
                              fujaba__IterAbstractStateRevParamTypeUMLParam4 = abstractState.iteratorOfRevParamType () ;
                              while ( fujaba__IterAbstractStateRevParamTypeUMLParam4.hasNext () )
                              {
                                 try
                                 {
                                    uMLParam4 = (UMLParam) fujaba__IterAbstractStateRevParamTypeUMLParam4.next () ;
                                     
                                    // bind setState: UMLMethod
                                    setState = uMLParam4.getRevParam () ;
                                    JavaSDM.ensure ( setState != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(handle.equals (setState)) ) ;
                                     
                                    // bind context: UMLClass
                                    context = setState.getParent () ;
                                    JavaSDM.ensure ( context != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(abstractState.equals (context)) ) ;
                                     
                                    // check To-Many-Link 'elements' between reference3 and context
                                    JavaSDM.ensure ( reference3.hasInElements ("referencingClass", context) ) ;
                                     
                                    // bind request: UMLMethod
                                    fujaba__IterNeighborCall2ElementsRequest = neighborCall2.iteratorOfElements ("caller") ;
                                    while ( fujaba__IterNeighborCall2ElementsRequest.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterNeighborCall2ElementsRequest.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          request = (UMLMethod) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(handle.equals (request)) && !(setState.equals (request)) ) ;
                                           
                                          // check To-One-Link 'parent' between request and context
                                          JavaSDM.ensure ( (request.getParent () != null) && request.getParent ().equals (context) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object context is really bound
                                                JavaSDM.ensure ( context != null ) ;
                                                 
                                                // check object abstractState is really bound
                                                JavaSDM.ensure ( abstractState != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                 
                                                // bind state: StateAnnotation
                                                fujaba__IterAbstractStateAnnotationsState = abstractState.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterAbstractStateAnnotationsState.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractStateAnnotationsState.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof StateAnnotation ) ;
                                                      state = (StateAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between state and abstractState
                                                      JavaSDM.ensure ( state.hasInElements ("state", abstractState) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between state and context
                                                      JavaSDM.ensure ( state.hasInElements ("context", context) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object context is really bound
                                                   JavaSDM.ensure ( context != null ) ;
                                                    
                                                   // check object abstractState is really bound
                                                   JavaSDM.ensure ( abstractState != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                    
                                                   // check object request is really bound
                                                   JavaSDM.ensure ( request != null ) ;
                                                    
                                                   // check object handle is really bound
                                                   JavaSDM.ensure ( handle != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(request.equals (handle)) ) ;
                                                    
                                                   // check object setState is really bound
                                                   JavaSDM.ensure ( setState != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(request.equals (setState)) && !(handle.equals (setState)) ) ;
                                                    
                                                   // create object
                                                   state = new StateAnnotation ( ) ;
                                                    
                                                   // assign statement
                                                   state.setClassification (1);
                                                    
                                                   // create link
                                                   state.addToElements ("context", context);
                                                    
                                                   // create link
                                                   state.addToElements ("state", abstractState);
                                                    
                                                   // create link
                                                   state.addToBoundObjects ("request", request);
                                                    
                                                   // create link
                                                   state.addToBoundObjects ("context", context);
                                                    
                                                   // create link
                                                   state.addToBoundObjects ("abstractState", abstractState);
                                                    
                                                   // create link
                                                   state.addToBoundObjects ("handle", handle);
                                                    
                                                   // create link
                                                   state.addToBoundObjects ("setState", setState);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object overridingMethod1 is really bound
                                                   JavaSDM.ensure ( overridingMethod1 != null ) ;
                                                    
                                                   // check object neighborCall2 is really bound
                                                   JavaSDM.ensure ( neighborCall2 != null ) ;
                                                    
                                                   // check object reference3 is really bound
                                                   JavaSDM.ensure ( reference3 != null ) ;
                                                    
                                                   // check object state is really bound
                                                   JavaSDM.ensure ( state != null ) ;
                                                    
                                                   // create link
                                                   state.addToAntecedentAnnos (overridingMethod1);
                                                    
                                                   // create link
                                                   state.addToAntecedentAnnos (neighborCall2);
                                                    
                                                   // create link
                                                   state.addToAntecedentAnnos (reference3);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (state) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object state is really bound
            JavaSDM.ensure ( state != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_OverridingMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (state) ;
   }


   private GFRNAnnotation annotateUsingTrigger_ReferenceRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractStateAnnotationsState = null ;
      Iterator fujaba__IterAbstractStateMethodsHandle = null ;
      Iterator fujaba__IterAbstractStateRevParamTypeUMLParam20 = null ;
      Iterator fujaba__IterContextMethodsRequest = null ;
      Iterator fujaba__IterContextMethodsSetState = null ;
      Iterator fujaba__IterHandleAnnotationsOverridingMethod17 = null ;
      Iterator fujaba__IterReference19ElementsAbstractState = null ;
      Iterator fujaba__IterReference19ElementsContext = null ;
      Iterator fujaba__IterRequestAnnotationsNeighborCall18 = null ;
      NeighborCallAnnotation neighborCall18 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod17 = null ;
      ReferenceAnnotation reference19 = null ;
      StateAnnotation state = null ;
      UMLClass abstractState = null ;
      UMLClass context = null ;
      UMLMethod handle = null ;
      UMLMethod request = null ;
      UMLMethod setState = null ;
      UMLParam uMLParam20 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Reference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind context: UMLClass
            fujaba__IterReference19ElementsContext = reference19.iteratorOfElements ("referencingClass") ;
            while ( fujaba__IterReference19ElementsContext.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference19ElementsContext.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  context = (UMLClass) fujaba__TmpObject ;
                   
                  // bind abstractState: UMLClass
                  fujaba__IterReference19ElementsAbstractState = reference19.iteratorOfElements ("references") ;
                  while ( fujaba__IterReference19ElementsAbstractState.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference19ElementsAbstractState.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        abstractState = (UMLClass) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (abstractState.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                         
                        // bind request: UMLMethod
                        fujaba__IterContextMethodsRequest = context.iteratorOfMethods () ;
                        while ( fujaba__IterContextMethodsRequest.hasNext () )
                        {
                           try
                           {
                              request = (UMLMethod) fujaba__IterContextMethodsRequest.next () ;
                               
                              // bind setState: UMLMethod
                              fujaba__IterContextMethodsSetState = context.iteratorOfMethods () ;
                              while ( fujaba__IterContextMethodsSetState.hasNext () )
                              {
                                 try
                                 {
                                    setState = (UMLMethod) fujaba__IterContextMethodsSetState.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(request.equals (setState)) ) ;
                                     
                                    // bind handle: UMLMethod
                                    fujaba__IterAbstractStateMethodsHandle = abstractState.iteratorOfMethods () ;
                                    while ( fujaba__IterAbstractStateMethodsHandle.hasNext () )
                                    {
                                       try
                                       {
                                          handle = (UMLMethod) fujaba__IterAbstractStateMethodsHandle.next () ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(request.equals (handle)) && !(setState.equals (handle)) ) ;
                                           
                                          // bind uMLParam20: UMLParam
                                          fujaba__IterAbstractStateRevParamTypeUMLParam20 = abstractState.iteratorOfRevParamType () ;
                                          while ( fujaba__IterAbstractStateRevParamTypeUMLParam20.hasNext () )
                                          {
                                             try
                                             {
                                                uMLParam20 = (UMLParam) fujaba__IterAbstractStateRevParamTypeUMLParam20.next () ;
                                                 
                                                // check To-One-Link 'revParam' between uMLParam20 and setState
                                                JavaSDM.ensure ( (uMLParam20.getRevParam () != null) && uMLParam20.getRevParam ().equals (setState) ) ;
                                                 
                                                // bind neighborCall18: NeighborCallAnnotation
                                                fujaba__IterRequestAnnotationsNeighborCall18 = request.iteratorOfAnnotations () ;
                                                while ( fujaba__IterRequestAnnotationsNeighborCall18.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterRequestAnnotationsNeighborCall18.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall18 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall18 and request
                                                      JavaSDM.ensure ( neighborCall18.hasInElements ("caller", request) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall18 and handle
                                                      JavaSDM.ensure ( neighborCall18.hasInElements ("callee", handle) ) ;
                                                       
                                                      // bind overridingMethod17: OverridingMethodAnnotation
                                                      fujaba__IterHandleAnnotationsOverridingMethod17 = handle.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterHandleAnnotationsOverridingMethod17.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterHandleAnnotationsOverridingMethod17.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                            overridingMethod17 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between overridingMethod17 and handle
                                                            JavaSDM.ensure ( overridingMethod17.hasInElements ("overridden", handle) ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object context is really bound
                                                                  JavaSDM.ensure ( context != null ) ;
                                                                   
                                                                  // check object abstractState is really bound
                                                                  JavaSDM.ensure ( abstractState != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                                   
                                                                  // bind state: StateAnnotation
                                                                  fujaba__IterAbstractStateAnnotationsState = abstractState.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterAbstractStateAnnotationsState.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterAbstractStateAnnotationsState.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof StateAnnotation ) ;
                                                                        state = (StateAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between state and abstractState
                                                                        JavaSDM.ensure ( state.hasInElements ("state", abstractState) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between state and context
                                                                        JavaSDM.ensure ( state.hasInElements ("context", context) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object context is really bound
                                                                     JavaSDM.ensure ( context != null ) ;
                                                                      
                                                                     // check object abstractState is really bound
                                                                     JavaSDM.ensure ( abstractState != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                                                                      
                                                                     // check object request is really bound
                                                                     JavaSDM.ensure ( request != null ) ;
                                                                      
                                                                     // check object handle is really bound
                                                                     JavaSDM.ensure ( handle != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(request.equals (handle)) ) ;
                                                                      
                                                                     // check object setState is really bound
                                                                     JavaSDM.ensure ( setState != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(request.equals (setState)) && !(handle.equals (setState)) ) ;
                                                                      
                                                                     // create object
                                                                     state = new StateAnnotation ( ) ;
                                                                      
                                                                     // assign statement
                                                                     state.setClassification (1);
                                                                      
                                                                     // create link
                                                                     state.addToElements ("context", context);
                                                                      
                                                                     // create link
                                                                     state.addToElements ("state", abstractState);
                                                                      
                                                                     // create link
                                                                     state.addToBoundObjects ("request", request);
                                                                      
                                                                     // create link
                                                                     state.addToBoundObjects ("context", context);
                                                                      
                                                                     // create link
                                                                     state.addToBoundObjects ("abstractState", abstractState);
                                                                      
                                                                     // create link
                                                                     state.addToBoundObjects ("handle", handle);
                                                                      
                                                                     // create link
                                                                     state.addToBoundObjects ("setState", setState);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object overridingMethod17 is really bound
                                                                     JavaSDM.ensure ( overridingMethod17 != null ) ;
                                                                      
                                                                     // check object neighborCall18 is really bound
                                                                     JavaSDM.ensure ( neighborCall18 != null ) ;
                                                                      
                                                                     // check object reference19 is really bound
                                                                     JavaSDM.ensure ( reference19 != null ) ;
                                                                      
                                                                     // check object state is really bound
                                                                     JavaSDM.ensure ( state != null ) ;
                                                                      
                                                                     // create link
                                                                     state.addToAntecedentAnnos (overridingMethod17);
                                                                      
                                                                     // create link
                                                                     state.addToAntecedentAnnos (neighborCall18);
                                                                      
                                                                     // create link
                                                                     state.addToAntecedentAnnos (reference19);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (state) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object state is really bound
            JavaSDM.ensure ( state != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Reference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (state) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("context", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("state", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_OverridingMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_NeighborCall", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractStateMethodsHandle = null ;
      Iterator fujaba__IterContextMethodsRequest = null ;
      Iterator fujaba__IterContextMethodsSetState = null ;
      Iterator fujaba__IterNeighborCall21ElementsHandle = null ;
      Iterator fujaba__IterNeighborCall21ElementsRequest = null ;
      Iterator fujaba__IterNeighborCall23ElementsHandle = null ;
      Iterator fujaba__IterNeighborCall23ElementsRequest = null ;
      Iterator fujaba__IterOverridingMethod17ElementsHandle = null ;
      Iterator fujaba__IterReference19ElementsContext = null ;
      Iterator fujaba__IterRequestAnnotationsNeighborCall21 = null ;
      Iterator fujaba__IterRequestAnnotationsNeighborCall23 = null ;
      Iterator fujaba__IterSetStateParamUMLParam22 = null ;
      NeighborCallAnnotation neighborCall21 = null ;
      NeighborCallAnnotation neighborCall23 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod17 = null ;
      ReferenceAnnotation reference19 = null ;
      UMLClass abstractState = null ;
      UMLClass context = null ;
      UMLMethod handle = null ;
      UMLMethod request = null ;
      UMLMethod setState = null ;
      UMLParam uMLParam22 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            context = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind request: UMLMethod
            fujaba__IterContextMethodsRequest = context.iteratorOfMethods () ;
            while ( fujaba__IterContextMethodsRequest.hasNext () )
            {
               try
               {
                  request = (UMLMethod) fujaba__IterContextMethodsRequest.next () ;
                   
                  // bind neighborCall21: NeighborCallAnnotation
                  fujaba__IterRequestAnnotationsNeighborCall21 = request.iteratorOfAnnotations () ;
                  while ( fujaba__IterRequestAnnotationsNeighborCall21.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterRequestAnnotationsNeighborCall21.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall21 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall21 and request
                        JavaSDM.ensure ( neighborCall21.hasInElements ("caller", request) ) ;
                         
                        // bind handle: UMLMethod
                        fujaba__IterNeighborCall21ElementsHandle = neighborCall21.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall21ElementsHandle.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall21ElementsHandle.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              handle = (UMLMethod) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(request.equals (handle)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (handle);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractState = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind handle: UMLMethod
            fujaba__IterAbstractStateMethodsHandle = abstractState.iteratorOfMethods () ;
            while ( fujaba__IterAbstractStateMethodsHandle.hasNext () )
            {
               try
               {
                  handle = (UMLMethod) fujaba__IterAbstractStateMethodsHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (handle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall21 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind request: UMLMethod
            fujaba__IterNeighborCall21ElementsRequest = neighborCall21.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall21ElementsRequest.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall21ElementsRequest.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  request = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind context: UMLClass
                  context = request.getParent () ;
                  JavaSDM.ensure ( context != null ) ;
                   
                  // bind setState: UMLMethod
                  fujaba__IterContextMethodsSetState = context.iteratorOfMethods () ;
                  while ( fujaba__IterContextMethodsSetState.hasNext () )
                  {
                     try
                     {
                        setState = (UMLMethod) fujaba__IterContextMethodsSetState.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(request.equals (setState)) ) ;
                         
                        // bind uMLParam22: UMLParam
                        fujaba__IterSetStateParamUMLParam22 = setState.iteratorOfParam () ;
                        while ( fujaba__IterSetStateParamUMLParam22.hasNext () )
                        {
                           try
                           {
                              uMLParam22 = (UMLParam) fujaba__IterSetStateParamUMLParam22.next () ;
                               
                              // bind abstractState: UMLClass
                              fujaba__TmpObject = uMLParam22.getParamType () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              abstractState = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (abstractState.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(context.equals (abstractState)) ) ;
                               
                              // bind handle: UMLMethod
                              fujaba__IterAbstractStateMethodsHandle = abstractState.iteratorOfMethods () ;
                              while ( fujaba__IterAbstractStateMethodsHandle.hasNext () )
                              {
                                 try
                                 {
                                    handle = (UMLMethod) fujaba__IterAbstractStateMethodsHandle.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(request.equals (handle)) && !(setState.equals (handle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (handle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind context: UMLClass
            fujaba__IterReference19ElementsContext = reference19.iteratorOfElements ("referencingClass") ;
            while ( fujaba__IterReference19ElementsContext.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference19ElementsContext.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  context = (UMLClass) fujaba__TmpObject ;
                   
                  // bind request: UMLMethod
                  fujaba__IterContextMethodsRequest = context.iteratorOfMethods () ;
                  while ( fujaba__IterContextMethodsRequest.hasNext () )
                  {
                     try
                     {
                        request = (UMLMethod) fujaba__IterContextMethodsRequest.next () ;
                         
                        // bind neighborCall23: NeighborCallAnnotation
                        fujaba__IterRequestAnnotationsNeighborCall23 = request.iteratorOfAnnotations () ;
                        while ( fujaba__IterRequestAnnotationsNeighborCall23.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterRequestAnnotationsNeighborCall23.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall23 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall23 and request
                              JavaSDM.ensure ( neighborCall23.hasInElements ("caller", request) ) ;
                               
                              // bind handle: UMLMethod
                              fujaba__IterNeighborCall23ElementsHandle = neighborCall23.iteratorOfElements ("callee") ;
                              while ( fujaba__IterNeighborCall23ElementsHandle.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall23ElementsHandle.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    handle = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(request.equals (handle)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (handle);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") || annotation.equals ("Delegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            context = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind request: UMLMethod
            fujaba__IterContextMethodsRequest = context.iteratorOfMethods () ;
            while ( fujaba__IterContextMethodsRequest.hasNext () )
            {
               try
               {
                  request = (UMLMethod) fujaba__IterContextMethodsRequest.next () ;
                   
                  {
                     //  for each flow
                     set.add (request);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractState = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind handle: UMLMethod
            fujaba__IterAbstractStateMethodsHandle = abstractState.iteratorOfMethods () ;
            while ( fujaba__IterAbstractStateMethodsHandle.hasNext () )
            {
               try
               {
                  handle = (UMLMethod) fujaba__IterAbstractStateMethodsHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (handle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod17 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind handle: UMLMethod
            fujaba__IterOverridingMethod17ElementsHandle = overridingMethod17.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod17ElementsHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod17ElementsHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  handle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (handle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference19 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind context: UMLClass
            fujaba__IterReference19ElementsContext = reference19.iteratorOfElements ("referencingClass") ;
            while ( fujaba__IterReference19ElementsContext.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference19ElementsContext.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  context = (UMLClass) fujaba__TmpObject ;
                   
                  // bind request: UMLMethod
                  fujaba__IterContextMethodsRequest = context.iteratorOfMethods () ;
                  while ( fujaba__IterContextMethodsRequest.hasNext () )
                  {
                     try
                     {
                        request = (UMLMethod) fujaba__IterContextMethodsRequest.next () ;
                         
                        {
                           //  for each flow
                           set.add (request);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") || annotation.equals ("MultiReference") || annotation.equals ("ArrayReference") || annotation.equals ("SingleReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            context = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (context);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractState = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractState);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OverridingMethodAnnotation ) ;
             
            // explicit type cast
            overridingMethod17 = (OverridingMethodAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind handle: UMLMethod
            fujaba__IterOverridingMethod17ElementsHandle = overridingMethod17.iteratorOfElements ("overridden") ;
            while ( fujaba__IterOverridingMethod17ElementsHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOverridingMethod17ElementsHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  handle = (UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (handle.isAbstract () == true) ) ;
                   
                  // bind abstractState: UMLClass
                  abstractState = handle.getParent () ;
                  JavaSDM.ensure ( abstractState != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractState.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractState);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall23 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind request: UMLMethod
            fujaba__IterNeighborCall23ElementsRequest = neighborCall23.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall23ElementsRequest.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall23ElementsRequest.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  request = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind context: UMLClass
                  context = request.getParent () ;
                  JavaSDM.ensure ( context != null ) ;
                   
                  {
                     //  for each flow
                     set.add (context);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
