package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class NormalMediatorEngine
extends GFRNEngine
{
   private  NormalMediatorEngine()
   {
   }

   private static NormalMediatorEngine theNormalMediatorEngine;

   public static NormalMediatorEngine get()
   {
      if (theNormalMediatorEngine == null)
      {
         theNormalMediatorEngine = new NormalMediatorEngine ();
      }
      return theNormalMediatorEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      GFRNAnnotation normalMediator = null;
      try
      {
         fujaba__Success = false ;
          
         // collabStatBegin 1 is empty !
         normalMediator = this.annotateUsingMediatorRole(asgElement);
          
         // collabStatEnd
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      try
      {
         fujaba__Success = false ;
          
         // constraint
         JavaSDM.ensure ( normalMediator != null ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
         return (normalMediator) ;
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            // collabStatBegin 1 is empty !
            normalMediator = this.annotateUsingTrigger_NeighborCallRole(asgElement);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // constraint
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
            return (normalMediator) ;
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // collabStatBegin 1 is empty !
               normalMediator = this.annotateUsingTrigger_GeneralizationRole(asgElement);
                
               // collabStatEnd
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            try
            {
               fujaba__Success = false ;
                
               // constraint
               JavaSDM.ensure ( normalMediator != null ) ;
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
            if ( fujaba__Success )
            {
               return (normalMediator) ;
            }
            else
            {
               try
               {
                  fujaba__Success = false ;
                   
                  // collabStatBegin 1 is empty !
                  normalMediator = this.annotateUsingTrigger_NeighborCallRole(asgElement);
                   
                  // collabStatEnd
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               try
               {
                  fujaba__Success = false ;
                   
                  // constraint
                  JavaSDM.ensure ( normalMediator != null ) ;
                   
                  fujaba__Success = true ;
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( fujaba__Success )
               {
                  return (normalMediator) ;
               }
               else
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // collabStatBegin 1 is empty !
                     normalMediator = this.annotateUsingColleagueRole(asgElement);
                      
                     // collabStatEnd
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  try
                  {
                     fujaba__Success = false ;
                      
                     // constraint
                     JavaSDM.ensure ( normalMediator != null ) ;
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  if ( fujaba__Success )
                  {
                     return (normalMediator) ;
                  }
                  else
                  {
                     try
                     {
                        fujaba__Success = false ;
                         
                        // collabStatBegin 1 is empty !
                        normalMediator = this.annotateUsingTrigger_GeneralizationRole(asgElement);
                         
                        // collabStatEnd
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     try
                     {
                        fujaba__Success = false ;
                         
                        // constraint
                        JavaSDM.ensure ( normalMediator != null ) ;
                         
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( fujaba__Success )
                     {
                        return (normalMediator) ;
                     }
                     else
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // collabStatBegin 1 is empty !
                           normalMediator = this.annotateUsingTrigger_NeighborCallRole(asgElement);
                            
                           // collabStatEnd
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        return (normalMediator) ;
                     }
                  }
               }
            }
         }
      }
   }


   private GFRNAnnotation annotateUsingColleagueRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization40 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization43 = null ;
      Iterator fujaba__IterColleagueAnnotationsNormalMediator = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod42 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod39 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod44 = null ;
      Iterator fujaba__IterGeneralization40ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization43ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterMediatorMethodsM1 = null ;
      Iterator fujaba__IterMediatorMethodsM2 = null ;
      Iterator fujaba__IterNeighborCall41ElementsUMLMethod37 = null ;
      Iterator fujaba__IterUMLMethod39AnnotationsNeighborCall38 = null ;
      Iterator fujaba__IterUMLMethod42AnnotationsNeighborCall41 = null ;
      Iterator fujaba__IterUMLMethod44AnnotationsNeighborCall45 = null ;
      GeneralizationAnnotation generalization40 = null ;
      GeneralizationAnnotation generalization43 = null ;
      NeighborCallAnnotation neighborCall38 = null ;
      NeighborCallAnnotation neighborCall41 = null ;
      NeighborCallAnnotation neighborCall45 = null ;
      NormalMediatorAnnotation normalMediator = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass colleague = null ;
      UMLClass concreteColleague1 = null ;
      UMLClass concreteColleague2 = null ;
      UMLClass mediator = null ;
      UMLMethod m1 = null ;
      UMLMethod m2 = null ;
      UMLMethod uMLMethod37 = null ;
      UMLMethod uMLMethod39 = null ;
      UMLMethod uMLMethod42 = null ;
      UMLMethod uMLMethod44 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("colleague", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
             
            // bind uMLMethod42: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod42 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod42.hasNext () )
            {
               try
               {
                  uMLMethod42 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod42.next () ;
                   
                  // bind generalization40: GeneralizationAnnotation
                  fujaba__IterColleagueAnnotationsGeneralization40 = colleague.iteratorOfAnnotations () ;
                  while ( fujaba__IterColleagueAnnotationsGeneralization40.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization40.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization40 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization40 and colleague
                        JavaSDM.ensure ( generalization40.hasInElements ("superClass", colleague) ) ;
                         
                        // bind generalization43: GeneralizationAnnotation
                        fujaba__IterColleagueAnnotationsGeneralization43 = colleague.iteratorOfAnnotations () ;
                        while ( fujaba__IterColleagueAnnotationsGeneralization43.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization43.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization43 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization43 and colleague
                              JavaSDM.ensure ( generalization43.hasInElements ("superClass", colleague) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(generalization40.equals (generalization43)) ) ;
                               
                              // bind neighborCall41: NeighborCallAnnotation
                              fujaba__IterUMLMethod42AnnotationsNeighborCall41 = uMLMethod42.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod42AnnotationsNeighborCall41.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod42AnnotationsNeighborCall41.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall41 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall41 and uMLMethod42
                                    JavaSDM.ensure ( neighborCall41.hasInElements ("caller", uMLMethod42) ) ;
                                     
                                    // bind concreteColleague1: UMLClass
                                    fujaba__IterGeneralization40ElementsConcreteColleague1 = generalization40.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization40ElementsConcreteColleague1.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization40ElementsConcreteColleague1.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(colleague.equals (concreteColleague1)) ) ;
                                           
                                          // bind concreteColleague2: UMLClass
                                          fujaba__IterGeneralization43ElementsConcreteColleague2 = generalization43.iteratorOfElements ("subClass") ;
                                          while ( fujaba__IterGeneralization43ElementsConcreteColleague2.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization43ElementsConcreteColleague2.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                concreteColleague2 = (UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(concreteColleague1.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                                 
                                                // bind uMLMethod37: UMLMethod
                                                fujaba__IterNeighborCall41ElementsUMLMethod37 = neighborCall41.iteratorOfElements ("callee") ;
                                                while ( fujaba__IterNeighborCall41ElementsUMLMethod37.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall41ElementsUMLMethod37.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod37 = (UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod42.equals (uMLMethod37)) ) ;
                                                       
                                                      // bind mediator: UMLClass
                                                      mediator = uMLMethod37.getParent () ;
                                                      JavaSDM.ensure ( mediator != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(concreteColleague1.equals (mediator)) && !(colleague.equals (mediator)) && !(concreteColleague2.equals (mediator)) ) ;
                                                       
                                                      // bind uMLMethod39: UMLMethod
                                                      fujaba__IterConcreteColleague1MethodsUMLMethod39 = concreteColleague1.iteratorOfMethods () ;
                                                      while ( fujaba__IterConcreteColleague1MethodsUMLMethod39.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            uMLMethod39 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod39.next () ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(uMLMethod37.equals (uMLMethod39)) && !(uMLMethod42.equals (uMLMethod39)) ) ;
                                                             
                                                            // bind uMLMethod44: UMLMethod
                                                            fujaba__IterConcreteColleague2MethodsUMLMethod44 = concreteColleague2.iteratorOfMethods () ;
                                                            while ( fujaba__IterConcreteColleague2MethodsUMLMethod44.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  uMLMethod44 = (UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod44.next () ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLMethod37.equals (uMLMethod44)) && !(uMLMethod39.equals (uMLMethod44)) && !(uMLMethod42.equals (uMLMethod44)) ) ;
                                                                   
                                                                  // bind m1: UMLMethod
                                                                  fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                                                                  while ( fujaba__IterMediatorMethodsM1.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        m1 = (UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(uMLMethod37.equals (m1)) && !(uMLMethod39.equals (m1)) && !(uMLMethod42.equals (m1)) && !(uMLMethod44.equals (m1)) ) ;
                                                                         
                                                                        // bind m2: UMLMethod
                                                                        fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                                                                        while ( fujaba__IterMediatorMethodsM2.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(uMLMethod37.equals (m2)) && !(uMLMethod39.equals (m2)) && !(uMLMethod42.equals (m2)) && !(uMLMethod44.equals (m2)) ) ;
                                                                               
                                                                              // bind neighborCall38: NeighborCallAnnotation
                                                                              fujaba__IterUMLMethod39AnnotationsNeighborCall38 = uMLMethod39.iteratorOfAnnotations () ;
                                                                              while ( fujaba__IterUMLMethod39AnnotationsNeighborCall38.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    fujaba__TmpObject = fujaba__IterUMLMethod39AnnotationsNeighborCall38.next () ;
                                                                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                                                    neighborCall38 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                                                     
                                                                                    // check Reverse-Qualified-Link 'elements' between neighborCall38 and uMLMethod39
                                                                                    JavaSDM.ensure ( neighborCall38.hasInElements ("callee", uMLMethod39) ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(neighborCall41.equals (neighborCall38)) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between neighborCall38 and m1
                                                                                    JavaSDM.ensure ( neighborCall38.hasInElements ("caller", m1) ) ;
                                                                                     
                                                                                    // bind neighborCall45: NeighborCallAnnotation
                                                                                    fujaba__IterUMLMethod44AnnotationsNeighborCall45 = uMLMethod44.iteratorOfAnnotations () ;
                                                                                    while ( fujaba__IterUMLMethod44AnnotationsNeighborCall45.hasNext () )
                                                                                    {
                                                                                       try
                                                                                       {
                                                                                          fujaba__TmpObject = fujaba__IterUMLMethod44AnnotationsNeighborCall45.next () ;
                                                                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                                                          neighborCall45 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                                                           
                                                                                          // check Reverse-Qualified-Link 'elements' between neighborCall45 and uMLMethod44
                                                                                          JavaSDM.ensure ( neighborCall45.hasInElements ("callee", uMLMethod44) ) ;
                                                                                           
                                                                                          // check isomorphic binding
                                                                                          JavaSDM.ensure ( !(neighborCall38.equals (neighborCall45)) && !(neighborCall41.equals (neighborCall45)) ) ;
                                                                                           
                                                                                          // check To-Many-Link 'elements' between neighborCall45 and m2
                                                                                          JavaSDM.ensure ( neighborCall45.hasInElements ("caller", m2) ) ;
                                                                                           
                                                                                          {
                                                                                             //  for each flow
                                                                                             try
                                                                                             {
                                                                                                fujaba__Success = false ;
                                                                                                 
                                                                                                // check object mediator is really bound
                                                                                                JavaSDM.ensure ( mediator != null ) ;
                                                                                                 
                                                                                                // check object colleague is really bound
                                                                                                JavaSDM.ensure ( colleague != null ) ;
                                                                                                 
                                                                                                // check isomorphic binding
                                                                                                JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                                 
                                                                                                // bind normalMediator: NormalMediatorAnnotation
                                                                                                fujaba__IterColleagueAnnotationsNormalMediator = colleague.iteratorOfAnnotations () ;
                                                                                                while ( !(fujaba__Success) && fujaba__IterColleagueAnnotationsNormalMediator.hasNext () )
                                                                                                {
                                                                                                   try
                                                                                                   {
                                                                                                      fujaba__TmpObject = fujaba__IterColleagueAnnotationsNormalMediator.next () ;
                                                                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NormalMediatorAnnotation ) ;
                                                                                                      normalMediator = (NormalMediatorAnnotation) fujaba__TmpObject ;
                                                                                                       
                                                                                                      // check Reverse-Qualified-Link 'elements' between normalMediator and colleague
                                                                                                      JavaSDM.ensure ( normalMediator.hasInElements ("colleague", colleague) ) ;
                                                                                                       
                                                                                                      // check To-Many-Link 'elements' between normalMediator and mediator
                                                                                                      JavaSDM.ensure ( normalMediator.hasInElements ("mediator", mediator) ) ;
                                                                                                       
                                                                                                      fujaba__Success = true ;
                                                                                                   }
                                                                                                   catch ( JavaSDMException fujaba__InternalException )
                                                                                                   {
                                                                                                   }
                                                                                                }
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                                fujaba__Success = false ;
                                                                                             }
                                                                                              
                                                                                             if ( !(fujaba__Success) )
                                                                                             {
                                                                                                try
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                    
                                                                                                   // check object mediator is really bound
                                                                                                   JavaSDM.ensure ( mediator != null ) ;
                                                                                                    
                                                                                                   // check object colleague is really bound
                                                                                                   JavaSDM.ensure ( colleague != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                                    
                                                                                                   // check object m1 is really bound
                                                                                                   JavaSDM.ensure ( m1 != null ) ;
                                                                                                    
                                                                                                   // check object concreteColleague1 is really bound
                                                                                                   JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                                                                    
                                                                                                   // check object concreteColleague2 is really bound
                                                                                                   JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                                                    
                                                                                                   // check object m2 is really bound
                                                                                                   JavaSDM.ensure ( m2 != null ) ;
                                                                                                    
                                                                                                   // create object
                                                                                                   normalMediator = new NormalMediatorAnnotation ( ) ;
                                                                                                    
                                                                                                   // assign statement
                                                                                                   normalMediator.setClassification (1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToElements ("mediator", mediator);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToElements ("colleague", colleague);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("mediator", mediator);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("m1", m1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("concreteColleague1", concreteColleague1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("colleague", colleague);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("concreteColleague2", concreteColleague2);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("m2", m2);
                                                                                                    
                                                                                                   fujaba__Success = true ;
                                                                                                }
                                                                                                catch ( JavaSDMException fujaba__InternalException )
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                }
                                                                                                 
                                                                                                try
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                    
                                                                                                   // check object neighborCall38 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall38 != null ) ;
                                                                                                    
                                                                                                   // check object generalization40 is really bound
                                                                                                   JavaSDM.ensure ( generalization40 != null ) ;
                                                                                                    
                                                                                                   // check object neighborCall41 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall41 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(neighborCall38.equals (neighborCall41)) ) ;
                                                                                                    
                                                                                                   // check object generalization43 is really bound
                                                                                                   JavaSDM.ensure ( generalization43 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(generalization40.equals (generalization43)) ) ;
                                                                                                    
                                                                                                   // check object neighborCall45 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall45 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(neighborCall38.equals (neighborCall45)) && !(neighborCall41.equals (neighborCall45)) ) ;
                                                                                                    
                                                                                                   // check object normalMediator is really bound
                                                                                                   JavaSDM.ensure ( normalMediator != null ) ;
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall38);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (generalization40);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall41);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (generalization43);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall45);
                                                                                                    
                                                                                                   fujaba__Success = true ;
                                                                                                }
                                                                                                catch ( JavaSDMException fujaba__InternalException )
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                }
                                                                                                 
                                                                                                return (normalMediator) ;
                                                                                             }
                                                                                          } //  end for each flow
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                       }
                                                                                    }
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object normalMediator is really bound
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("colleague", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (normalMediator) ;
   }


   private GFRNAnnotation annotateUsingMediatorRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization4 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization7 = null ;
      Iterator fujaba__IterColleagueAnnotationsNormalMediator = null ;
      Iterator fujaba__IterM1AnnotationsNeighborCall2 = null ;
      Iterator fujaba__IterM2AnnotationsNeighborCall9 = null ;
      Iterator fujaba__IterMediatorMethodsM1 = null ;
      Iterator fujaba__IterMediatorMethodsM2 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod1 = null ;
      Iterator fujaba__IterNeighborCall2ElementsUMLMethod3 = null ;
      Iterator fujaba__IterNeighborCall5ElementsUMLMethod6 = null ;
      Iterator fujaba__IterNeighborCall9ElementsUMLMethod8 = null ;
      Iterator fujaba__IterUMLMethod1AnnotationsNeighborCall5 = null ;
      GeneralizationAnnotation generalization4 = null ;
      GeneralizationAnnotation generalization7 = null ;
      NeighborCallAnnotation neighborCall2 = null ;
      NeighborCallAnnotation neighborCall5 = null ;
      NeighborCallAnnotation neighborCall9 = null ;
      NormalMediatorAnnotation normalMediator = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass colleague = null ;
      UMLClass concreteColleague1 = null ;
      UMLClass concreteColleague2 = null ;
      UMLClass mediator = null ;
      UMLMethod m1 = null ;
      UMLMethod m2 = null ;
      UMLMethod uMLMethod1 = null ;
      UMLMethod uMLMethod3 = null ;
      UMLMethod uMLMethod6 = null ;
      UMLMethod uMLMethod8 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("mediator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod1: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod1 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod1.hasNext () )
            {
               try
               {
                  uMLMethod1 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod1.next () ;
                   
                  // bind m1: UMLMethod
                  fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsM1.hasNext () )
                  {
                     try
                     {
                        m1 = (UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod1.equals (m1)) ) ;
                         
                        // bind m2: UMLMethod
                        fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                        while ( fujaba__IterMediatorMethodsM2.hasNext () )
                        {
                           try
                           {
                              m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod1.equals (m2)) ) ;
                               
                              // bind neighborCall5: NeighborCallAnnotation
                              fujaba__IterUMLMethod1AnnotationsNeighborCall5 = uMLMethod1.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod1AnnotationsNeighborCall5.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod1AnnotationsNeighborCall5.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall5 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall5 and uMLMethod1
                                    JavaSDM.ensure ( neighborCall5.hasInElements ("callee", uMLMethod1) ) ;
                                     
                                    // bind neighborCall2: NeighborCallAnnotation
                                    fujaba__IterM1AnnotationsNeighborCall2 = m1.iteratorOfAnnotations () ;
                                    while ( fujaba__IterM1AnnotationsNeighborCall2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterM1AnnotationsNeighborCall2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall2 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall2 and m1
                                          JavaSDM.ensure ( neighborCall2.hasInElements ("caller", m1) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(neighborCall5.equals (neighborCall2)) ) ;
                                           
                                          // bind neighborCall9: NeighborCallAnnotation
                                          fujaba__IterM2AnnotationsNeighborCall9 = m2.iteratorOfAnnotations () ;
                                          while ( fujaba__IterM2AnnotationsNeighborCall9.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterM2AnnotationsNeighborCall9.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall9 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall9 and m2
                                                JavaSDM.ensure ( neighborCall9.hasInElements ("caller", m2) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(neighborCall2.equals (neighborCall9)) && !(neighborCall5.equals (neighborCall9)) ) ;
                                                 
                                                // bind uMLMethod6: UMLMethod
                                                fujaba__IterNeighborCall5ElementsUMLMethod6 = neighborCall5.iteratorOfElements ("caller") ;
                                                while ( fujaba__IterNeighborCall5ElementsUMLMethod6.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall5ElementsUMLMethod6.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod6 = (UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod6)) && !(m1.equals (uMLMethod6)) && !(m2.equals (uMLMethod6)) ) ;
                                                       
                                                      // bind colleague: UMLClass
                                                      colleague = uMLMethod6.getParent () ;
                                                      JavaSDM.ensure ( colleague != null ) ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                       
                                                      // bind uMLMethod3: UMLMethod
                                                      fujaba__IterNeighborCall2ElementsUMLMethod3 = neighborCall2.iteratorOfElements ("callee") ;
                                                      while ( fujaba__IterNeighborCall2ElementsUMLMethod3.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterNeighborCall2ElementsUMLMethod3.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                            uMLMethod3 = (UMLMethod) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod3)) && !(m1.equals (uMLMethod3)) && !(uMLMethod6.equals (uMLMethod3)) && !(m2.equals (uMLMethod3)) ) ;
                                                             
                                                            // bind concreteColleague1: UMLClass
                                                            concreteColleague1 = uMLMethod3.getParent () ;
                                                            JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                             
                                                            // bind uMLMethod8: UMLMethod
                                                            fujaba__IterNeighborCall9ElementsUMLMethod8 = neighborCall9.iteratorOfElements ("callee") ;
                                                            while ( fujaba__IterNeighborCall9ElementsUMLMethod8.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterNeighborCall9ElementsUMLMethod8.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                  uMLMethod8 = (UMLMethod) fujaba__TmpObject ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod8)) && !(m1.equals (uMLMethod8)) && !(uMLMethod3.equals (uMLMethod8)) && !(uMLMethod6.equals (uMLMethod8)) && !(m2.equals (uMLMethod8)) ) ;
                                                                   
                                                                  // bind concreteColleague2: UMLClass
                                                                  concreteColleague2 = uMLMethod8.getParent () ;
                                                                  JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                                                   
                                                                  // bind generalization4: GeneralizationAnnotation
                                                                  fujaba__IterColleagueAnnotationsGeneralization4 = colleague.iteratorOfAnnotations () ;
                                                                  while ( fujaba__IterColleagueAnnotationsGeneralization4.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization4.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                                        generalization4 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between generalization4 and colleague
                                                                        JavaSDM.ensure ( generalization4.hasInElements ("superClass", colleague) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between generalization4 and concreteColleague1
                                                                        JavaSDM.ensure ( generalization4.hasInElements ("subClass", concreteColleague1) ) ;
                                                                         
                                                                        // bind generalization7: GeneralizationAnnotation
                                                                        fujaba__IterColleagueAnnotationsGeneralization7 = colleague.iteratorOfAnnotations () ;
                                                                        while ( fujaba__IterColleagueAnnotationsGeneralization7.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization7.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                                              generalization7 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                                               
                                                                              // check Reverse-Qualified-Link 'elements' between generalization7 and colleague
                                                                              JavaSDM.ensure ( generalization7.hasInElements ("superClass", colleague) ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(generalization4.equals (generalization7)) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between generalization7 and concreteColleague2
                                                                              JavaSDM.ensure ( generalization7.hasInElements ("subClass", concreteColleague2) ) ;
                                                                               
                                                                              {
                                                                                 //  for each flow
                                                                                 try
                                                                                 {
                                                                                    fujaba__Success = false ;
                                                                                     
                                                                                    // check object mediator is really bound
                                                                                    JavaSDM.ensure ( mediator != null ) ;
                                                                                     
                                                                                    // check object colleague is really bound
                                                                                    JavaSDM.ensure ( colleague != null ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                     
                                                                                    // bind normalMediator: NormalMediatorAnnotation
                                                                                    fujaba__IterColleagueAnnotationsNormalMediator = colleague.iteratorOfAnnotations () ;
                                                                                    while ( !(fujaba__Success) && fujaba__IterColleagueAnnotationsNormalMediator.hasNext () )
                                                                                    {
                                                                                       try
                                                                                       {
                                                                                          fujaba__TmpObject = fujaba__IterColleagueAnnotationsNormalMediator.next () ;
                                                                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NormalMediatorAnnotation ) ;
                                                                                          normalMediator = (NormalMediatorAnnotation) fujaba__TmpObject ;
                                                                                           
                                                                                          // check Reverse-Qualified-Link 'elements' between normalMediator and colleague
                                                                                          JavaSDM.ensure ( normalMediator.hasInElements ("colleague", colleague) ) ;
                                                                                           
                                                                                          // check To-Many-Link 'elements' between normalMediator and mediator
                                                                                          JavaSDM.ensure ( normalMediator.hasInElements ("mediator", mediator) ) ;
                                                                                           
                                                                                          fujaba__Success = true ;
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                       }
                                                                                    }
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                    fujaba__Success = false ;
                                                                                 }
                                                                                  
                                                                                 if ( !(fujaba__Success) )
                                                                                 {
                                                                                    try
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                        
                                                                                       // check object mediator is really bound
                                                                                       JavaSDM.ensure ( mediator != null ) ;
                                                                                        
                                                                                       // check object colleague is really bound
                                                                                       JavaSDM.ensure ( colleague != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                        
                                                                                       // check object m1 is really bound
                                                                                       JavaSDM.ensure ( m1 != null ) ;
                                                                                        
                                                                                       // check object concreteColleague1 is really bound
                                                                                       JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                                                        
                                                                                       // check object concreteColleague2 is really bound
                                                                                       JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                                        
                                                                                       // check object m2 is really bound
                                                                                       JavaSDM.ensure ( m2 != null ) ;
                                                                                        
                                                                                       // create object
                                                                                       normalMediator = new NormalMediatorAnnotation ( ) ;
                                                                                        
                                                                                       // assign statement
                                                                                       normalMediator.setClassification (1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToElements ("mediator", mediator);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToElements ("colleague", colleague);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("mediator", mediator);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("m1", m1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("concreteColleague1", concreteColleague1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("colleague", colleague);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("concreteColleague2", concreteColleague2);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("m2", m2);
                                                                                        
                                                                                       fujaba__Success = true ;
                                                                                    }
                                                                                    catch ( JavaSDMException fujaba__InternalException )
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                    }
                                                                                     
                                                                                    try
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                        
                                                                                       // check object neighborCall2 is really bound
                                                                                       JavaSDM.ensure ( neighborCall2 != null ) ;
                                                                                        
                                                                                       // check object generalization4 is really bound
                                                                                       JavaSDM.ensure ( generalization4 != null ) ;
                                                                                        
                                                                                       // check object neighborCall5 is really bound
                                                                                       JavaSDM.ensure ( neighborCall5 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(neighborCall2.equals (neighborCall5)) ) ;
                                                                                        
                                                                                       // check object generalization7 is really bound
                                                                                       JavaSDM.ensure ( generalization7 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(generalization4.equals (generalization7)) ) ;
                                                                                        
                                                                                       // check object neighborCall9 is really bound
                                                                                       JavaSDM.ensure ( neighborCall9 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(neighborCall2.equals (neighborCall9)) && !(neighborCall5.equals (neighborCall9)) ) ;
                                                                                        
                                                                                       // check object normalMediator is really bound
                                                                                       JavaSDM.ensure ( normalMediator != null ) ;
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall2);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (generalization4);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall5);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (generalization7);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall9);
                                                                                        
                                                                                       fujaba__Success = true ;
                                                                                    }
                                                                                    catch ( JavaSDMException fujaba__InternalException )
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                    }
                                                                                     
                                                                                    return (normalMediator) ;
                                                                                 }
                                                                              } //  end for each flow
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object normalMediator is really bound
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("mediator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (normalMediator) ;
   }


   private GFRNAnnotation annotateUsingTrigger_GeneralizationRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization25 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod24 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod21 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod26 = null ;
      Iterator fujaba__IterGeneralization22ElementsColleague = null ;
      Iterator fujaba__IterGeneralization22ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization25ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterMediatorAnnotationsNormalMediator = null ;
      Iterator fujaba__IterMediatorMethodsM2 = null ;
      Iterator fujaba__IterNeighborCall20ElementsM1 = null ;
      Iterator fujaba__IterNeighborCall23ElementsUMLMethod19 = null ;
      Iterator fujaba__IterUMLMethod21AnnotationsNeighborCall20 = null ;
      Iterator fujaba__IterUMLMethod24AnnotationsNeighborCall23 = null ;
      Iterator fujaba__IterUMLMethod26AnnotationsNeighborCall27 = null ;
      GeneralizationAnnotation generalization22 = null ;
      GeneralizationAnnotation generalization25 = null ;
      NeighborCallAnnotation neighborCall20 = null ;
      NeighborCallAnnotation neighborCall23 = null ;
      NeighborCallAnnotation neighborCall27 = null ;
      NormalMediatorAnnotation normalMediator = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass colleague = null ;
      UMLClass concreteColleague1 = null ;
      UMLClass concreteColleague2 = null ;
      UMLClass mediator = null ;
      UMLMethod m1 = null ;
      UMLMethod m2 = null ;
      UMLMethod uMLMethod19 = null ;
      UMLMethod uMLMethod21 = null ;
      UMLMethod uMLMethod24 = null ;
      UMLMethod uMLMethod26 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization22 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteColleague1: UMLClass
            fujaba__IterGeneralization22ElementsConcreteColleague1 = generalization22.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization22ElementsConcreteColleague1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization22ElementsConcreteColleague1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  fujaba__IterGeneralization22ElementsColleague = generalization22.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization22ElementsColleague.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization22ElementsColleague.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        colleague = (UMLClass) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(concreteColleague1.equals (colleague)) ) ;
                         
                        // bind uMLMethod21: UMLMethod
                        fujaba__IterConcreteColleague1MethodsUMLMethod21 = concreteColleague1.iteratorOfMethods () ;
                        while ( fujaba__IterConcreteColleague1MethodsUMLMethod21.hasNext () )
                        {
                           try
                           {
                              uMLMethod21 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod21.next () ;
                               
                              // bind uMLMethod24: UMLMethod
                              fujaba__IterColleagueMethodsUMLMethod24 = colleague.iteratorOfMethods () ;
                              while ( fujaba__IterColleagueMethodsUMLMethod24.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod24 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod24.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod21.equals (uMLMethod24)) ) ;
                                     
                                    // bind generalization25: GeneralizationAnnotation
                                    fujaba__IterColleagueAnnotationsGeneralization25 = colleague.iteratorOfAnnotations () ;
                                    while ( fujaba__IterColleagueAnnotationsGeneralization25.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization25.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization25 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization25 and colleague
                                          JavaSDM.ensure ( generalization25.hasInElements ("superClass", colleague) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(generalization22.equals (generalization25)) ) ;
                                           
                                          // bind neighborCall20: NeighborCallAnnotation
                                          fujaba__IterUMLMethod21AnnotationsNeighborCall20 = uMLMethod21.iteratorOfAnnotations () ;
                                          while ( fujaba__IterUMLMethod21AnnotationsNeighborCall20.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLMethod21AnnotationsNeighborCall20.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall20 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall20 and uMLMethod21
                                                JavaSDM.ensure ( neighborCall20.hasInElements ("callee", uMLMethod21) ) ;
                                                 
                                                // bind neighborCall23: NeighborCallAnnotation
                                                fujaba__IterUMLMethod24AnnotationsNeighborCall23 = uMLMethod24.iteratorOfAnnotations () ;
                                                while ( fujaba__IterUMLMethod24AnnotationsNeighborCall23.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterUMLMethod24AnnotationsNeighborCall23.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall23 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall23 and uMLMethod24
                                                      JavaSDM.ensure ( neighborCall23.hasInElements ("caller", uMLMethod24) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(neighborCall20.equals (neighborCall23)) ) ;
                                                       
                                                      // bind concreteColleague2: UMLClass
                                                      fujaba__IterGeneralization25ElementsConcreteColleague2 = generalization25.iteratorOfElements ("subClass") ;
                                                      while ( fujaba__IterGeneralization25ElementsConcreteColleague2.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterGeneralization25ElementsConcreteColleague2.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                            concreteColleague2 = (UMLClass) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(concreteColleague1.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                                             
                                                            // bind m1: UMLMethod
                                                            fujaba__IterNeighborCall20ElementsM1 = neighborCall20.iteratorOfElements ("caller") ;
                                                            while ( fujaba__IterNeighborCall20ElementsM1.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterNeighborCall20ElementsM1.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                  m1 = (UMLMethod) fujaba__TmpObject ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLMethod21.equals (m1)) && !(uMLMethod24.equals (m1)) ) ;
                                                                   
                                                                  // bind mediator: UMLClass
                                                                  mediator = m1.getParent () ;
                                                                  JavaSDM.ensure ( mediator != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(concreteColleague1.equals (mediator)) && !(colleague.equals (mediator)) && !(concreteColleague2.equals (mediator)) ) ;
                                                                   
                                                                  // bind uMLMethod19: UMLMethod
                                                                  fujaba__IterNeighborCall23ElementsUMLMethod19 = neighborCall23.iteratorOfElements ("callee") ;
                                                                  while ( fujaba__IterNeighborCall23ElementsUMLMethod19.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterNeighborCall23ElementsUMLMethod19.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                        uMLMethod19 = (UMLMethod) fujaba__TmpObject ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(m1.equals (uMLMethod19)) && !(uMLMethod21.equals (uMLMethod19)) && !(uMLMethod24.equals (uMLMethod19)) ) ;
                                                                         
                                                                        // check To-One-Link 'parent' between uMLMethod19 and mediator
                                                                        JavaSDM.ensure ( (uMLMethod19.getParent () != null) && uMLMethod19.getParent ().equals (mediator) ) ;
                                                                         
                                                                        // bind uMLMethod26: UMLMethod
                                                                        fujaba__IterConcreteColleague2MethodsUMLMethod26 = concreteColleague2.iteratorOfMethods () ;
                                                                        while ( fujaba__IterConcreteColleague2MethodsUMLMethod26.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              uMLMethod26 = (UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod26.next () ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(uMLMethod19.equals (uMLMethod26)) && !(m1.equals (uMLMethod26)) && !(uMLMethod21.equals (uMLMethod26)) && !(uMLMethod24.equals (uMLMethod26)) ) ;
                                                                               
                                                                              // bind m2: UMLMethod
                                                                              fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                                                                              while ( fujaba__IterMediatorMethodsM2.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(uMLMethod19.equals (m2)) && !(uMLMethod21.equals (m2)) && !(uMLMethod24.equals (m2)) && !(uMLMethod26.equals (m2)) ) ;
                                                                                     
                                                                                    // bind neighborCall27: NeighborCallAnnotation
                                                                                    fujaba__IterUMLMethod26AnnotationsNeighborCall27 = uMLMethod26.iteratorOfAnnotations () ;
                                                                                    while ( fujaba__IterUMLMethod26AnnotationsNeighborCall27.hasNext () )
                                                                                    {
                                                                                       try
                                                                                       {
                                                                                          fujaba__TmpObject = fujaba__IterUMLMethod26AnnotationsNeighborCall27.next () ;
                                                                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                                                          neighborCall27 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                                                           
                                                                                          // check Reverse-Qualified-Link 'elements' between neighborCall27 and uMLMethod26
                                                                                          JavaSDM.ensure ( neighborCall27.hasInElements ("callee", uMLMethod26) ) ;
                                                                                           
                                                                                          // check isomorphic binding
                                                                                          JavaSDM.ensure ( !(neighborCall20.equals (neighborCall27)) && !(neighborCall23.equals (neighborCall27)) ) ;
                                                                                           
                                                                                          // check To-Many-Link 'elements' between neighborCall27 and m2
                                                                                          JavaSDM.ensure ( neighborCall27.hasInElements ("caller", m2) ) ;
                                                                                           
                                                                                          {
                                                                                             //  for each flow
                                                                                             try
                                                                                             {
                                                                                                fujaba__Success = false ;
                                                                                                 
                                                                                                // check object mediator is really bound
                                                                                                JavaSDM.ensure ( mediator != null ) ;
                                                                                                 
                                                                                                // check object colleague is really bound
                                                                                                JavaSDM.ensure ( colleague != null ) ;
                                                                                                 
                                                                                                // check isomorphic binding
                                                                                                JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                                 
                                                                                                // bind normalMediator: NormalMediatorAnnotation
                                                                                                fujaba__IterMediatorAnnotationsNormalMediator = mediator.iteratorOfAnnotations () ;
                                                                                                while ( !(fujaba__Success) && fujaba__IterMediatorAnnotationsNormalMediator.hasNext () )
                                                                                                {
                                                                                                   try
                                                                                                   {
                                                                                                      fujaba__TmpObject = fujaba__IterMediatorAnnotationsNormalMediator.next () ;
                                                                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NormalMediatorAnnotation ) ;
                                                                                                      normalMediator = (NormalMediatorAnnotation) fujaba__TmpObject ;
                                                                                                       
                                                                                                      // check Reverse-Qualified-Link 'elements' between normalMediator and mediator
                                                                                                      JavaSDM.ensure ( normalMediator.hasInElements ("mediator", mediator) ) ;
                                                                                                       
                                                                                                      // check To-Many-Link 'elements' between normalMediator and colleague
                                                                                                      JavaSDM.ensure ( normalMediator.hasInElements ("colleague", colleague) ) ;
                                                                                                       
                                                                                                      fujaba__Success = true ;
                                                                                                   }
                                                                                                   catch ( JavaSDMException fujaba__InternalException )
                                                                                                   {
                                                                                                   }
                                                                                                }
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                                fujaba__Success = false ;
                                                                                             }
                                                                                              
                                                                                             if ( !(fujaba__Success) )
                                                                                             {
                                                                                                try
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                    
                                                                                                   // check object mediator is really bound
                                                                                                   JavaSDM.ensure ( mediator != null ) ;
                                                                                                    
                                                                                                   // check object colleague is really bound
                                                                                                   JavaSDM.ensure ( colleague != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                                    
                                                                                                   // check object m1 is really bound
                                                                                                   JavaSDM.ensure ( m1 != null ) ;
                                                                                                    
                                                                                                   // check object concreteColleague1 is really bound
                                                                                                   JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                                                                    
                                                                                                   // check object concreteColleague2 is really bound
                                                                                                   JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                                                    
                                                                                                   // check object m2 is really bound
                                                                                                   JavaSDM.ensure ( m2 != null ) ;
                                                                                                    
                                                                                                   // create object
                                                                                                   normalMediator = new NormalMediatorAnnotation ( ) ;
                                                                                                    
                                                                                                   // assign statement
                                                                                                   normalMediator.setClassification (1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToElements ("mediator", mediator);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToElements ("colleague", colleague);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("mediator", mediator);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("m1", m1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("concreteColleague1", concreteColleague1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("colleague", colleague);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("concreteColleague2", concreteColleague2);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("m2", m2);
                                                                                                    
                                                                                                   fujaba__Success = true ;
                                                                                                }
                                                                                                catch ( JavaSDMException fujaba__InternalException )
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                }
                                                                                                 
                                                                                                try
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                    
                                                                                                   // check object neighborCall20 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall20 != null ) ;
                                                                                                    
                                                                                                   // check object generalization22 is really bound
                                                                                                   JavaSDM.ensure ( generalization22 != null ) ;
                                                                                                    
                                                                                                   // check object neighborCall23 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall23 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(neighborCall20.equals (neighborCall23)) ) ;
                                                                                                    
                                                                                                   // check object generalization25 is really bound
                                                                                                   JavaSDM.ensure ( generalization25 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(generalization22.equals (generalization25)) ) ;
                                                                                                    
                                                                                                   // check object neighborCall27 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall27 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(neighborCall20.equals (neighborCall27)) && !(neighborCall23.equals (neighborCall27)) ) ;
                                                                                                    
                                                                                                   // check object normalMediator is really bound
                                                                                                   JavaSDM.ensure ( normalMediator != null ) ;
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall20);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (generalization22);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall23);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (generalization25);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall27);
                                                                                                    
                                                                                                   fujaba__Success = true ;
                                                                                                }
                                                                                                catch ( JavaSDMException fujaba__InternalException )
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                }
                                                                                                 
                                                                                                return (normalMediator) ;
                                                                                             }
                                                                                          } //  end for each flow
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                       }
                                                                                    }
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object normalMediator is really bound
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_Generalization", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (normalMediator) ;
   }


   private GFRNAnnotation annotateUsingTrigger_NeighborCallRole(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization16 = null ;
      Iterator fujaba__IterConcreteColleague1AnnotationsGeneralization13 = null ;
      Iterator fujaba__IterGeneralization13ElementsColleague = null ;
      Iterator fujaba__IterM2AnnotationsNeighborCall18 = null ;
      Iterator fujaba__IterMediatorAnnotationsNormalMediator = null ;
      Iterator fujaba__IterMediatorMethodsM2 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod10 = null ;
      Iterator fujaba__IterNeighborCall11ElementsM1 = null ;
      Iterator fujaba__IterNeighborCall11ElementsUMLMethod12 = null ;
      Iterator fujaba__IterNeighborCall14ElementsUMLMethod15 = null ;
      Iterator fujaba__IterNeighborCall18ElementsUMLMethod17 = null ;
      Iterator fujaba__IterUMLMethod10AnnotationsNeighborCall14 = null ;
      GeneralizationAnnotation generalization13 = null ;
      GeneralizationAnnotation generalization16 = null ;
      NeighborCallAnnotation neighborCall11 = null ;
      NeighborCallAnnotation neighborCall14 = null ;
      NeighborCallAnnotation neighborCall18 = null ;
      NormalMediatorAnnotation normalMediator = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass colleague = null ;
      UMLClass concreteColleague1 = null ;
      UMLClass concreteColleague2 = null ;
      UMLClass mediator = null ;
      UMLMethod m1 = null ;
      UMLMethod m2 = null ;
      UMLMethod uMLMethod10 = null ;
      UMLMethod uMLMethod12 = null ;
      UMLMethod uMLMethod15 = null ;
      UMLMethod uMLMethod17 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger_NeighborCall", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind m1: UMLMethod
            fujaba__IterNeighborCall11ElementsM1 = neighborCall11.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall11ElementsM1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsM1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  m1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = m1.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind uMLMethod12: UMLMethod
                  fujaba__IterNeighborCall11ElementsUMLMethod12 = neighborCall11.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall11ElementsUMLMethod12.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall11ElementsUMLMethod12.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod12 = (UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(m1.equals (uMLMethod12)) ) ;
                         
                        // bind concreteColleague1: UMLClass
                        concreteColleague1 = uMLMethod12.getParent () ;
                        JavaSDM.ensure ( concreteColleague1 != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) ) ;
                         
                        // bind uMLMethod10: UMLMethod
                        fujaba__IterMediatorMethodsUMLMethod10 = mediator.iteratorOfMethods () ;
                        while ( fujaba__IterMediatorMethodsUMLMethod10.hasNext () )
                        {
                           try
                           {
                              uMLMethod10 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod10.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(m1.equals (uMLMethod10)) && !(uMLMethod12.equals (uMLMethod10)) ) ;
                               
                              // bind m2: UMLMethod
                              fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                              while ( fujaba__IterMediatorMethodsM2.hasNext () )
                              {
                                 try
                                 {
                                    m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod10.equals (m2)) && !(uMLMethod12.equals (m2)) ) ;
                                     
                                    // bind generalization13: GeneralizationAnnotation
                                    fujaba__IterConcreteColleague1AnnotationsGeneralization13 = concreteColleague1.iteratorOfAnnotations () ;
                                    while ( fujaba__IterConcreteColleague1AnnotationsGeneralization13.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterConcreteColleague1AnnotationsGeneralization13.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization13 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization13 and concreteColleague1
                                          JavaSDM.ensure ( generalization13.hasInElements ("subClass", concreteColleague1) ) ;
                                           
                                          // bind neighborCall14: NeighborCallAnnotation
                                          fujaba__IterUMLMethod10AnnotationsNeighborCall14 = uMLMethod10.iteratorOfAnnotations () ;
                                          while ( fujaba__IterUMLMethod10AnnotationsNeighborCall14.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLMethod10AnnotationsNeighborCall14.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall14 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall14 and uMLMethod10
                                                JavaSDM.ensure ( neighborCall14.hasInElements ("callee", uMLMethod10) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(neighborCall11.equals (neighborCall14)) ) ;
                                                 
                                                // bind neighborCall18: NeighborCallAnnotation
                                                fujaba__IterM2AnnotationsNeighborCall18 = m2.iteratorOfAnnotations () ;
                                                while ( fujaba__IterM2AnnotationsNeighborCall18.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterM2AnnotationsNeighborCall18.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall18 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall18 and m2
                                                      JavaSDM.ensure ( neighborCall18.hasInElements ("caller", m2) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(neighborCall11.equals (neighborCall18)) && !(neighborCall14.equals (neighborCall18)) ) ;
                                                       
                                                      // bind colleague: UMLClass
                                                      fujaba__IterGeneralization13ElementsColleague = generalization13.iteratorOfElements ("superClass") ;
                                                      while ( fujaba__IterGeneralization13ElementsColleague.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterGeneralization13ElementsColleague.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                            colleague = (UMLClass) fujaba__TmpObject ;
                                                             
                                                            // attribute condition
                                                            JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(mediator.equals (colleague)) && !(concreteColleague1.equals (colleague)) ) ;
                                                             
                                                            // bind uMLMethod15: UMLMethod
                                                            fujaba__IterNeighborCall14ElementsUMLMethod15 = neighborCall14.iteratorOfElements ("caller") ;
                                                            while ( fujaba__IterNeighborCall14ElementsUMLMethod15.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterNeighborCall14ElementsUMLMethod15.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                  uMLMethod15 = (UMLMethod) fujaba__TmpObject ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLMethod10.equals (uMLMethod15)) && !(m1.equals (uMLMethod15)) && !(uMLMethod12.equals (uMLMethod15)) && !(m2.equals (uMLMethod15)) ) ;
                                                                   
                                                                  // check To-One-Link 'parent' between uMLMethod15 and colleague
                                                                  JavaSDM.ensure ( (uMLMethod15.getParent () != null) && uMLMethod15.getParent ().equals (colleague) ) ;
                                                                   
                                                                  // bind uMLMethod17: UMLMethod
                                                                  fujaba__IterNeighborCall18ElementsUMLMethod17 = neighborCall18.iteratorOfElements ("callee") ;
                                                                  while ( fujaba__IterNeighborCall18ElementsUMLMethod17.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterNeighborCall18ElementsUMLMethod17.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                        uMLMethod17 = (UMLMethod) fujaba__TmpObject ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(uMLMethod10.equals (uMLMethod17)) && !(m1.equals (uMLMethod17)) && !(uMLMethod12.equals (uMLMethod17)) && !(uMLMethod15.equals (uMLMethod17)) && !(m2.equals (uMLMethod17)) ) ;
                                                                         
                                                                        // bind concreteColleague2: UMLClass
                                                                        concreteColleague2 = uMLMethod17.getParent () ;
                                                                        JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                                                         
                                                                        // bind generalization16: GeneralizationAnnotation
                                                                        fujaba__IterColleagueAnnotationsGeneralization16 = colleague.iteratorOfAnnotations () ;
                                                                        while ( fujaba__IterColleagueAnnotationsGeneralization16.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization16.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                                              generalization16 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                                               
                                                                              // check Reverse-Qualified-Link 'elements' between generalization16 and colleague
                                                                              JavaSDM.ensure ( generalization16.hasInElements ("superClass", colleague) ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(generalization13.equals (generalization16)) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between generalization16 and concreteColleague2
                                                                              JavaSDM.ensure ( generalization16.hasInElements ("subClass", concreteColleague2) ) ;
                                                                               
                                                                              {
                                                                                 //  for each flow
                                                                                 try
                                                                                 {
                                                                                    fujaba__Success = false ;
                                                                                     
                                                                                    // check object mediator is really bound
                                                                                    JavaSDM.ensure ( mediator != null ) ;
                                                                                     
                                                                                    // check object colleague is really bound
                                                                                    JavaSDM.ensure ( colleague != null ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                     
                                                                                    // bind normalMediator: NormalMediatorAnnotation
                                                                                    fujaba__IterMediatorAnnotationsNormalMediator = mediator.iteratorOfAnnotations () ;
                                                                                    while ( !(fujaba__Success) && fujaba__IterMediatorAnnotationsNormalMediator.hasNext () )
                                                                                    {
                                                                                       try
                                                                                       {
                                                                                          fujaba__TmpObject = fujaba__IterMediatorAnnotationsNormalMediator.next () ;
                                                                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NormalMediatorAnnotation ) ;
                                                                                          normalMediator = (NormalMediatorAnnotation) fujaba__TmpObject ;
                                                                                           
                                                                                          // check Reverse-Qualified-Link 'elements' between normalMediator and mediator
                                                                                          JavaSDM.ensure ( normalMediator.hasInElements ("mediator", mediator) ) ;
                                                                                           
                                                                                          // check To-Many-Link 'elements' between normalMediator and colleague
                                                                                          JavaSDM.ensure ( normalMediator.hasInElements ("colleague", colleague) ) ;
                                                                                           
                                                                                          fujaba__Success = true ;
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                       }
                                                                                    }
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                    fujaba__Success = false ;
                                                                                 }
                                                                                  
                                                                                 if ( !(fujaba__Success) )
                                                                                 {
                                                                                    try
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                        
                                                                                       // check object mediator is really bound
                                                                                       JavaSDM.ensure ( mediator != null ) ;
                                                                                        
                                                                                       // check object colleague is really bound
                                                                                       JavaSDM.ensure ( colleague != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                        
                                                                                       // check object m1 is really bound
                                                                                       JavaSDM.ensure ( m1 != null ) ;
                                                                                        
                                                                                       // check object concreteColleague1 is really bound
                                                                                       JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                                                        
                                                                                       // check object concreteColleague2 is really bound
                                                                                       JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                                        
                                                                                       // check object m2 is really bound
                                                                                       JavaSDM.ensure ( m2 != null ) ;
                                                                                        
                                                                                       // create object
                                                                                       normalMediator = new NormalMediatorAnnotation ( ) ;
                                                                                        
                                                                                       // assign statement
                                                                                       normalMediator.setClassification (1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToElements ("mediator", mediator);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToElements ("colleague", colleague);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("mediator", mediator);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("m1", m1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("concreteColleague1", concreteColleague1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("colleague", colleague);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("concreteColleague2", concreteColleague2);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("m2", m2);
                                                                                        
                                                                                       fujaba__Success = true ;
                                                                                    }
                                                                                    catch ( JavaSDMException fujaba__InternalException )
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                    }
                                                                                     
                                                                                    try
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                        
                                                                                       // check object neighborCall11 is really bound
                                                                                       JavaSDM.ensure ( neighborCall11 != null ) ;
                                                                                        
                                                                                       // check object generalization13 is really bound
                                                                                       JavaSDM.ensure ( generalization13 != null ) ;
                                                                                        
                                                                                       // check object neighborCall14 is really bound
                                                                                       JavaSDM.ensure ( neighborCall14 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(neighborCall11.equals (neighborCall14)) ) ;
                                                                                        
                                                                                       // check object generalization16 is really bound
                                                                                       JavaSDM.ensure ( generalization16 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(generalization13.equals (generalization16)) ) ;
                                                                                        
                                                                                       // check object neighborCall18 is really bound
                                                                                       JavaSDM.ensure ( neighborCall18 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(neighborCall11.equals (neighborCall18)) && !(neighborCall14.equals (neighborCall18)) ) ;
                                                                                        
                                                                                       // check object normalMediator is really bound
                                                                                       JavaSDM.ensure ( normalMediator != null ) ;
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall11);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (generalization13);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall14);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (generalization16);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall18);
                                                                                        
                                                                                       fujaba__Success = true ;
                                                                                    }
                                                                                    catch ( JavaSDMException fujaba__InternalException )
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                    }
                                                                                     
                                                                                    return (normalMediator) ;
                                                                                 }
                                                                              } //  end for each flow
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object normalMediator is really bound
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger_NeighborCall", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (normalMediator) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("mediator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("colleague", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_NeighborCall", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_NeighborCall", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_Generalization", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger_NeighborCall", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization127 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization135 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization142 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization67 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization77 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod100 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod105 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod108 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod129 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod145 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod69 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod79 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod84 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod102 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod115 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod137 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod68 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod72 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod78 = null ;
      Iterator fujaba__IterConcreteColleague2AnnotationsGeneralization107 = null ;
      Iterator fujaba__IterConcreteColleague2AnnotationsGeneralization76 = null ;
      Iterator fujaba__IterConcreteColleague2AnnotationsGeneralization83 = null ;
      Iterator fujaba__IterConcreteColleague2AnnotationsGeneralization96 = null ;
      Iterator fujaba__IterConcreteColleague2AnnotationsGeneralization98 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod128 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod136 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod143 = null ;
      Iterator fujaba__IterGeneralization107ElementsColleague = null ;
      Iterator fujaba__IterGeneralization127ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterGeneralization135ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterGeneralization142ElementsColleague = null ;
      Iterator fujaba__IterGeneralization142ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterGeneralization67ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization76ElementsColleague = null ;
      Iterator fujaba__IterGeneralization77ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization83ElementsColleague = null ;
      Iterator fujaba__IterGeneralization96ElementsColleague = null ;
      Iterator fujaba__IterGeneralization98ElementsColleague = null ;
      Iterator fujaba__IterM2AnnotationsNeighborCall121 = null ;
      Iterator fujaba__IterM2AnnotationsNeighborCall74 = null ;
      Iterator fujaba__IterM2AnnotationsNeighborCall94 = null ;
      Iterator fujaba__IterMediatorMethodsM1 = null ;
      Iterator fujaba__IterMediatorMethodsM2 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod101 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod104 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod109 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod112 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod117 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod124 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod132 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod139 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod64 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod87 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod90 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod99 = null ;
      Iterator fujaba__IterNeighborCall103ElementsM1 = null ;
      Iterator fujaba__IterNeighborCall110ElementsUMLMethod111 = null ;
      Iterator fujaba__IterNeighborCall113ElementsUMLMethod114 = null ;
      Iterator fujaba__IterNeighborCall116ElementsM1 = null ;
      Iterator fujaba__IterNeighborCall118ElementsUMLMethod119 = null ;
      Iterator fujaba__IterNeighborCall118ElementsUMLMethod120 = null ;
      Iterator fujaba__IterNeighborCall121ElementsUMLMethod122 = null ;
      Iterator fujaba__IterNeighborCall121ElementsUMLMethod123 = null ;
      Iterator fujaba__IterNeighborCall125ElementsUMLMethod126 = null ;
      Iterator fujaba__IterNeighborCall130ElementsUMLMethod131 = null ;
      Iterator fujaba__IterNeighborCall133ElementsUMLMethod134 = null ;
      Iterator fujaba__IterNeighborCall138ElementsM1 = null ;
      Iterator fujaba__IterNeighborCall140ElementsUMLMethod141 = null ;
      Iterator fujaba__IterNeighborCall140ElementsUMLMethod144 = null ;
      Iterator fujaba__IterNeighborCall146ElementsUMLMethod147 = null ;
      Iterator fujaba__IterNeighborCall56ElementsM1 = null ;
      Iterator fujaba__IterNeighborCall65ElementsUMLMethod66 = null ;
      Iterator fujaba__IterNeighborCall70ElementsUMLMethod71 = null ;
      Iterator fujaba__IterNeighborCall70ElementsUMLMethod73 = null ;
      Iterator fujaba__IterNeighborCall74ElementsUMLMethod75 = null ;
      Iterator fujaba__IterNeighborCall74ElementsUMLMethod82 = null ;
      Iterator fujaba__IterNeighborCall80ElementsUMLMethod81 = null ;
      Iterator fujaba__IterNeighborCall85ElementsUMLMethod86 = null ;
      Iterator fujaba__IterNeighborCall88ElementsUMLMethod89 = null ;
      Iterator fujaba__IterNeighborCall91ElementsUMLMethod92 = null ;
      Iterator fujaba__IterNeighborCall91ElementsUMLMethod93 = null ;
      Iterator fujaba__IterNeighborCall94ElementsUMLMethod106 = null ;
      Iterator fujaba__IterNeighborCall94ElementsUMLMethod95 = null ;
      Iterator fujaba__IterNeighborCall94ElementsUMLMethod97 = null ;
      Iterator fujaba__IterUMLMethod102AnnotationsNeighborCall103 = null ;
      Iterator fujaba__IterUMLMethod109AnnotationsNeighborCall110 = null ;
      Iterator fujaba__IterUMLMethod112AnnotationsNeighborCall113 = null ;
      Iterator fujaba__IterUMLMethod115AnnotationsNeighborCall116 = null ;
      Iterator fujaba__IterUMLMethod117AnnotationsNeighborCall118 = null ;
      Iterator fujaba__IterUMLMethod124AnnotationsNeighborCall125 = null ;
      Iterator fujaba__IterUMLMethod129AnnotationsNeighborCall130 = null ;
      Iterator fujaba__IterUMLMethod132AnnotationsNeighborCall133 = null ;
      Iterator fujaba__IterUMLMethod137AnnotationsNeighborCall138 = null ;
      Iterator fujaba__IterUMLMethod139AnnotationsNeighborCall140 = null ;
      Iterator fujaba__IterUMLMethod145AnnotationsNeighborCall146 = null ;
      Iterator fujaba__IterUMLMethod64AnnotationsNeighborCall65 = null ;
      Iterator fujaba__IterUMLMethod69AnnotationsNeighborCall70 = null ;
      Iterator fujaba__IterUMLMethod79AnnotationsNeighborCall80 = null ;
      Iterator fujaba__IterUMLMethod84AnnotationsNeighborCall85 = null ;
      Iterator fujaba__IterUMLMethod87AnnotationsNeighborCall88 = null ;
      Iterator fujaba__IterUMLMethod90AnnotationsNeighborCall91 = null ;
      GeneralizationAnnotation generalization107 = null ;
      GeneralizationAnnotation generalization127 = null ;
      GeneralizationAnnotation generalization135 = null ;
      GeneralizationAnnotation generalization142 = null ;
      GeneralizationAnnotation generalization67 = null ;
      GeneralizationAnnotation generalization76 = null ;
      GeneralizationAnnotation generalization77 = null ;
      GeneralizationAnnotation generalization83 = null ;
      GeneralizationAnnotation generalization96 = null ;
      GeneralizationAnnotation generalization98 = null ;
      NeighborCallAnnotation neighborCall103 = null ;
      NeighborCallAnnotation neighborCall110 = null ;
      NeighborCallAnnotation neighborCall113 = null ;
      NeighborCallAnnotation neighborCall116 = null ;
      NeighborCallAnnotation neighborCall118 = null ;
      NeighborCallAnnotation neighborCall121 = null ;
      NeighborCallAnnotation neighborCall125 = null ;
      NeighborCallAnnotation neighborCall130 = null ;
      NeighborCallAnnotation neighborCall133 = null ;
      NeighborCallAnnotation neighborCall138 = null ;
      NeighborCallAnnotation neighborCall140 = null ;
      NeighborCallAnnotation neighborCall146 = null ;
      NeighborCallAnnotation neighborCall56 = null ;
      NeighborCallAnnotation neighborCall65 = null ;
      NeighborCallAnnotation neighborCall70 = null ;
      NeighborCallAnnotation neighborCall74 = null ;
      NeighborCallAnnotation neighborCall80 = null ;
      NeighborCallAnnotation neighborCall85 = null ;
      NeighborCallAnnotation neighborCall88 = null ;
      NeighborCallAnnotation neighborCall91 = null ;
      NeighborCallAnnotation neighborCall94 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      UMLClass colleague = null ;
      UMLClass concreteColleague1 = null ;
      UMLClass concreteColleague2 = null ;
      UMLClass mediator = null ;
      UMLMethod m1 = null ;
      UMLMethod m2 = null ;
      UMLMethod uMLMethod100 = null ;
      UMLMethod uMLMethod101 = null ;
      UMLMethod uMLMethod102 = null ;
      UMLMethod uMLMethod104 = null ;
      UMLMethod uMLMethod105 = null ;
      UMLMethod uMLMethod106 = null ;
      UMLMethod uMLMethod108 = null ;
      UMLMethod uMLMethod109 = null ;
      UMLMethod uMLMethod111 = null ;
      UMLMethod uMLMethod112 = null ;
      UMLMethod uMLMethod114 = null ;
      UMLMethod uMLMethod115 = null ;
      UMLMethod uMLMethod117 = null ;
      UMLMethod uMLMethod119 = null ;
      UMLMethod uMLMethod120 = null ;
      UMLMethod uMLMethod122 = null ;
      UMLMethod uMLMethod123 = null ;
      UMLMethod uMLMethod124 = null ;
      UMLMethod uMLMethod126 = null ;
      UMLMethod uMLMethod128 = null ;
      UMLMethod uMLMethod129 = null ;
      UMLMethod uMLMethod131 = null ;
      UMLMethod uMLMethod132 = null ;
      UMLMethod uMLMethod134 = null ;
      UMLMethod uMLMethod136 = null ;
      UMLMethod uMLMethod137 = null ;
      UMLMethod uMLMethod139 = null ;
      UMLMethod uMLMethod141 = null ;
      UMLMethod uMLMethod143 = null ;
      UMLMethod uMLMethod144 = null ;
      UMLMethod uMLMethod145 = null ;
      UMLMethod uMLMethod147 = null ;
      UMLMethod uMLMethod64 = null ;
      UMLMethod uMLMethod66 = null ;
      UMLMethod uMLMethod68 = null ;
      UMLMethod uMLMethod69 = null ;
      UMLMethod uMLMethod71 = null ;
      UMLMethod uMLMethod72 = null ;
      UMLMethod uMLMethod73 = null ;
      UMLMethod uMLMethod75 = null ;
      UMLMethod uMLMethod78 = null ;
      UMLMethod uMLMethod79 = null ;
      UMLMethod uMLMethod81 = null ;
      UMLMethod uMLMethod82 = null ;
      UMLMethod uMLMethod84 = null ;
      UMLMethod uMLMethod86 = null ;
      UMLMethod uMLMethod87 = null ;
      UMLMethod uMLMethod89 = null ;
      UMLMethod uMLMethod90 = null ;
      UMLMethod uMLMethod92 = null ;
      UMLMethod uMLMethod93 = null ;
      UMLMethod uMLMethod95 = null ;
      UMLMethod uMLMethod97 = null ;
      UMLMethod uMLMethod99 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("NeighborCall") || annotation.equals ("Delegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod64: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod64 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod64.hasNext () )
            {
               try
               {
                  uMLMethod64 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod64.next () ;
                   
                  // bind neighborCall65: NeighborCallAnnotation
                  fujaba__IterUMLMethod64AnnotationsNeighborCall65 = uMLMethod64.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod64AnnotationsNeighborCall65.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod64AnnotationsNeighborCall65.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall65 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall65 and uMLMethod64
                        JavaSDM.ensure ( neighborCall65.hasInElements ("callee", uMLMethod64) ) ;
                         
                        // bind uMLMethod66: UMLMethod
                        fujaba__IterNeighborCall65ElementsUMLMethod66 = neighborCall65.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall65ElementsUMLMethod66.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall65ElementsUMLMethod66.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod66 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod64.equals (uMLMethod66)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod66.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              // bind generalization67: GeneralizationAnnotation
                              fujaba__IterColleagueAnnotationsGeneralization67 = colleague.iteratorOfAnnotations () ;
                              while ( fujaba__IterColleagueAnnotationsGeneralization67.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization67.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization67 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization67 and colleague
                                    JavaSDM.ensure ( generalization67.hasInElements ("superClass", colleague) ) ;
                                     
                                    // bind concreteColleague1: UMLClass
                                    fujaba__IterGeneralization67ElementsConcreteColleague1 = generalization67.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization67ElementsConcreteColleague1.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization67ElementsConcreteColleague1.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                           
                                          // bind uMLMethod68: UMLMethod
                                          fujaba__IterConcreteColleague1MethodsUMLMethod68 = concreteColleague1.iteratorOfMethods () ;
                                          while ( fujaba__IterConcreteColleague1MethodsUMLMethod68.hasNext () )
                                          {
                                             try
                                             {
                                                uMLMethod68 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod68.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod64.equals (uMLMethod68)) && !(uMLMethod66.equals (uMLMethod68)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   set.add (uMLMethod68);
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod69: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod69 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod69.hasNext () )
            {
               try
               {
                  uMLMethod69 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod69.next () ;
                   
                  // bind neighborCall70: NeighborCallAnnotation
                  fujaba__IterUMLMethod69AnnotationsNeighborCall70 = uMLMethod69.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod69AnnotationsNeighborCall70.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod69AnnotationsNeighborCall70.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall70 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall70 and uMLMethod69
                        JavaSDM.ensure ( neighborCall70.hasInElements ("caller", uMLMethod69) ) ;
                         
                        // bind uMLMethod71: UMLMethod
                        fujaba__IterNeighborCall70ElementsUMLMethod71 = neighborCall70.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall70ElementsUMLMethod71.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall70ElementsUMLMethod71.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod71 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod69.equals (uMLMethod71)) ) ;
                               
                              // bind mediator: UMLClass
                              mediator = uMLMethod71.getParent () ;
                              JavaSDM.ensure ( mediator != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                               
                              // bind m1: UMLMethod
                              fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                              while ( fujaba__IterMediatorMethodsM1.hasNext () )
                              {
                                 try
                                 {
                                    m1 = (UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod69.equals (m1)) && !(uMLMethod71.equals (m1)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (m1);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization67 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteColleague1: UMLClass
            fujaba__IterGeneralization67ElementsConcreteColleague1 = generalization67.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization67ElementsConcreteColleague1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization67ElementsConcreteColleague1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod72: UMLMethod
                  fujaba__IterConcreteColleague1MethodsUMLMethod72 = concreteColleague1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteColleague1MethodsUMLMethod72.hasNext () )
                  {
                     try
                     {
                        uMLMethod72 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod72.next () ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod72);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall70 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod73: UMLMethod
            fujaba__IterNeighborCall70ElementsUMLMethod73 = neighborCall70.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall70ElementsUMLMethod73.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall70ElementsUMLMethod73.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod73 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = uMLMethod73.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind m2: UMLMethod
                  fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsM2.hasNext () )
                  {
                     try
                     {
                        m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod73.equals (m2)) ) ;
                         
                        // bind neighborCall74: NeighborCallAnnotation
                        fujaba__IterM2AnnotationsNeighborCall74 = m2.iteratorOfAnnotations () ;
                        while ( fujaba__IterM2AnnotationsNeighborCall74.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterM2AnnotationsNeighborCall74.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall74 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall74 and m2
                              JavaSDM.ensure ( neighborCall74.hasInElements ("caller", m2) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(neighborCall70.equals (neighborCall74)) ) ;
                               
                              // bind uMLMethod75: UMLMethod
                              fujaba__IterNeighborCall74ElementsUMLMethod75 = neighborCall74.iteratorOfElements ("callee") ;
                              while ( fujaba__IterNeighborCall74ElementsUMLMethod75.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall74ElementsUMLMethod75.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod75 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod73.equals (uMLMethod75)) && !(m2.equals (uMLMethod75)) ) ;
                                     
                                    // bind concreteColleague2: UMLClass
                                    concreteColleague2 = uMLMethod75.getParent () ;
                                    JavaSDM.ensure ( concreteColleague2 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) ) ;
                                     
                                    // bind generalization76: GeneralizationAnnotation
                                    fujaba__IterConcreteColleague2AnnotationsGeneralization76 = concreteColleague2.iteratorOfAnnotations () ;
                                    while ( fujaba__IterConcreteColleague2AnnotationsGeneralization76.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterConcreteColleague2AnnotationsGeneralization76.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization76 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization76 and concreteColleague2
                                          JavaSDM.ensure ( generalization76.hasInElements ("subClass", concreteColleague2) ) ;
                                           
                                          // bind colleague: UMLClass
                                          fujaba__IterGeneralization76ElementsColleague = generalization76.iteratorOfElements ("superClass") ;
                                          while ( fujaba__IterGeneralization76ElementsColleague.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization76ElementsColleague.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                colleague = (UMLClass) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mediator.equals (colleague)) && !(concreteColleague2.equals (colleague)) ) ;
                                                 
                                                // bind generalization77: GeneralizationAnnotation
                                                fujaba__IterColleagueAnnotationsGeneralization77 = colleague.iteratorOfAnnotations () ;
                                                while ( fujaba__IterColleagueAnnotationsGeneralization77.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization77.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      generalization77 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between generalization77 and colleague
                                                      JavaSDM.ensure ( generalization77.hasInElements ("superClass", colleague) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(generalization76.equals (generalization77)) ) ;
                                                       
                                                      // bind concreteColleague1: UMLClass
                                                      fujaba__IterGeneralization77ElementsConcreteColleague1 = generalization77.iteratorOfElements ("subClass") ;
                                                      while ( fujaba__IterGeneralization77ElementsConcreteColleague1.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterGeneralization77ElementsConcreteColleague1.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                            concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(concreteColleague2.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                             
                                                            // bind uMLMethod78: UMLMethod
                                                            fujaba__IterConcreteColleague1MethodsUMLMethod78 = concreteColleague1.iteratorOfMethods () ;
                                                            while ( fujaba__IterConcreteColleague1MethodsUMLMethod78.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  uMLMethod78 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod78.next () ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLMethod73.equals (uMLMethod78)) && !(m2.equals (uMLMethod78)) && !(uMLMethod75.equals (uMLMethod78)) ) ;
                                                                   
                                                                  {
                                                                     //  for each flow
                                                                     set.add (uMLMethod78);
                                                                  } //  end for each flow
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization76 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind colleague: UMLClass
            fujaba__IterGeneralization76ElementsColleague = generalization76.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization76ElementsColleague.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization76ElementsColleague.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  colleague = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind uMLMethod79: UMLMethod
                  fujaba__IterColleagueMethodsUMLMethod79 = colleague.iteratorOfMethods () ;
                  while ( fujaba__IterColleagueMethodsUMLMethod79.hasNext () )
                  {
                     try
                     {
                        uMLMethod79 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod79.next () ;
                         
                        // bind neighborCall80: NeighborCallAnnotation
                        fujaba__IterUMLMethod79AnnotationsNeighborCall80 = uMLMethod79.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod79AnnotationsNeighborCall80.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod79AnnotationsNeighborCall80.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall80 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall80 and uMLMethod79
                              JavaSDM.ensure ( neighborCall80.hasInElements ("caller", uMLMethod79) ) ;
                               
                              // bind uMLMethod81: UMLMethod
                              fujaba__IterNeighborCall80ElementsUMLMethod81 = neighborCall80.iteratorOfElements ("callee") ;
                              while ( fujaba__IterNeighborCall80ElementsUMLMethod81.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall80ElementsUMLMethod81.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod81 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod79.equals (uMLMethod81)) ) ;
                                     
                                    // bind mediator: UMLClass
                                    mediator = uMLMethod81.getParent () ;
                                    JavaSDM.ensure ( mediator != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                                     
                                    // bind m1: UMLMethod
                                    fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                                    while ( fujaba__IterMediatorMethodsM1.hasNext () )
                                    {
                                       try
                                       {
                                          m1 = (UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod79.equals (m1)) && !(uMLMethod81.equals (m1)) ) ;
                                           
                                          {
                                             //  for each flow
                                             set.add (m1);
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall74 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod82: UMLMethod
            fujaba__IterNeighborCall74ElementsUMLMethod82 = neighborCall74.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall74ElementsUMLMethod82.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall74ElementsUMLMethod82.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod82 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind concreteColleague2: UMLClass
                  concreteColleague2 = uMLMethod82.getParent () ;
                  JavaSDM.ensure ( concreteColleague2 != null ) ;
                   
                  // bind generalization83: GeneralizationAnnotation
                  fujaba__IterConcreteColleague2AnnotationsGeneralization83 = concreteColleague2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteColleague2AnnotationsGeneralization83.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteColleague2AnnotationsGeneralization83.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization83 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization83 and concreteColleague2
                        JavaSDM.ensure ( generalization83.hasInElements ("subClass", concreteColleague2) ) ;
                         
                        // bind colleague: UMLClass
                        fujaba__IterGeneralization83ElementsColleague = generalization83.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization83ElementsColleague.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization83ElementsColleague.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              colleague = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteColleague2.equals (colleague)) ) ;
                               
                              // bind uMLMethod84: UMLMethod
                              fujaba__IterColleagueMethodsUMLMethod84 = colleague.iteratorOfMethods () ;
                              while ( fujaba__IterColleagueMethodsUMLMethod84.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod84 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod84.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod82.equals (uMLMethod84)) ) ;
                                     
                                    // bind neighborCall85: NeighborCallAnnotation
                                    fujaba__IterUMLMethod84AnnotationsNeighborCall85 = uMLMethod84.iteratorOfAnnotations () ;
                                    while ( fujaba__IterUMLMethod84AnnotationsNeighborCall85.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLMethod84AnnotationsNeighborCall85.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall85 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall85 and uMLMethod84
                                          JavaSDM.ensure ( neighborCall85.hasInElements ("caller", uMLMethod84) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(neighborCall74.equals (neighborCall85)) ) ;
                                           
                                          // bind uMLMethod86: UMLMethod
                                          fujaba__IterNeighborCall85ElementsUMLMethod86 = neighborCall85.iteratorOfElements ("callee") ;
                                          while ( fujaba__IterNeighborCall85ElementsUMLMethod86.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterNeighborCall85ElementsUMLMethod86.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                uMLMethod86 = (UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod82.equals (uMLMethod86)) && !(uMLMethod84.equals (uMLMethod86)) ) ;
                                                 
                                                // bind mediator: UMLClass
                                                mediator = uMLMethod86.getParent () ;
                                                JavaSDM.ensure ( mediator != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(concreteColleague2.equals (mediator)) && !(colleague.equals (mediator)) ) ;
                                                 
                                                // bind m1: UMLMethod
                                                fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                                                while ( fujaba__IterMediatorMethodsM1.hasNext () )
                                                {
                                                   try
                                                   {
                                                      m1 = (UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod82.equals (m1)) && !(uMLMethod84.equals (m1)) && !(uMLMethod86.equals (m1)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         set.add (m1);
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod87: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod87 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod87.hasNext () )
            {
               try
               {
                  uMLMethod87 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod87.next () ;
                   
                  // bind neighborCall88: NeighborCallAnnotation
                  fujaba__IterUMLMethod87AnnotationsNeighborCall88 = uMLMethod87.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod87AnnotationsNeighborCall88.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod87AnnotationsNeighborCall88.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall88 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall88 and uMLMethod87
                        JavaSDM.ensure ( neighborCall88.hasInElements ("callee", uMLMethod87) ) ;
                         
                        // bind uMLMethod89: UMLMethod
                        fujaba__IterNeighborCall88ElementsUMLMethod89 = neighborCall88.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall88ElementsUMLMethod89.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall88ElementsUMLMethod89.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod89 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod87.equals (uMLMethod89)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod89.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (colleague);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (colleague);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall56 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind m1: UMLMethod
            fujaba__IterNeighborCall56ElementsM1 = neighborCall56.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall56ElementsM1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall56ElementsM1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  m1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = m1.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind uMLMethod90: UMLMethod
                  fujaba__IterMediatorMethodsUMLMethod90 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsUMLMethod90.hasNext () )
                  {
                     try
                     {
                        uMLMethod90 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod90.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(m1.equals (uMLMethod90)) ) ;
                         
                        // bind neighborCall91: NeighborCallAnnotation
                        fujaba__IterUMLMethod90AnnotationsNeighborCall91 = uMLMethod90.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod90AnnotationsNeighborCall91.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod90AnnotationsNeighborCall91.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall91 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall91 and uMLMethod90
                              JavaSDM.ensure ( neighborCall91.hasInElements ("callee", uMLMethod90) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(neighborCall56.equals (neighborCall91)) ) ;
                               
                              // bind uMLMethod92: UMLMethod
                              fujaba__IterNeighborCall91ElementsUMLMethod92 = neighborCall91.iteratorOfElements ("caller") ;
                              while ( fujaba__IterNeighborCall91ElementsUMLMethod92.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall91ElementsUMLMethod92.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod92 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(m1.equals (uMLMethod92)) && !(uMLMethod90.equals (uMLMethod92)) ) ;
                                     
                                    // bind colleague: UMLClass
                                    colleague = uMLMethod92.getParent () ;
                                    JavaSDM.ensure ( colleague != null ) ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (colleague);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall91 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod93: UMLMethod
            fujaba__IterNeighborCall91ElementsUMLMethod93 = neighborCall91.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall91ElementsUMLMethod93.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall91ElementsUMLMethod93.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod93 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = uMLMethod93.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind m2: UMLMethod
                  fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsM2.hasNext () )
                  {
                     try
                     {
                        m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod93.equals (m2)) ) ;
                         
                        // bind neighborCall94: NeighborCallAnnotation
                        fujaba__IterM2AnnotationsNeighborCall94 = m2.iteratorOfAnnotations () ;
                        while ( fujaba__IterM2AnnotationsNeighborCall94.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterM2AnnotationsNeighborCall94.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall94 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall94 and m2
                              JavaSDM.ensure ( neighborCall94.hasInElements ("caller", m2) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(neighborCall91.equals (neighborCall94)) ) ;
                               
                              // bind uMLMethod95: UMLMethod
                              fujaba__IterNeighborCall94ElementsUMLMethod95 = neighborCall94.iteratorOfElements ("callee") ;
                              while ( fujaba__IterNeighborCall94ElementsUMLMethod95.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall94ElementsUMLMethod95.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod95 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod93.equals (uMLMethod95)) && !(m2.equals (uMLMethod95)) ) ;
                                     
                                    // bind concreteColleague2: UMLClass
                                    concreteColleague2 = uMLMethod95.getParent () ;
                                    JavaSDM.ensure ( concreteColleague2 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) ) ;
                                     
                                    // bind generalization96: GeneralizationAnnotation
                                    fujaba__IterConcreteColleague2AnnotationsGeneralization96 = concreteColleague2.iteratorOfAnnotations () ;
                                    while ( fujaba__IterConcreteColleague2AnnotationsGeneralization96.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterConcreteColleague2AnnotationsGeneralization96.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization96 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization96 and concreteColleague2
                                          JavaSDM.ensure ( generalization96.hasInElements ("subClass", concreteColleague2) ) ;
                                           
                                          // bind colleague: UMLClass
                                          fujaba__IterGeneralization96ElementsColleague = generalization96.iteratorOfElements ("superClass") ;
                                          while ( fujaba__IterGeneralization96ElementsColleague.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization96ElementsColleague.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                colleague = (UMLClass) fujaba__TmpObject ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mediator.equals (colleague)) && !(concreteColleague2.equals (colleague)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   set.add (colleague);
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization96 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind colleague: UMLClass
            fujaba__IterGeneralization96ElementsColleague = generalization96.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization96ElementsColleague.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization96ElementsColleague.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  colleague = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (colleague);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall94 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod97: UMLMethod
            fujaba__IterNeighborCall94ElementsUMLMethod97 = neighborCall94.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall94ElementsUMLMethod97.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall94ElementsUMLMethod97.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod97 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind concreteColleague2: UMLClass
                  concreteColleague2 = uMLMethod97.getParent () ;
                  JavaSDM.ensure ( concreteColleague2 != null ) ;
                   
                  // bind generalization98: GeneralizationAnnotation
                  fujaba__IterConcreteColleague2AnnotationsGeneralization98 = concreteColleague2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteColleague2AnnotationsGeneralization98.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteColleague2AnnotationsGeneralization98.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization98 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization98 and concreteColleague2
                        JavaSDM.ensure ( generalization98.hasInElements ("subClass", concreteColleague2) ) ;
                         
                        // bind colleague: UMLClass
                        fujaba__IterGeneralization98ElementsColleague = generalization98.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization98ElementsColleague.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization98ElementsColleague.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              colleague = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteColleague2.equals (colleague)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (colleague);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") || annotation.equals ("Delegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod99: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod99 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod99.hasNext () )
            {
               try
               {
                  uMLMethod99 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod99.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod99);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod100: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod100 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod100.hasNext () )
            {
               try
               {
                  uMLMethod100 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod100.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod100);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall56 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind m1: UMLMethod
            fujaba__IterNeighborCall56ElementsM1 = neighborCall56.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall56ElementsM1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall56ElementsM1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  m1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = m1.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind uMLMethod101: UMLMethod
                  fujaba__IterMediatorMethodsUMLMethod101 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsUMLMethod101.hasNext () )
                  {
                     try
                     {
                        uMLMethod101 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod101.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(m1.equals (uMLMethod101)) ) ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod101);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization77 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteColleague1: UMLClass
            fujaba__IterGeneralization77ElementsConcreteColleague1 = generalization77.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization77ElementsConcreteColleague1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization77ElementsConcreteColleague1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod102: UMLMethod
                  fujaba__IterConcreteColleague1MethodsUMLMethod102 = concreteColleague1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteColleague1MethodsUMLMethod102.hasNext () )
                  {
                     try
                     {
                        uMLMethod102 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod102.next () ;
                         
                        // bind neighborCall103: NeighborCallAnnotation
                        fujaba__IterUMLMethod102AnnotationsNeighborCall103 = uMLMethod102.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod102AnnotationsNeighborCall103.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod102AnnotationsNeighborCall103.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall103 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall103 and uMLMethod102
                              JavaSDM.ensure ( neighborCall103.hasInElements ("callee", uMLMethod102) ) ;
                               
                              // bind m1: UMLMethod
                              fujaba__IterNeighborCall103ElementsM1 = neighborCall103.iteratorOfElements ("caller") ;
                              while ( fujaba__IterNeighborCall103ElementsM1.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall103ElementsM1.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    m1 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod102.equals (m1)) ) ;
                                     
                                    // bind mediator: UMLClass
                                    mediator = m1.getParent () ;
                                    JavaSDM.ensure ( mediator != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteColleague1.equals (mediator)) ) ;
                                     
                                    // bind uMLMethod104: UMLMethod
                                    fujaba__IterMediatorMethodsUMLMethod104 = mediator.iteratorOfMethods () ;
                                    while ( fujaba__IterMediatorMethodsUMLMethod104.hasNext () )
                                    {
                                       try
                                       {
                                          uMLMethod104 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod104.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod102.equals (uMLMethod104)) && !(m1.equals (uMLMethod104)) ) ;
                                           
                                          {
                                             //  for each flow
                                             set.add (uMLMethod104);
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization98 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind colleague: UMLClass
            fujaba__IterGeneralization98ElementsColleague = generalization98.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization98ElementsColleague.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization98ElementsColleague.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  colleague = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind uMLMethod105: UMLMethod
                  fujaba__IterColleagueMethodsUMLMethod105 = colleague.iteratorOfMethods () ;
                  while ( fujaba__IterColleagueMethodsUMLMethod105.hasNext () )
                  {
                     try
                     {
                        uMLMethod105 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod105.next () ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod105);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall94 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod106: UMLMethod
            fujaba__IterNeighborCall94ElementsUMLMethod106 = neighborCall94.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall94ElementsUMLMethod106.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall94ElementsUMLMethod106.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod106 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind concreteColleague2: UMLClass
                  concreteColleague2 = uMLMethod106.getParent () ;
                  JavaSDM.ensure ( concreteColleague2 != null ) ;
                   
                  // bind generalization107: GeneralizationAnnotation
                  fujaba__IterConcreteColleague2AnnotationsGeneralization107 = concreteColleague2.iteratorOfAnnotations () ;
                  while ( fujaba__IterConcreteColleague2AnnotationsGeneralization107.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterConcreteColleague2AnnotationsGeneralization107.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization107 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization107 and concreteColleague2
                        JavaSDM.ensure ( generalization107.hasInElements ("subClass", concreteColleague2) ) ;
                         
                        // bind colleague: UMLClass
                        fujaba__IterGeneralization107ElementsColleague = generalization107.iteratorOfElements ("superClass") ;
                        while ( fujaba__IterGeneralization107ElementsColleague.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization107ElementsColleague.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              colleague = (UMLClass) fujaba__TmpObject ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(concreteColleague2.equals (colleague)) ) ;
                               
                              // bind uMLMethod108: UMLMethod
                              fujaba__IterColleagueMethodsUMLMethod108 = colleague.iteratorOfMethods () ;
                              while ( fujaba__IterColleagueMethodsUMLMethod108.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod108 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod108.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod106.equals (uMLMethod108)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (uMLMethod108);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") || annotation.equals ("MultiLevelGeneralization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod109: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod109 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod109.hasNext () )
            {
               try
               {
                  uMLMethod109 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod109.next () ;
                   
                  // bind neighborCall110: NeighborCallAnnotation
                  fujaba__IterUMLMethod109AnnotationsNeighborCall110 = uMLMethod109.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod109AnnotationsNeighborCall110.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod109AnnotationsNeighborCall110.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall110 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall110 and uMLMethod109
                        JavaSDM.ensure ( neighborCall110.hasInElements ("callee", uMLMethod109) ) ;
                         
                        // bind uMLMethod111: UMLMethod
                        fujaba__IterNeighborCall110ElementsUMLMethod111 = neighborCall110.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall110ElementsUMLMethod111.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall110ElementsUMLMethod111.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod111 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod109.equals (uMLMethod111)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod111.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (colleague);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (colleague);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall103 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind m1: UMLMethod
            fujaba__IterNeighborCall103ElementsM1 = neighborCall103.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall103ElementsM1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall103ElementsM1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  m1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = m1.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind uMLMethod112: UMLMethod
                  fujaba__IterMediatorMethodsUMLMethod112 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsUMLMethod112.hasNext () )
                  {
                     try
                     {
                        uMLMethod112 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod112.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(m1.equals (uMLMethod112)) ) ;
                         
                        // bind neighborCall113: NeighborCallAnnotation
                        fujaba__IterUMLMethod112AnnotationsNeighborCall113 = uMLMethod112.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod112AnnotationsNeighborCall113.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod112AnnotationsNeighborCall113.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall113 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall113 and uMLMethod112
                              JavaSDM.ensure ( neighborCall113.hasInElements ("callee", uMLMethod112) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(neighborCall103.equals (neighborCall113)) ) ;
                               
                              // bind uMLMethod114: UMLMethod
                              fujaba__IterNeighborCall113ElementsUMLMethod114 = neighborCall113.iteratorOfElements ("caller") ;
                              while ( fujaba__IterNeighborCall113ElementsUMLMethod114.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall113ElementsUMLMethod114.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod114 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(m1.equals (uMLMethod114)) && !(uMLMethod112.equals (uMLMethod114)) ) ;
                                     
                                    // bind colleague: UMLClass
                                    colleague = uMLMethod114.getParent () ;
                                    JavaSDM.ensure ( colleague != null ) ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (colleague);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization77 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteColleague1: UMLClass
            fujaba__IterGeneralization77ElementsConcreteColleague1 = generalization77.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization77ElementsConcreteColleague1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization77ElementsConcreteColleague1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod115: UMLMethod
                  fujaba__IterConcreteColleague1MethodsUMLMethod115 = concreteColleague1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteColleague1MethodsUMLMethod115.hasNext () )
                  {
                     try
                     {
                        uMLMethod115 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod115.next () ;
                         
                        // bind neighborCall116: NeighborCallAnnotation
                        fujaba__IterUMLMethod115AnnotationsNeighborCall116 = uMLMethod115.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod115AnnotationsNeighborCall116.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod115AnnotationsNeighborCall116.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall116 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall116 and uMLMethod115
                              JavaSDM.ensure ( neighborCall116.hasInElements ("callee", uMLMethod115) ) ;
                               
                              // bind m1: UMLMethod
                              fujaba__IterNeighborCall116ElementsM1 = neighborCall116.iteratorOfElements ("caller") ;
                              while ( fujaba__IterNeighborCall116ElementsM1.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall116ElementsM1.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    m1 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod115.equals (m1)) ) ;
                                     
                                    // bind mediator: UMLClass
                                    mediator = m1.getParent () ;
                                    JavaSDM.ensure ( mediator != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteColleague1.equals (mediator)) ) ;
                                     
                                    // bind uMLMethod117: UMLMethod
                                    fujaba__IterMediatorMethodsUMLMethod117 = mediator.iteratorOfMethods () ;
                                    while ( fujaba__IterMediatorMethodsUMLMethod117.hasNext () )
                                    {
                                       try
                                       {
                                          uMLMethod117 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod117.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod115.equals (uMLMethod117)) && !(m1.equals (uMLMethod117)) ) ;
                                           
                                          // bind neighborCall118: NeighborCallAnnotation
                                          fujaba__IterUMLMethod117AnnotationsNeighborCall118 = uMLMethod117.iteratorOfAnnotations () ;
                                          while ( fujaba__IterUMLMethod117AnnotationsNeighborCall118.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLMethod117AnnotationsNeighborCall118.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall118 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall118 and uMLMethod117
                                                JavaSDM.ensure ( neighborCall118.hasInElements ("callee", uMLMethod117) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(neighborCall116.equals (neighborCall118)) ) ;
                                                 
                                                // bind uMLMethod119: UMLMethod
                                                fujaba__IterNeighborCall118ElementsUMLMethod119 = neighborCall118.iteratorOfElements ("caller") ;
                                                while ( fujaba__IterNeighborCall118ElementsUMLMethod119.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall118ElementsUMLMethod119.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod119 = (UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod115.equals (uMLMethod119)) && !(m1.equals (uMLMethod119)) && !(uMLMethod117.equals (uMLMethod119)) ) ;
                                                       
                                                      // bind colleague: UMLClass
                                                      colleague = uMLMethod119.getParent () ;
                                                      JavaSDM.ensure ( colleague != null ) ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(concreteColleague1.equals (colleague)) && !(mediator.equals (colleague)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         set.add (colleague);
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall118 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod120: UMLMethod
            fujaba__IterNeighborCall118ElementsUMLMethod120 = neighborCall118.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall118ElementsUMLMethod120.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall118ElementsUMLMethod120.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod120 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = uMLMethod120.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind m2: UMLMethod
                  fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsM2.hasNext () )
                  {
                     try
                     {
                        m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod120.equals (m2)) ) ;
                         
                        // bind neighborCall121: NeighborCallAnnotation
                        fujaba__IterM2AnnotationsNeighborCall121 = m2.iteratorOfAnnotations () ;
                        while ( fujaba__IterM2AnnotationsNeighborCall121.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterM2AnnotationsNeighborCall121.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall121 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall121 and m2
                              JavaSDM.ensure ( neighborCall121.hasInElements ("caller", m2) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(neighborCall118.equals (neighborCall121)) ) ;
                               
                              // bind uMLMethod122: UMLMethod
                              fujaba__IterNeighborCall121ElementsUMLMethod122 = neighborCall121.iteratorOfElements ("callee") ;
                              while ( fujaba__IterNeighborCall121ElementsUMLMethod122.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall121ElementsUMLMethod122.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod122 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod120.equals (uMLMethod122)) && !(m2.equals (uMLMethod122)) ) ;
                                     
                                    // bind concreteColleague2: UMLClass
                                    concreteColleague2 = uMLMethod122.getParent () ;
                                    JavaSDM.ensure ( concreteColleague2 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (concreteColleague2);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall121 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod123: UMLMethod
            fujaba__IterNeighborCall121ElementsUMLMethod123 = neighborCall121.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall121ElementsUMLMethod123.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall121ElementsUMLMethod123.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod123 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind concreteColleague2: UMLClass
                  concreteColleague2 = uMLMethod123.getParent () ;
                  JavaSDM.ensure ( concreteColleague2 != null ) ;
                   
                  {
                     //  for each flow
                     set.add (concreteColleague2);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") || annotation.equals ("Delegation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod124: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod124 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod124.hasNext () )
            {
               try
               {
                  uMLMethod124 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod124.next () ;
                   
                  // bind neighborCall125: NeighborCallAnnotation
                  fujaba__IterUMLMethod124AnnotationsNeighborCall125 = uMLMethod124.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod124AnnotationsNeighborCall125.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod124AnnotationsNeighborCall125.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall125 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall125 and uMLMethod124
                        JavaSDM.ensure ( neighborCall125.hasInElements ("callee", uMLMethod124) ) ;
                         
                        // bind uMLMethod126: UMLMethod
                        fujaba__IterNeighborCall125ElementsUMLMethod126 = neighborCall125.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall125ElementsUMLMethod126.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall125ElementsUMLMethod126.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod126 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod124.equals (uMLMethod126)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod126.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              // bind generalization127: GeneralizationAnnotation
                              fujaba__IterColleagueAnnotationsGeneralization127 = colleague.iteratorOfAnnotations () ;
                              while ( fujaba__IterColleagueAnnotationsGeneralization127.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization127.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization127 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization127 and colleague
                                    JavaSDM.ensure ( generalization127.hasInElements ("superClass", colleague) ) ;
                                     
                                    // bind concreteColleague2: UMLClass
                                    fujaba__IterGeneralization127ElementsConcreteColleague2 = generalization127.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization127ElementsConcreteColleague2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization127ElementsConcreteColleague2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          concreteColleague2 = (UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                           
                                          // bind uMLMethod128: UMLMethod
                                          fujaba__IterConcreteColleague2MethodsUMLMethod128 = concreteColleague2.iteratorOfMethods () ;
                                          while ( fujaba__IterConcreteColleague2MethodsUMLMethod128.hasNext () )
                                          {
                                             try
                                             {
                                                uMLMethod128 = (UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod128.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod124.equals (uMLMethod128)) && !(uMLMethod126.equals (uMLMethod128)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   set.add (uMLMethod128);
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod129: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod129 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod129.hasNext () )
            {
               try
               {
                  uMLMethod129 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod129.next () ;
                   
                  // bind neighborCall130: NeighborCallAnnotation
                  fujaba__IterUMLMethod129AnnotationsNeighborCall130 = uMLMethod129.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod129AnnotationsNeighborCall130.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod129AnnotationsNeighborCall130.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall130 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall130 and uMLMethod129
                        JavaSDM.ensure ( neighborCall130.hasInElements ("caller", uMLMethod129) ) ;
                         
                        // bind uMLMethod131: UMLMethod
                        fujaba__IterNeighborCall130ElementsUMLMethod131 = neighborCall130.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall130ElementsUMLMethod131.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall130ElementsUMLMethod131.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod131 = (UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod129.equals (uMLMethod131)) ) ;
                               
                              // bind mediator: UMLClass
                              mediator = uMLMethod131.getParent () ;
                              JavaSDM.ensure ( mediator != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                               
                              // bind m2: UMLMethod
                              fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                              while ( fujaba__IterMediatorMethodsM2.hasNext () )
                              {
                                 try
                                 {
                                    m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod129.equals (m2)) && !(uMLMethod131.equals (m2)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (m2);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall116 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind m1: UMLMethod
            fujaba__IterNeighborCall116ElementsM1 = neighborCall116.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall116ElementsM1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall116ElementsM1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  m1 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = m1.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind uMLMethod132: UMLMethod
                  fujaba__IterMediatorMethodsUMLMethod132 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsUMLMethod132.hasNext () )
                  {
                     try
                     {
                        uMLMethod132 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod132.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(m1.equals (uMLMethod132)) ) ;
                         
                        // bind neighborCall133: NeighborCallAnnotation
                        fujaba__IterUMLMethod132AnnotationsNeighborCall133 = uMLMethod132.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod132AnnotationsNeighborCall133.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod132AnnotationsNeighborCall133.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall133 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall133 and uMLMethod132
                              JavaSDM.ensure ( neighborCall133.hasInElements ("callee", uMLMethod132) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(neighborCall116.equals (neighborCall133)) ) ;
                               
                              // bind uMLMethod134: UMLMethod
                              fujaba__IterNeighborCall133ElementsUMLMethod134 = neighborCall133.iteratorOfElements ("caller") ;
                              while ( fujaba__IterNeighborCall133ElementsUMLMethod134.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall133ElementsUMLMethod134.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod134 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(m1.equals (uMLMethod134)) && !(uMLMethod132.equals (uMLMethod134)) ) ;
                                     
                                    // bind colleague: UMLClass
                                    colleague = uMLMethod134.getParent () ;
                                    JavaSDM.ensure ( colleague != null ) ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                     
                                    // bind generalization135: GeneralizationAnnotation
                                    fujaba__IterColleagueAnnotationsGeneralization135 = colleague.iteratorOfAnnotations () ;
                                    while ( fujaba__IterColleagueAnnotationsGeneralization135.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization135.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                          generalization135 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between generalization135 and colleague
                                          JavaSDM.ensure ( generalization135.hasInElements ("superClass", colleague) ) ;
                                           
                                          // bind concreteColleague2: UMLClass
                                          fujaba__IterGeneralization135ElementsConcreteColleague2 = generalization135.iteratorOfElements ("subClass") ;
                                          while ( fujaba__IterGeneralization135ElementsConcreteColleague2.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization135ElementsConcreteColleague2.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                concreteColleague2 = (UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                                 
                                                // bind uMLMethod136: UMLMethod
                                                fujaba__IterConcreteColleague2MethodsUMLMethod136 = concreteColleague2.iteratorOfMethods () ;
                                                while ( fujaba__IterConcreteColleague2MethodsUMLMethod136.hasNext () )
                                                {
                                                   try
                                                   {
                                                      uMLMethod136 = (UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod136.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(m1.equals (uMLMethod136)) && !(uMLMethod132.equals (uMLMethod136)) && !(uMLMethod134.equals (uMLMethod136)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         set.add (uMLMethod136);
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization77 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind concreteColleague1: UMLClass
            fujaba__IterGeneralization77ElementsConcreteColleague1 = generalization77.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization77ElementsConcreteColleague1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization77ElementsConcreteColleague1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  concreteColleague1 = (UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod137: UMLMethod
                  fujaba__IterConcreteColleague1MethodsUMLMethod137 = concreteColleague1.iteratorOfMethods () ;
                  while ( fujaba__IterConcreteColleague1MethodsUMLMethod137.hasNext () )
                  {
                     try
                     {
                        uMLMethod137 = (UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod137.next () ;
                         
                        // bind neighborCall138: NeighborCallAnnotation
                        fujaba__IterUMLMethod137AnnotationsNeighborCall138 = uMLMethod137.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod137AnnotationsNeighborCall138.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod137AnnotationsNeighborCall138.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall138 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall138 and uMLMethod137
                              JavaSDM.ensure ( neighborCall138.hasInElements ("callee", uMLMethod137) ) ;
                               
                              // bind m1: UMLMethod
                              fujaba__IterNeighborCall138ElementsM1 = neighborCall138.iteratorOfElements ("caller") ;
                              while ( fujaba__IterNeighborCall138ElementsM1.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall138ElementsM1.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    m1 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod137.equals (m1)) ) ;
                                     
                                    // bind mediator: UMLClass
                                    mediator = m1.getParent () ;
                                    JavaSDM.ensure ( mediator != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(concreteColleague1.equals (mediator)) ) ;
                                     
                                    // bind uMLMethod139: UMLMethod
                                    fujaba__IterMediatorMethodsUMLMethod139 = mediator.iteratorOfMethods () ;
                                    while ( fujaba__IterMediatorMethodsUMLMethod139.hasNext () )
                                    {
                                       try
                                       {
                                          uMLMethod139 = (UMLMethod) fujaba__IterMediatorMethodsUMLMethod139.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod137.equals (uMLMethod139)) && !(m1.equals (uMLMethod139)) ) ;
                                           
                                          // bind neighborCall140: NeighborCallAnnotation
                                          fujaba__IterUMLMethod139AnnotationsNeighborCall140 = uMLMethod139.iteratorOfAnnotations () ;
                                          while ( fujaba__IterUMLMethod139AnnotationsNeighborCall140.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLMethod139AnnotationsNeighborCall140.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall140 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall140 and uMLMethod139
                                                JavaSDM.ensure ( neighborCall140.hasInElements ("callee", uMLMethod139) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(neighborCall138.equals (neighborCall140)) ) ;
                                                 
                                                // bind uMLMethod141: UMLMethod
                                                fujaba__IterNeighborCall140ElementsUMLMethod141 = neighborCall140.iteratorOfElements ("caller") ;
                                                while ( fujaba__IterNeighborCall140ElementsUMLMethod141.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall140ElementsUMLMethod141.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod141 = (UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod137.equals (uMLMethod141)) && !(m1.equals (uMLMethod141)) && !(uMLMethod139.equals (uMLMethod141)) ) ;
                                                       
                                                      // bind colleague: UMLClass
                                                      colleague = uMLMethod141.getParent () ;
                                                      JavaSDM.ensure ( colleague != null ) ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(concreteColleague1.equals (colleague)) && !(mediator.equals (colleague)) ) ;
                                                       
                                                      // bind generalization142: GeneralizationAnnotation
                                                      fujaba__IterColleagueAnnotationsGeneralization142 = colleague.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterColleagueAnnotationsGeneralization142.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization142.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                            generalization142 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between generalization142 and colleague
                                                            JavaSDM.ensure ( generalization142.hasInElements ("superClass", colleague) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(generalization77.equals (generalization142)) ) ;
                                                             
                                                            // bind concreteColleague2: UMLClass
                                                            fujaba__IterGeneralization142ElementsConcreteColleague2 = generalization142.iteratorOfElements ("subClass") ;
                                                            while ( fujaba__IterGeneralization142ElementsConcreteColleague2.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterGeneralization142ElementsConcreteColleague2.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                  concreteColleague2 = (UMLClass) fujaba__TmpObject ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(concreteColleague1.equals (concreteColleague2)) && !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                                                   
                                                                  // bind uMLMethod143: UMLMethod
                                                                  fujaba__IterConcreteColleague2MethodsUMLMethod143 = concreteColleague2.iteratorOfMethods () ;
                                                                  while ( fujaba__IterConcreteColleague2MethodsUMLMethod143.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        uMLMethod143 = (UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod143.next () ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(uMLMethod137.equals (uMLMethod143)) && !(m1.equals (uMLMethod143)) && !(uMLMethod139.equals (uMLMethod143)) && !(uMLMethod141.equals (uMLMethod143)) ) ;
                                                                         
                                                                        {
                                                                           //  for each flow
                                                                           set.add (uMLMethod143);
                                                                        } //  end for each flow
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall140 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod144: UMLMethod
            fujaba__IterNeighborCall140ElementsUMLMethod144 = neighborCall140.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall140ElementsUMLMethod144.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall140ElementsUMLMethod144.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod144 = (UMLMethod) fujaba__TmpObject ;
                   
                  // bind mediator: UMLClass
                  mediator = uMLMethod144.getParent () ;
                  JavaSDM.ensure ( mediator != null ) ;
                   
                  // bind m2: UMLMethod
                  fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsM2.hasNext () )
                  {
                     try
                     {
                        m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod144.equals (m2)) ) ;
                         
                        {
                           //  for each flow
                           set.add (m2);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization142 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind colleague: UMLClass
            fujaba__IterGeneralization142ElementsColleague = generalization142.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization142ElementsColleague.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization142ElementsColleague.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  colleague = (UMLClass) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind uMLMethod145: UMLMethod
                  fujaba__IterColleagueMethodsUMLMethod145 = colleague.iteratorOfMethods () ;
                  while ( fujaba__IterColleagueMethodsUMLMethod145.hasNext () )
                  {
                     try
                     {
                        uMLMethod145 = (UMLMethod) fujaba__IterColleagueMethodsUMLMethod145.next () ;
                         
                        // bind neighborCall146: NeighborCallAnnotation
                        fujaba__IterUMLMethod145AnnotationsNeighborCall146 = uMLMethod145.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod145AnnotationsNeighborCall146.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod145AnnotationsNeighborCall146.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall146 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall146 and uMLMethod145
                              JavaSDM.ensure ( neighborCall146.hasInElements ("caller", uMLMethod145) ) ;
                               
                              // bind uMLMethod147: UMLMethod
                              fujaba__IterNeighborCall146ElementsUMLMethod147 = neighborCall146.iteratorOfElements ("callee") ;
                              while ( fujaba__IterNeighborCall146ElementsUMLMethod147.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterNeighborCall146ElementsUMLMethod147.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod147 = (UMLMethod) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod145.equals (uMLMethod147)) ) ;
                                     
                                    // bind mediator: UMLClass
                                    mediator = uMLMethod147.getParent () ;
                                    JavaSDM.ensure ( mediator != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                                     
                                    // bind m2: UMLMethod
                                    fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                                    while ( fujaba__IterMediatorMethodsM2.hasNext () )
                                    {
                                       try
                                       {
                                          m2 = (UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod145.equals (m2)) && !(uMLMethod147.equals (m2)) ) ;
                                           
                                          {
                                             //  for each flow
                                             set.add (m2);
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
